--megafunction wizard: %Altera SOPC Builder%
--GENERATION: STANDARD
--VERSION: WM1.0


--Legal Notice: (C)2005 Altera Corporation. All rights reserved.  Your
--use of Altera Corporation's design tools, logic functions and other
--software and tools, and its AMPP partner logic functions, and any
--output files any of the foregoing (including device programming or
--simulation files), and any associated documentation or information are
--expressly subject to the terms and conditions of the Altera Program
--License Subscription Agreement or other applicable license agreement,
--including, without limitation, that your use is for the sole purpose
--of programming logic devices manufactured by Altera and sold by Altera
--or its authorized distributors.  Please refer to the applicable
--agreement for further details.

library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity buttons_s1_arbitrator is 
        port (
              -- inputs:
                 signal buttons_s1_irq : IN STD_LOGIC;
                 signal buttons_s1_readdata : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal buttons_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal buttons_s1_chipselect : OUT STD_LOGIC;
                 signal buttons_s1_irq_from_sa : OUT STD_LOGIC;
                 signal buttons_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal buttons_s1_reset_n : OUT STD_LOGIC;
                 signal buttons_s1_write_n : OUT STD_LOGIC;
                 signal buttons_s1_writedata : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_granted_buttons_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_buttons_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_buttons_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_buttons_s1 : OUT STD_LOGIC;
                 signal d1_buttons_s1_end_xfer : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of buttons_s1_arbitrator : entity is FALSE;
end entity buttons_s1_arbitrator;


architecture europa of buttons_s1_arbitrator is
                signal buttons_s1_allgrants :  STD_LOGIC;
                signal buttons_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal buttons_s1_any_continuerequest :  STD_LOGIC;
                signal buttons_s1_arb_counter_enable :  STD_LOGIC;
                signal buttons_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal buttons_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal buttons_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal buttons_s1_arbitration_holdoff_internal :  STD_LOGIC;
                signal buttons_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal buttons_s1_begins_xfer :  STD_LOGIC;
                signal buttons_s1_end_xfer :  STD_LOGIC;
                signal buttons_s1_firsttransfer :  STD_LOGIC;
                signal buttons_s1_grant_vector :  STD_LOGIC;
                signal buttons_s1_in_a_read_cycle :  STD_LOGIC;
                signal buttons_s1_in_a_write_cycle :  STD_LOGIC;
                signal buttons_s1_master_qreq_vector :  STD_LOGIC;
                signal buttons_s1_slavearbiterlockenable :  STD_LOGIC;
                signal buttons_s1_waits_for_read :  STD_LOGIC;
                signal buttons_s1_waits_for_write :  STD_LOGIC;
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_buttons_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_buttons_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_buttons_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_buttons_s1 :  STD_LOGIC;
                signal wait_for_buttons_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT buttons_s1_end_xfer;
      end if;
    end if;

  end process;

  buttons_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_buttons_s1);
  --assign buttons_s1_readdata_from_sa = buttons_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  buttons_s1_readdata_from_sa <= buttons_s1_readdata;
  internal_cpu_data_master_requests_buttons_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("001000100000000000010000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --buttons_s1_arb_share_counter set values, which is an e_mux
  buttons_s1_arb_share_set_values <= std_logic_vector'("001");
  --buttons_s1_arb_share_counter_next_value assignment, which is an e_assign
  buttons_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(buttons_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (buttons_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(buttons_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (buttons_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --buttons_s1_allgrants all slave grants, which is an e_mux
  buttons_s1_allgrants <= buttons_s1_grant_vector;
  --buttons_s1_end_xfer assignment, which is an e_assign
  buttons_s1_end_xfer <= NOT ((buttons_s1_waits_for_read OR buttons_s1_waits_for_write));
  --buttons_s1_arb_share_counter arbitration counter enable, which is an e_assign
  buttons_s1_arb_counter_enable <= buttons_s1_end_xfer AND buttons_s1_allgrants;
  --buttons_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      buttons_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(buttons_s1_arb_counter_enable) = '1' then 
        buttons_s1_arb_share_counter <= buttons_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --buttons_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      buttons_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((buttons_s1_master_qreq_vector AND buttons_s1_end_xfer)) = '1' then 
        buttons_s1_slavearbiterlockenable <= or_reduce(buttons_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master buttons/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= buttons_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --buttons_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  buttons_s1_any_continuerequest <= std_logic'('0');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('0');
  internal_cpu_data_master_qualified_request_buttons_s1 <= internal_cpu_data_master_requests_buttons_s1 AND NOT (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write));
  --buttons_s1_writedata mux, which is an e_mux
  buttons_s1_writedata <= cpu_data_master_writedata (3 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_buttons_s1 <= internal_cpu_data_master_qualified_request_buttons_s1;
  --cpu/data_master saved-grant buttons/s1, which is an e_assign
  cpu_data_master_saved_grant_buttons_s1 <= internal_cpu_data_master_requests_buttons_s1;
  --allow new arb cycle for buttons/s1, which is an e_assign
  buttons_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  buttons_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  buttons_s1_master_qreq_vector <= std_logic'('1');
  --buttons_s1_reset_n assignment, which is an e_assign
  buttons_s1_reset_n <= reset_n;
  buttons_s1_chipselect <= internal_cpu_data_master_granted_buttons_s1;
  --buttons_s1_firsttransfer first transaction, which is an e_assign
  buttons_s1_firsttransfer <= NOT ((buttons_s1_slavearbiterlockenable AND buttons_s1_any_continuerequest));
  --buttons_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  buttons_s1_beginbursttransfer_internal <= buttons_s1_begins_xfer AND buttons_s1_firsttransfer;
  --buttons_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  buttons_s1_arbitration_holdoff_internal <= buttons_s1_begins_xfer AND buttons_s1_firsttransfer;
  --~buttons_s1_write_n assignment, which is an e_mux
  buttons_s1_write_n <= NOT ((internal_cpu_data_master_granted_buttons_s1 AND cpu_data_master_write));
  --buttons_s1_address mux, which is an e_mux
  buttons_s1_address <= A_EXT (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_buttons_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_buttons_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_buttons_s1_end_xfer <= buttons_s1_end_xfer;
      end if;
    end if;

  end process;

  --buttons_s1_waits_for_read in a cycle, which is an e_mux
  buttons_s1_waits_for_read <= buttons_s1_in_a_read_cycle AND buttons_s1_begins_xfer;
  --buttons_s1_in_a_read_cycle assignment, which is an e_assign
  buttons_s1_in_a_read_cycle <= internal_cpu_data_master_granted_buttons_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= buttons_s1_in_a_read_cycle;
  --buttons_s1_waits_for_write in a cycle, which is an e_mux
  buttons_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(buttons_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --buttons_s1_in_a_write_cycle assignment, which is an e_assign
  buttons_s1_in_a_write_cycle <= internal_cpu_data_master_granted_buttons_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= buttons_s1_in_a_write_cycle;
  wait_for_buttons_s1_counter <= std_logic'('0');
  --assign buttons_s1_irq_from_sa = buttons_s1_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  buttons_s1_irq_from_sa <= buttons_s1_irq;
  --vhdl renameroo for output signals
  cpu_data_master_granted_buttons_s1 <= internal_cpu_data_master_granted_buttons_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_buttons_s1 <= internal_cpu_data_master_qualified_request_buttons_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_buttons_s1 <= internal_cpu_data_master_requests_buttons_s1;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity cpu_jtag_debug_module_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_debugaccess : IN STD_LOGIC;
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_sdram_s1_shift_register : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal cpu_jtag_debug_module_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_jtag_debug_module_resetrequest : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_data_master_requests_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_instruction_master_granted_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_instruction_master_requests_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_address : OUT STD_LOGIC_VECTOR (8 DOWNTO 0);
                 signal cpu_jtag_debug_module_begintransfer : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_jtag_debug_module_chipselect : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_debugaccess : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_jtag_debug_module_reset : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_reset_n : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_resetrequest_from_sa : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_write : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal d1_cpu_jtag_debug_module_end_xfer : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of cpu_jtag_debug_module_arbitrator : entity is FALSE;
end entity cpu_jtag_debug_module_arbitrator;


architecture europa of cpu_jtag_debug_module_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_instruction_master_arbiterlock :  STD_LOGIC;
                signal cpu_instruction_master_continuerequest :  STD_LOGIC;
                signal cpu_instruction_master_saved_grant_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_jtag_debug_module_allgrants :  STD_LOGIC;
                signal cpu_jtag_debug_module_allow_new_arb_cycle :  STD_LOGIC;
                signal cpu_jtag_debug_module_any_continuerequest :  STD_LOGIC;
                signal cpu_jtag_debug_module_arb_addend :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_arb_counter_enable :  STD_LOGIC;
                signal cpu_jtag_debug_module_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal cpu_jtag_debug_module_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal cpu_jtag_debug_module_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal cpu_jtag_debug_module_arb_winner :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_arbitration_holdoff_internal :  STD_LOGIC;
                signal cpu_jtag_debug_module_beginbursttransfer_internal :  STD_LOGIC;
                signal cpu_jtag_debug_module_begins_xfer :  STD_LOGIC;
                signal cpu_jtag_debug_module_chosen_master_double_vector :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal cpu_jtag_debug_module_chosen_master_rot_left :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_end_xfer :  STD_LOGIC;
                signal cpu_jtag_debug_module_firsttransfer :  STD_LOGIC;
                signal cpu_jtag_debug_module_grant_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_in_a_read_cycle :  STD_LOGIC;
                signal cpu_jtag_debug_module_in_a_write_cycle :  STD_LOGIC;
                signal cpu_jtag_debug_module_master_qreq_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_saved_chosen_master_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_slavearbiterlockenable :  STD_LOGIC;
                signal cpu_jtag_debug_module_waits_for_read :  STD_LOGIC;
                signal cpu_jtag_debug_module_waits_for_write :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_data_master_requests_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_instruction_master_granted_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_instruction_master_qualified_request_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_instruction_master_requests_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_jtag_debug_module_reset_n :  STD_LOGIC;
                signal last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module :  STD_LOGIC;
                signal last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module :  STD_LOGIC;
                signal wait_for_cpu_jtag_debug_module_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT cpu_jtag_debug_module_end_xfer;
      end if;
    end if;

  end process;

  cpu_jtag_debug_module_begins_xfer <= NOT d1_reasons_to_wait AND ((internal_cpu_data_master_qualified_request_cpu_jtag_debug_module OR internal_cpu_instruction_master_qualified_request_cpu_jtag_debug_module));
  --assign cpu_jtag_debug_module_readdata_from_sa = cpu_jtag_debug_module_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  cpu_jtag_debug_module_readdata_from_sa <= cpu_jtag_debug_module_readdata;
  internal_cpu_data_master_requests_cpu_jtag_debug_module <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 11) & std_logic_vector'("00000000000")) = std_logic_vector'("001000100000100000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --cpu_jtag_debug_module_arb_share_counter set values, which is an e_mux
  cpu_jtag_debug_module_arb_share_set_values <= std_logic_vector'("001");
  --cpu_jtag_debug_module_arb_share_counter_next_value assignment, which is an e_assign
  cpu_jtag_debug_module_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(cpu_jtag_debug_module_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (cpu_jtag_debug_module_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(cpu_jtag_debug_module_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (cpu_jtag_debug_module_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --cpu_jtag_debug_module_allgrants all slave grants, which is an e_mux
  cpu_jtag_debug_module_allgrants <= ((or_reduce(cpu_jtag_debug_module_grant_vector) OR or_reduce(cpu_jtag_debug_module_grant_vector)) OR or_reduce(cpu_jtag_debug_module_grant_vector)) OR or_reduce(cpu_jtag_debug_module_grant_vector);
  --cpu_jtag_debug_module_end_xfer assignment, which is an e_assign
  cpu_jtag_debug_module_end_xfer <= NOT ((cpu_jtag_debug_module_waits_for_read OR cpu_jtag_debug_module_waits_for_write));
  --cpu_jtag_debug_module_arb_share_counter arbitration counter enable, which is an e_assign
  cpu_jtag_debug_module_arb_counter_enable <= cpu_jtag_debug_module_end_xfer AND cpu_jtag_debug_module_allgrants;
  --cpu_jtag_debug_module_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_jtag_debug_module_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(cpu_jtag_debug_module_arb_counter_enable) = '1' then 
        cpu_jtag_debug_module_arb_share_counter <= cpu_jtag_debug_module_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_jtag_debug_module_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_jtag_debug_module_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((or_reduce(cpu_jtag_debug_module_master_qreq_vector) AND cpu_jtag_debug_module_end_xfer)) = '1' then 
        cpu_jtag_debug_module_slavearbiterlockenable <= or_reduce(cpu_jtag_debug_module_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master cpu/jtag_debug_module arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= cpu_jtag_debug_module_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --cpu/instruction_master cpu/jtag_debug_module arbiterlock, which is an e_assign
  cpu_instruction_master_arbiterlock <= cpu_jtag_debug_module_slavearbiterlockenable AND cpu_instruction_master_continuerequest;
  --cpu/instruction_master granted cpu/jtag_debug_module last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_instruction_master_saved_grant_cpu_jtag_debug_module) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((cpu_jtag_debug_module_arbitration_holdoff_internal OR NOT internal_cpu_instruction_master_requests_cpu_jtag_debug_module))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module))))));
      end if;
    end if;

  end process;

  --cpu_instruction_master_continuerequest continued request, which is an e_mux
  cpu_instruction_master_continuerequest <= last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module AND internal_cpu_instruction_master_requests_cpu_jtag_debug_module;
  --cpu_jtag_debug_module_any_continuerequest at least one master continues requesting, which is an e_mux
  cpu_jtag_debug_module_any_continuerequest <= cpu_instruction_master_continuerequest OR cpu_data_master_continuerequest;
  internal_cpu_data_master_qualified_request_cpu_jtag_debug_module <= internal_cpu_data_master_requests_cpu_jtag_debug_module AND NOT (cpu_instruction_master_arbiterlock);
  --cpu_jtag_debug_module_writedata mux, which is an e_mux
  cpu_jtag_debug_module_writedata <= cpu_data_master_writedata;
  --mux cpu_jtag_debug_module_debugaccess, which is an e_mux
  cpu_jtag_debug_module_debugaccess <= cpu_data_master_debugaccess;
  internal_cpu_instruction_master_requests_cpu_jtag_debug_module <= ((to_std_logic(((Std_Logic_Vector'(cpu_instruction_master_address_to_slave(23 DOWNTO 11) & std_logic_vector'("00000000000")) = std_logic_vector'("001000100000100000000000")))) AND (cpu_instruction_master_read))) AND cpu_instruction_master_read;
  --cpu/data_master granted cpu/jtag_debug_module last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_data_master_saved_grant_cpu_jtag_debug_module) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((cpu_jtag_debug_module_arbitration_holdoff_internal OR NOT internal_cpu_data_master_requests_cpu_jtag_debug_module))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module))))));
      end if;
    end if;

  end process;

  --cpu_data_master_continuerequest continued request, which is an e_mux
  cpu_data_master_continuerequest <= last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module AND internal_cpu_data_master_requests_cpu_jtag_debug_module;
  internal_cpu_instruction_master_qualified_request_cpu_jtag_debug_module <= internal_cpu_instruction_master_requests_cpu_jtag_debug_module AND NOT ((((cpu_instruction_master_read AND ((to_std_logic((((std_logic_vector'("000000000000000000000000000000") & (cpu_instruction_master_latency_counter)) /= std_logic_vector'("00000000000000000000000000000000")))) OR (or_reduce(cpu_instruction_master_read_data_valid_sdram_s1_shift_register)))))) OR cpu_data_master_arbiterlock));
  --local readdatavalid cpu_instruction_master_read_data_valid_cpu_jtag_debug_module, which is an e_mux
  cpu_instruction_master_read_data_valid_cpu_jtag_debug_module <= (internal_cpu_instruction_master_granted_cpu_jtag_debug_module AND cpu_instruction_master_read) AND NOT cpu_jtag_debug_module_waits_for_read;
  --allow new arb cycle for cpu/jtag_debug_module, which is an e_assign
  cpu_jtag_debug_module_allow_new_arb_cycle <= NOT cpu_data_master_arbiterlock AND NOT cpu_instruction_master_arbiterlock;
  --cpu/instruction_master assignment into master qualified-requests vector for cpu/jtag_debug_module, which is an e_assign
  cpu_jtag_debug_module_master_qreq_vector(0) <= internal_cpu_instruction_master_qualified_request_cpu_jtag_debug_module;
  --cpu/instruction_master grant cpu/jtag_debug_module, which is an e_assign
  internal_cpu_instruction_master_granted_cpu_jtag_debug_module <= cpu_jtag_debug_module_grant_vector(0);
  --cpu/instruction_master saved-grant cpu/jtag_debug_module, which is an e_assign
  cpu_instruction_master_saved_grant_cpu_jtag_debug_module <= cpu_jtag_debug_module_arb_winner(0) AND internal_cpu_instruction_master_requests_cpu_jtag_debug_module;
  --cpu/data_master assignment into master qualified-requests vector for cpu/jtag_debug_module, which is an e_assign
  cpu_jtag_debug_module_master_qreq_vector(1) <= internal_cpu_data_master_qualified_request_cpu_jtag_debug_module;
  --cpu/data_master grant cpu/jtag_debug_module, which is an e_assign
  internal_cpu_data_master_granted_cpu_jtag_debug_module <= cpu_jtag_debug_module_grant_vector(1);
  --cpu/data_master saved-grant cpu/jtag_debug_module, which is an e_assign
  cpu_data_master_saved_grant_cpu_jtag_debug_module <= cpu_jtag_debug_module_arb_winner(1) AND internal_cpu_data_master_requests_cpu_jtag_debug_module;
  --cpu/jtag_debug_module chosen-master double-vector, which is an e_assign
  cpu_jtag_debug_module_chosen_master_double_vector <= A_EXT (((std_logic_vector'("0") & ((cpu_jtag_debug_module_master_qreq_vector & cpu_jtag_debug_module_master_qreq_vector))) AND (((std_logic_vector'("0") & (Std_Logic_Vector'(NOT cpu_jtag_debug_module_master_qreq_vector & NOT cpu_jtag_debug_module_master_qreq_vector))) + (std_logic_vector'("000") & (cpu_jtag_debug_module_arb_addend))))), 4);
  --stable onehot encoding of arb winner
  cpu_jtag_debug_module_arb_winner <= A_WE_StdLogicVector((std_logic'(((cpu_jtag_debug_module_allow_new_arb_cycle AND or_reduce(cpu_jtag_debug_module_grant_vector)))) = '1'), cpu_jtag_debug_module_grant_vector, cpu_jtag_debug_module_saved_chosen_master_vector);
  --saved cpu_jtag_debug_module_grant_vector, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_jtag_debug_module_saved_chosen_master_vector <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(cpu_jtag_debug_module_allow_new_arb_cycle) = '1' then 
        cpu_jtag_debug_module_saved_chosen_master_vector <= A_WE_StdLogicVector((std_logic'(or_reduce(cpu_jtag_debug_module_grant_vector)) = '1'), cpu_jtag_debug_module_grant_vector, cpu_jtag_debug_module_saved_chosen_master_vector);
      end if;
    end if;

  end process;

  --onehot encoding of chosen master
  cpu_jtag_debug_module_grant_vector <= Std_Logic_Vector'(A_ToStdLogicVector(((cpu_jtag_debug_module_chosen_master_double_vector(1) OR cpu_jtag_debug_module_chosen_master_double_vector(3)))) & A_ToStdLogicVector(((cpu_jtag_debug_module_chosen_master_double_vector(0) OR cpu_jtag_debug_module_chosen_master_double_vector(2)))));
  --cpu/jtag_debug_module chosen master rotated left, which is an e_assign
  cpu_jtag_debug_module_chosen_master_rot_left <= A_EXT (A_WE_StdLogicVector((((A_SLL(cpu_jtag_debug_module_arb_winner,std_logic_vector'("00000000000000000000000000000001")))) /= std_logic_vector'("00")), (std_logic_vector'("000000000000000000000000000000") & ((A_SLL(cpu_jtag_debug_module_arb_winner,std_logic_vector'("00000000000000000000000000000001"))))), std_logic_vector'("00000000000000000000000000000001")), 2);
  --cpu/jtag_debug_module's addend for next-master-grant
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_jtag_debug_module_arb_addend <= std_logic_vector'("01");
    elsif clk'event and clk = '1' then
      if std_logic'(or_reduce(cpu_jtag_debug_module_grant_vector)) = '1' then 
        cpu_jtag_debug_module_arb_addend <= A_WE_StdLogicVector((std_logic'(cpu_jtag_debug_module_end_xfer) = '1'), cpu_jtag_debug_module_chosen_master_rot_left, cpu_jtag_debug_module_grant_vector);
      end if;
    end if;

  end process;

  cpu_jtag_debug_module_begintransfer <= cpu_jtag_debug_module_begins_xfer;
  --assign lhs ~cpu_jtag_debug_module_reset of type reset_n to cpu_jtag_debug_module_reset_n, which is an e_assign
  cpu_jtag_debug_module_reset <= NOT internal_cpu_jtag_debug_module_reset_n;
  --cpu_jtag_debug_module_reset_n assignment, which is an e_assign
  internal_cpu_jtag_debug_module_reset_n <= reset_n;
  --assign cpu_jtag_debug_module_resetrequest_from_sa = cpu_jtag_debug_module_resetrequest so that symbol knows where to group signals which may go to master only, which is an e_assign
  cpu_jtag_debug_module_resetrequest_from_sa <= cpu_jtag_debug_module_resetrequest;
  cpu_jtag_debug_module_chipselect <= internal_cpu_data_master_granted_cpu_jtag_debug_module OR internal_cpu_instruction_master_granted_cpu_jtag_debug_module;
  --cpu_jtag_debug_module_firsttransfer first transaction, which is an e_assign
  cpu_jtag_debug_module_firsttransfer <= NOT ((cpu_jtag_debug_module_slavearbiterlockenable AND cpu_jtag_debug_module_any_continuerequest));
  --cpu_jtag_debug_module_beginbursttransfer_internal begin burst transfer, which is an e_assign
  cpu_jtag_debug_module_beginbursttransfer_internal <= cpu_jtag_debug_module_begins_xfer AND cpu_jtag_debug_module_firsttransfer;
  --cpu_jtag_debug_module_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  cpu_jtag_debug_module_arbitration_holdoff_internal <= cpu_jtag_debug_module_begins_xfer AND cpu_jtag_debug_module_firsttransfer;
  --cpu_jtag_debug_module_write assignment, which is an e_mux
  cpu_jtag_debug_module_write <= internal_cpu_data_master_granted_cpu_jtag_debug_module AND cpu_data_master_write;
  --cpu_jtag_debug_module_address mux, which is an e_mux
  cpu_jtag_debug_module_address <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_cpu_jtag_debug_module)) = '1'), (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010"))), (A_SRL(cpu_instruction_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")))), 9);
  --d1_cpu_jtag_debug_module_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_cpu_jtag_debug_module_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_cpu_jtag_debug_module_end_xfer <= cpu_jtag_debug_module_end_xfer;
      end if;
    end if;

  end process;

  --cpu_jtag_debug_module_waits_for_read in a cycle, which is an e_mux
  cpu_jtag_debug_module_waits_for_read <= cpu_jtag_debug_module_in_a_read_cycle AND cpu_jtag_debug_module_begins_xfer;
  --cpu_jtag_debug_module_in_a_read_cycle assignment, which is an e_assign
  cpu_jtag_debug_module_in_a_read_cycle <= ((internal_cpu_data_master_granted_cpu_jtag_debug_module AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_cpu_jtag_debug_module AND cpu_instruction_master_read));
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= cpu_jtag_debug_module_in_a_read_cycle;
  --cpu_jtag_debug_module_waits_for_write in a cycle, which is an e_mux
  cpu_jtag_debug_module_waits_for_write <= cpu_jtag_debug_module_in_a_write_cycle AND cpu_jtag_debug_module_begins_xfer;
  --cpu_jtag_debug_module_in_a_write_cycle assignment, which is an e_assign
  cpu_jtag_debug_module_in_a_write_cycle <= internal_cpu_data_master_granted_cpu_jtag_debug_module AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= cpu_jtag_debug_module_in_a_write_cycle;
  wait_for_cpu_jtag_debug_module_counter <= std_logic'('0');
  --cpu_jtag_debug_module_byteenable byte enable port mux, which is an e_mux
  cpu_jtag_debug_module_byteenable <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_cpu_jtag_debug_module)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))), 4);
  --vhdl renameroo for output signals
  cpu_data_master_granted_cpu_jtag_debug_module <= internal_cpu_data_master_granted_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_cpu_jtag_debug_module <= internal_cpu_data_master_qualified_request_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_data_master_requests_cpu_jtag_debug_module <= internal_cpu_data_master_requests_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_instruction_master_granted_cpu_jtag_debug_module <= internal_cpu_instruction_master_granted_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_instruction_master_qualified_request_cpu_jtag_debug_module <= internal_cpu_instruction_master_qualified_request_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_instruction_master_requests_cpu_jtag_debug_module <= internal_cpu_instruction_master_requests_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_jtag_debug_module_reset_n <= internal_cpu_jtag_debug_module_reset_n;
--synthesis translate_off
    --grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_data_master_granted_cpu_jtag_debug_module))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_instruction_master_granted_cpu_jtag_debug_module))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line, now);
          write(write_line, string'(": "));
          write(write_line, string'("> 1 of grant signals are active simultaneously"));
          write(output, write_line.all);
          deallocate (write_line);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --saved_grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line1 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_data_master_saved_grant_cpu_jtag_debug_module))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_saved_grant_cpu_jtag_debug_module))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line1, now);
          write(write_line1, string'(": "));
          write(write_line1, string'("> 1 of saved_grant signals are active simultaneously"));
          write(output, write_line1.all);
          deallocate (write_line1);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity cpu_data_master_arbitrator is 
        port (
              -- inputs:
                 signal buttons_s1_irq_from_sa : IN STD_LOGIC;
                 signal buttons_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_byteenable_flash_s1 : IN STD_LOGIC;
                 signal cpu_data_master_byteenable_sdram_s1 : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_byteenable_sram_avalonS : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_debugaccess : IN STD_LOGIC;
                 signal cpu_data_master_granted_buttons_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_data_master_granted_epcs_controller_epcs_control_port : IN STD_LOGIC;
                 signal cpu_data_master_granted_flash_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_jtag_avalon_jtag_slave : IN STD_LOGIC;
                 signal cpu_data_master_granted_lcd_control_slave : IN STD_LOGIC;
                 signal cpu_data_master_granted_led_green_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_led_red_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_sdram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_seven_seg_avalonS : IN STD_LOGIC;
                 signal cpu_data_master_granted_sram_avalonS : IN STD_LOGIC;
                 signal cpu_data_master_granted_switches_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_timer0_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_uart_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_buttons_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_epcs_controller_epcs_control_port : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_flash_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_jtag_avalon_jtag_slave : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_lcd_control_slave : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_led_green_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_led_red_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_sdram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_seven_seg_avalonS : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_sram_avalonS : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_switches_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_timer0_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_uart_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_buttons_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_epcs_controller_epcs_control_port : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_flash_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_jtag_avalon_jtag_slave : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_lcd_control_slave : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_led_green_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_led_red_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_sdram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_sdram_s1_shift_register : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal cpu_data_master_read_data_valid_seven_seg_avalonS : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_sram_avalonS : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_switches_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_timer0_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_uart_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_buttons_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_data_master_requests_epcs_controller_epcs_control_port : IN STD_LOGIC;
                 signal cpu_data_master_requests_flash_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_jtag_avalon_jtag_slave : IN STD_LOGIC;
                 signal cpu_data_master_requests_lcd_control_slave : IN STD_LOGIC;
                 signal cpu_data_master_requests_led_green_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_led_red_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_sdram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_seven_seg_avalonS : IN STD_LOGIC;
                 signal cpu_data_master_requests_sram_avalonS : IN STD_LOGIC;
                 signal cpu_data_master_requests_switches_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_timer0_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_uart_s1 : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_jtag_debug_module_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal d1_buttons_s1_end_xfer : IN STD_LOGIC;
                 signal d1_cpu_jtag_debug_module_end_xfer : IN STD_LOGIC;
                 signal d1_epcs_controller_epcs_control_port_end_xfer : IN STD_LOGIC;
                 signal d1_ext_bus_avalon_slave_end_xfer : IN STD_LOGIC;
                 signal d1_jtag_avalon_jtag_slave_end_xfer : IN STD_LOGIC;
                 signal d1_lcd_control_slave_end_xfer : IN STD_LOGIC;
                 signal d1_led_green_s1_end_xfer : IN STD_LOGIC;
                 signal d1_led_red_s1_end_xfer : IN STD_LOGIC;
                 signal d1_sdram_s1_end_xfer : IN STD_LOGIC;
                 signal d1_seven_seg_avalonS_end_xfer : IN STD_LOGIC;
                 signal d1_sram_avalonS_end_xfer : IN STD_LOGIC;
                 signal d1_switches_s1_end_xfer : IN STD_LOGIC;
                 signal d1_timer0_s1_end_xfer : IN STD_LOGIC;
                 signal d1_uart_s1_end_xfer : IN STD_LOGIC;
                 signal epcs_controller_epcs_control_port_irq_from_sa : IN STD_LOGIC;
                 signal epcs_controller_epcs_control_port_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal flash_s1_wait_counter_eq_0 : IN STD_LOGIC;
                 signal flash_s1_wait_counter_eq_1 : IN STD_LOGIC;
                 signal incoming_ext_bus_data_with_Xs_converted_to_0 : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal jtag_avalon_jtag_slave_irq_from_sa : IN STD_LOGIC;
                 signal jtag_avalon_jtag_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal jtag_avalon_jtag_slave_waitrequest_from_sa : IN STD_LOGIC;
                 signal lcd_control_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal lcd_control_slave_wait_counter_eq_0 : IN STD_LOGIC;
                 signal lcd_control_slave_wait_counter_eq_1 : IN STD_LOGIC;
                 signal registered_cpu_data_master_read_data_valid_flash_s1 : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;
                 signal sdram_s1_posted_fifo_readenable : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal sdram_s1_posted_fifo_writenable : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal sdram_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal sdram_s1_waitrequest_from_sa : IN STD_LOGIC;
                 signal sram_avalonS_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal sram_avalonS_wait_counter_eq_0 : IN STD_LOGIC;
                 signal switches_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal timer0_s1_irq_from_sa : IN STD_LOGIC;
                 signal timer0_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal uart_s1_irq_from_sa : IN STD_LOGIC;
                 signal uart_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

              -- outputs:
                 signal cpu_data_master_address_to_slave : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_dbs_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_dbs_write_16 : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal cpu_data_master_dbs_write_8 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal cpu_data_master_irq : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_data_master_no_byte_enables_and_last_term : OUT STD_LOGIC;
                 signal cpu_data_master_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_data_master_waitrequest : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of cpu_data_master_arbitrator : entity is FALSE;
end entity cpu_data_master_arbitrator;


architecture europa of cpu_data_master_arbitrator is
                signal cpu_data_master_dbs_increment :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_run :  STD_LOGIC;
                signal dbs_16_reg_segment_0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dbs_8_reg_segment_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal dbs_8_reg_segment_1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal dbs_8_reg_segment_2 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal dbs_count_enable :  STD_LOGIC;
                signal dbs_counter_overflow :  STD_LOGIC;
                signal dummy_sink :  STD_LOGIC;
                signal internal_cpu_data_master_address_to_slave :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal internal_cpu_data_master_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal internal_cpu_data_master_no_byte_enables_and_last_term :  STD_LOGIC;
                signal internal_cpu_data_master_waitrequest :  STD_LOGIC;
                signal last_dbs_term_and_run :  STD_LOGIC;
                signal next_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_dbs_16_reg_segment_0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal p1_dbs_8_reg_segment_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal p1_dbs_8_reg_segment_1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal p1_dbs_8_reg_segment_2 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal p1_registered_cpu_data_master_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal pre_dbs_count_enable :  STD_LOGIC;
                signal r_0 :  STD_LOGIC;
                signal r_1 :  STD_LOGIC;
                signal r_2 :  STD_LOGIC;
                signal registered_cpu_data_master_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);

begin

  --r_0 master_run cascaded wait assignment, which is an e_assign
  r_0 <= Vector_To_Std_Logic((((((((((((((((((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_buttons_s1 OR NOT cpu_data_master_requests_buttons_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_buttons_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_buttons_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_cpu_jtag_debug_module OR NOT cpu_data_master_requests_cpu_jtag_debug_module)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_granted_cpu_jtag_debug_module OR NOT cpu_data_master_qualified_request_cpu_jtag_debug_module)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_cpu_jtag_debug_module OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_cpu_jtag_debug_module OR NOT cpu_data_master_write)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_epcs_controller_epcs_control_port OR NOT cpu_data_master_requests_epcs_controller_epcs_control_port)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_granted_epcs_controller_epcs_control_port OR NOT cpu_data_master_qualified_request_epcs_controller_epcs_control_port)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_epcs_controller_epcs_control_port OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_epcs_controller_epcs_control_port OR NOT cpu_data_master_write)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((((cpu_data_master_qualified_request_flash_s1 OR (((registered_cpu_data_master_read_data_valid_flash_s1 AND internal_cpu_data_master_dbs_address(1)) AND internal_cpu_data_master_dbs_address(0)))) OR ((((cpu_data_master_write AND NOT(cpu_data_master_byteenable_flash_s1)) AND internal_cpu_data_master_dbs_address(1)) AND internal_cpu_data_master_dbs_address(0)))) OR NOT cpu_data_master_requests_flash_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_granted_flash_s1 OR NOT cpu_data_master_qualified_request_flash_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((NOT cpu_data_master_qualified_request_flash_s1 OR NOT cpu_data_master_read) OR (((registered_cpu_data_master_read_data_valid_flash_s1 AND ((internal_cpu_data_master_dbs_address(1) AND internal_cpu_data_master_dbs_address(0)))) AND cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_flash_s1 OR NOT cpu_data_master_write)))) OR ((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(flash_s1_wait_counter_eq_1)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((internal_cpu_data_master_dbs_address(1) AND internal_cpu_data_master_dbs_address(0))))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")));
  --cascaded wait assignment, which is an e_assign
  cpu_data_master_run <= (r_0 AND r_1) AND r_2;
  --r_1 master_run cascaded wait assignment, which is an e_assign
  r_1 <= Vector_To_Std_Logic(((((((((((((((((((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_jtag_avalon_jtag_slave OR NOT cpu_data_master_requests_jtag_avalon_jtag_slave))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_jtag_avalon_jtag_slave OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT jtag_avalon_jtag_slave_waitrequest_from_sa)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_jtag_avalon_jtag_slave OR NOT cpu_data_master_write)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT jtag_avalon_jtag_slave_waitrequest_from_sa)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_lcd_control_slave OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(lcd_control_slave_wait_counter_eq_1)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_lcd_control_slave OR NOT cpu_data_master_write)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(lcd_control_slave_wait_counter_eq_1)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_led_green_s1 OR NOT cpu_data_master_requests_led_green_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_led_green_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_led_green_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_led_red_s1 OR NOT cpu_data_master_requests_led_red_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_led_red_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_led_red_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((((cpu_data_master_qualified_request_sdram_s1 OR ((cpu_data_master_read_data_valid_sdram_s1 AND internal_cpu_data_master_dbs_address(1)))) OR (((cpu_data_master_write AND NOT(or_reduce(cpu_data_master_byteenable_sdram_s1))) AND internal_cpu_data_master_dbs_address(1)))) OR NOT cpu_data_master_requests_sdram_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_granted_sdram_s1 OR NOT cpu_data_master_qualified_request_sdram_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((NOT cpu_data_master_qualified_request_sdram_s1 OR NOT cpu_data_master_read) OR (((cpu_data_master_read_data_valid_sdram_s1 AND (internal_cpu_data_master_dbs_address(1))) AND cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_sdram_s1 OR NOT cpu_data_master_write)))) OR ((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT sdram_s1_waitrequest_from_sa)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((internal_cpu_data_master_dbs_address(1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")));
  --r_2 master_run cascaded wait assignment, which is an e_assign
  r_2 <= Vector_To_Std_Logic(((((((((((((((((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((cpu_data_master_qualified_request_seven_seg_avalonS OR NOT cpu_data_master_requests_seven_seg_avalonS)) AND ((cpu_data_master_granted_seven_seg_avalonS OR NOT cpu_data_master_qualified_request_seven_seg_avalonS)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_seven_seg_avalonS OR NOT cpu_data_master_read)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_seven_seg_avalonS OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((cpu_data_master_qualified_request_sram_avalonS OR (((cpu_data_master_write AND NOT(or_reduce(cpu_data_master_byteenable_sram_avalonS))) AND internal_cpu_data_master_dbs_address(1)))) OR NOT cpu_data_master_requests_sram_avalonS)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_granted_sram_avalonS OR NOT cpu_data_master_qualified_request_sram_avalonS)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_sram_avalonS OR NOT cpu_data_master_read)))) OR ((((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((internal_cpu_data_master_dbs_address(1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_sram_avalonS OR NOT cpu_data_master_write)))) OR ((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_sram_avalonS_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((internal_cpu_data_master_dbs_address(1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_switches_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_switches_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_timer0_s1 OR NOT cpu_data_master_requests_timer0_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_timer0_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_timer0_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_uart_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_uart_s1 OR NOT cpu_data_master_write)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))));
  --optimize select-logic by passing only those address bits which matter.
  internal_cpu_data_master_address_to_slave <= cpu_data_master_address(23 DOWNTO 0);
  --cpu/data_master readdata mux, which is an e_mux
  cpu_data_master_readdata <= (((((((((((A_REP(NOT cpu_data_master_requests_buttons_s1, 32) OR (std_logic_vector'("0000000000000000000000000000") & (buttons_s1_readdata_from_sa)))) AND ((A_REP(NOT cpu_data_master_requests_cpu_jtag_debug_module, 32) OR cpu_jtag_debug_module_readdata_from_sa))) AND ((A_REP(NOT cpu_data_master_requests_epcs_controller_epcs_control_port, 32) OR epcs_controller_epcs_control_port_readdata_from_sa))) AND ((A_REP(NOT cpu_data_master_requests_flash_s1, 32) OR (incoming_ext_bus_data_with_Xs_converted_to_0 & dbs_8_reg_segment_2 & dbs_8_reg_segment_1 & dbs_8_reg_segment_0)))) AND ((A_REP(NOT cpu_data_master_requests_jtag_avalon_jtag_slave, 32) OR registered_cpu_data_master_readdata))) AND ((A_REP(NOT cpu_data_master_requests_lcd_control_slave, 32) OR (std_logic_vector'("000000000000000000000000") & (lcd_control_slave_readdata_from_sa))))) AND ((A_REP(NOT cpu_data_master_requests_sdram_s1, 32) OR registered_cpu_data_master_readdata))) AND ((A_REP(NOT cpu_data_master_requests_sram_avalonS, 32) OR (sram_avalonS_readdata_from_sa & dbs_16_reg_segment_0)))) AND ((A_REP(NOT cpu_data_master_requests_switches_s1, 32) OR (std_logic_vector'("00000000000000") & (switches_s1_readdata_from_sa))))) AND ((A_REP(NOT cpu_data_master_requests_timer0_s1, 32) OR (std_logic_vector'("0000000000000000") & (timer0_s1_readdata_from_sa))))) AND ((A_REP(NOT cpu_data_master_requests_uart_s1, 32) OR (std_logic_vector'("0000000000000000") & (uart_s1_readdata_from_sa))));
  --actual waitrequest port, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_waitrequest <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        internal_cpu_data_master_waitrequest <= Vector_To_Std_Logic(NOT (A_WE_StdLogicVector((std_logic'((NOT ((cpu_data_master_read OR cpu_data_master_write)))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_run AND internal_cpu_data_master_waitrequest))))))));
      end if;
    end if;

  end process;

  --irq assign, which is an e_assign
  cpu_data_master_irq <= Std_Logic_Vector'(A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(epcs_controller_epcs_control_port_irq_from_sa) & A_ToStdLogicVector(buttons_s1_irq_from_sa) & A_ToStdLogicVector(uart_s1_irq_from_sa) & A_ToStdLogicVector(jtag_avalon_jtag_slave_irq_from_sa) & A_ToStdLogicVector(timer0_s1_irq_from_sa));
  --no_byte_enables_and_last_term, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_no_byte_enables_and_last_term <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        internal_cpu_data_master_no_byte_enables_and_last_term <= last_dbs_term_and_run;
      end if;
    end if;

  end process;

  --compute the last dbs term, which is an e_mux
  last_dbs_term_and_run <= A_WE_StdLogic((std_logic'((cpu_data_master_requests_flash_s1)) = '1'), (((to_std_logic(((internal_cpu_data_master_dbs_address = std_logic_vector'("11")))) AND cpu_data_master_write) AND NOT(cpu_data_master_byteenable_flash_s1))), A_WE_StdLogic((std_logic'((cpu_data_master_requests_sdram_s1)) = '1'), (((to_std_logic(((internal_cpu_data_master_dbs_address = std_logic_vector'("10")))) AND cpu_data_master_write) AND NOT(or_reduce(cpu_data_master_byteenable_sdram_s1)))), (((to_std_logic(((internal_cpu_data_master_dbs_address = std_logic_vector'("10")))) AND cpu_data_master_write) AND NOT(or_reduce(cpu_data_master_byteenable_sram_avalonS))))));
  --pre dbs count enable, which is an e_mux
  pre_dbs_count_enable <= Vector_To_Std_Logic(((((((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((((((NOT internal_cpu_data_master_no_byte_enables_and_last_term) AND cpu_data_master_requests_flash_s1) AND cpu_data_master_write) AND NOT(cpu_data_master_byteenable_flash_s1))) OR cpu_data_master_read_data_valid_flash_s1)))) OR (((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((cpu_data_master_granted_flash_s1 AND cpu_data_master_write)))) AND std_logic_vector'("00000000000000000000000000000001")) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((flash_s1_wait_counter_eq_0 AND NOT d1_ext_bus_avalon_slave_end_xfer)))))))) OR (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((((NOT internal_cpu_data_master_no_byte_enables_and_last_term) AND cpu_data_master_requests_sdram_s1) AND cpu_data_master_write) AND NOT(or_reduce(cpu_data_master_byteenable_sdram_s1)))))))) OR (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read_data_valid_sdram_s1)))) OR (((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((cpu_data_master_granted_sdram_s1 AND cpu_data_master_write)))) AND std_logic_vector'("00000000000000000000000000000001")) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT sdram_s1_waitrequest_from_sa)))))) OR (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((((NOT internal_cpu_data_master_no_byte_enables_and_last_term) AND cpu_data_master_requests_sram_avalonS) AND cpu_data_master_write) AND NOT(or_reduce(cpu_data_master_byteenable_sram_avalonS)))))))) OR (((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((cpu_data_master_granted_sram_avalonS AND cpu_data_master_read)))) AND std_logic_vector'("00000000000000000000000000000001")) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_sram_avalonS_end_xfer)))))) OR (((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((cpu_data_master_granted_sram_avalonS AND cpu_data_master_write)))) AND std_logic_vector'("00000000000000000000000000000001")) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((sram_avalonS_wait_counter_eq_0 AND NOT d1_sram_avalonS_end_xfer)))))))));
  --input to dbs-8 stored 0, which is an e_mux
  p1_dbs_8_reg_segment_0 <= incoming_ext_bus_data_with_Xs_converted_to_0;
  --dbs register for dbs-8 segment 0, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dbs_8_reg_segment_0 <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      if std_logic'((dbs_count_enable AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & ((internal_cpu_data_master_dbs_address(1 DOWNTO 0)))) = std_logic_vector'("00000000000000000000000000000000")))))) = '1' then 
        dbs_8_reg_segment_0 <= p1_dbs_8_reg_segment_0;
      end if;
    end if;

  end process;

  --input to dbs-8 stored 1, which is an e_mux
  p1_dbs_8_reg_segment_1 <= incoming_ext_bus_data_with_Xs_converted_to_0;
  --dbs register for dbs-8 segment 1, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dbs_8_reg_segment_1 <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      if std_logic'((dbs_count_enable AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & ((internal_cpu_data_master_dbs_address(1 DOWNTO 0)))) = std_logic_vector'("00000000000000000000000000000001")))))) = '1' then 
        dbs_8_reg_segment_1 <= p1_dbs_8_reg_segment_1;
      end if;
    end if;

  end process;

  --input to dbs-8 stored 2, which is an e_mux
  p1_dbs_8_reg_segment_2 <= incoming_ext_bus_data_with_Xs_converted_to_0;
  --dbs register for dbs-8 segment 2, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dbs_8_reg_segment_2 <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      if std_logic'((dbs_count_enable AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & ((internal_cpu_data_master_dbs_address(1 DOWNTO 0)))) = std_logic_vector'("00000000000000000000000000000010")))))) = '1' then 
        dbs_8_reg_segment_2 <= p1_dbs_8_reg_segment_2;
      end if;
    end if;

  end process;

  --mux write dbs 2, which is an e_mux
  cpu_data_master_dbs_write_8 <= A_WE_StdLogicVector((((std_logic_vector'("000000000000000000000000000000") & (internal_cpu_data_master_dbs_address(1 DOWNTO 0))) = std_logic_vector'("00000000000000000000000000000000"))), cpu_data_master_writedata(7 DOWNTO 0), A_WE_StdLogicVector((((std_logic_vector'("000000000000000000000000000000") & (internal_cpu_data_master_dbs_address(1 DOWNTO 0))) = std_logic_vector'("00000000000000000000000000000001"))), cpu_data_master_writedata(15 DOWNTO 8), A_WE_StdLogicVector((((std_logic_vector'("000000000000000000000000000000") & (internal_cpu_data_master_dbs_address(1 DOWNTO 0))) = std_logic_vector'("00000000000000000000000000000010"))), cpu_data_master_writedata(23 DOWNTO 16), cpu_data_master_writedata(31 DOWNTO 24))));
  --dbs count increment, which is an e_mux
  cpu_data_master_dbs_increment <= A_EXT (A_WE_StdLogicVector((std_logic'((cpu_data_master_requests_flash_s1)) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'((cpu_data_master_requests_sdram_s1)) = '1'), std_logic_vector'("00000000000000000000000000000010"), A_WE_StdLogicVector((std_logic'((cpu_data_master_requests_sram_avalonS)) = '1'), std_logic_vector'("00000000000000000000000000000010"), std_logic_vector'("00000000000000000000000000000000")))), 2);
  --dbs counter overflow, which is an e_assign
  dbs_counter_overflow <= internal_cpu_data_master_dbs_address(1) AND NOT((next_dbs_address(1)));
  --next master address, which is an e_assign
  next_dbs_address <= A_EXT (((std_logic_vector'("0") & (internal_cpu_data_master_dbs_address)) + (std_logic_vector'("0") & (cpu_data_master_dbs_increment))), 2);
  --dbs count enable, which is an e_mux
  dbs_count_enable <= pre_dbs_count_enable AND (NOT ((cpu_data_master_requests_sdram_s1 AND NOT internal_cpu_data_master_waitrequest)));
  --dbs counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_dbs_address <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(dbs_count_enable) = '1' then 
        internal_cpu_data_master_dbs_address <= next_dbs_address;
      end if;
    end if;

  end process;

  --unpredictable registered wait state incoming data, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      registered_cpu_data_master_readdata <= std_logic_vector'("00000000000000000000000000000000");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        registered_cpu_data_master_readdata <= p1_registered_cpu_data_master_readdata;
      end if;
    end if;

  end process;

  --registered readdata mux, which is an e_mux
  p1_registered_cpu_data_master_readdata <= ((A_REP(NOT cpu_data_master_requests_jtag_avalon_jtag_slave, 32) OR jtag_avalon_jtag_slave_readdata_from_sa)) AND ((A_REP(NOT cpu_data_master_requests_sdram_s1, 32) OR (sdram_s1_readdata_from_sa & dbs_16_reg_segment_0)));
  --input to dbs-16 stored 0, which is an e_mux
  p1_dbs_16_reg_segment_0 <= A_WE_StdLogicVector((std_logic'((cpu_data_master_requests_sdram_s1)) = '1'), sdram_s1_readdata_from_sa, sram_avalonS_readdata_from_sa);
  --dbs register for dbs-16 segment 0, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dbs_16_reg_segment_0 <= std_logic_vector'("0000000000000000");
    elsif clk'event and clk = '1' then
      if std_logic'((dbs_count_enable AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((internal_cpu_data_master_dbs_address(1))))) = std_logic_vector'("00000000000000000000000000000000")))))) = '1' then 
        dbs_16_reg_segment_0 <= p1_dbs_16_reg_segment_0;
      end if;
    end if;

  end process;

  --mux write dbs 1, which is an e_mux
  cpu_data_master_dbs_write_16 <= A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_dbs_address(1))) = '1'), cpu_data_master_writedata(31 DOWNTO 16), A_WE_StdLogicVector((std_logic'((NOT (internal_cpu_data_master_dbs_address(1)))) = '1'), cpu_data_master_writedata(15 DOWNTO 0), A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_dbs_address(1))) = '1'), cpu_data_master_writedata(31 DOWNTO 16), cpu_data_master_writedata(15 DOWNTO 0))));
  --vhdl renameroo for output signals
  cpu_data_master_address_to_slave <= internal_cpu_data_master_address_to_slave;
  --vhdl renameroo for output signals
  cpu_data_master_dbs_address <= internal_cpu_data_master_dbs_address;
  --vhdl renameroo for output signals
  cpu_data_master_no_byte_enables_and_last_term <= internal_cpu_data_master_no_byte_enables_and_last_term;
  --vhdl renameroo for output signals
  cpu_data_master_waitrequest <= internal_cpu_data_master_waitrequest;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity cpu_instruction_master_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_instruction_master_address : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_instruction_master_granted_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_instruction_master_granted_epcs_controller_epcs_control_port : IN STD_LOGIC;
                 signal cpu_instruction_master_granted_flash_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_granted_sdram_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_granted_seven_seg_avalonS : IN STD_LOGIC;
                 signal cpu_instruction_master_granted_sram_avalonS : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_epcs_controller_epcs_control_port : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_flash_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_sdram_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_seven_seg_avalonS : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_sram_avalonS : IN STD_LOGIC;
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_epcs_controller_epcs_control_port : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_flash_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_sdram_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_sdram_s1_shift_register : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal cpu_instruction_master_read_data_valid_seven_seg_avalonS : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_sram_avalonS : IN STD_LOGIC;
                 signal cpu_instruction_master_requests_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_instruction_master_requests_epcs_controller_epcs_control_port : IN STD_LOGIC;
                 signal cpu_instruction_master_requests_flash_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_requests_sdram_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_requests_seven_seg_avalonS : IN STD_LOGIC;
                 signal cpu_instruction_master_requests_sram_avalonS : IN STD_LOGIC;
                 signal cpu_jtag_debug_module_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal d1_cpu_jtag_debug_module_end_xfer : IN STD_LOGIC;
                 signal d1_epcs_controller_epcs_control_port_end_xfer : IN STD_LOGIC;
                 signal d1_ext_bus_avalon_slave_end_xfer : IN STD_LOGIC;
                 signal d1_sdram_s1_end_xfer : IN STD_LOGIC;
                 signal d1_seven_seg_avalonS_end_xfer : IN STD_LOGIC;
                 signal d1_sram_avalonS_end_xfer : IN STD_LOGIC;
                 signal epcs_controller_epcs_control_port_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal flash_s1_wait_counter_eq_0 : IN STD_LOGIC;
                 signal flash_s1_wait_counter_eq_1 : IN STD_LOGIC;
                 signal incoming_ext_bus_data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;
                 signal sdram_s1_posted_fifo_readenable : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal sdram_s1_posted_fifo_writenable : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal sdram_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal sdram_s1_waitrequest_from_sa : IN STD_LOGIC;
                 signal sram_avalonS_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal sram_avalonS_wait_counter_eq_0 : IN STD_LOGIC;

              -- outputs:
                 signal cpu_instruction_master_address_to_slave : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_instruction_master_dbs_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_latency_counter : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_instruction_master_readdatavalid : OUT STD_LOGIC;
                 signal cpu_instruction_master_waitrequest : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of cpu_instruction_master_arbitrator : entity is FALSE;
end entity cpu_instruction_master_arbitrator;


architecture europa of cpu_instruction_master_arbitrator is
                signal active_and_waiting_last_time :  STD_LOGIC;
                signal cpu_instruction_master_address_last_time :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal cpu_instruction_master_dbs_increment :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_instruction_master_dbs_rdv_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_instruction_master_dbs_rdv_counter_inc :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_instruction_master_is_granted_some_slave :  STD_LOGIC;
                signal cpu_instruction_master_next_dbs_rdv_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_instruction_master_read_but_no_slave_selected :  STD_LOGIC;
                signal cpu_instruction_master_read_last_time :  STD_LOGIC;
                signal cpu_instruction_master_run :  STD_LOGIC;
                signal dbs_16_reg_segment_0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dbs_count_enable :  STD_LOGIC;
                signal dbs_counter_overflow :  STD_LOGIC;
                signal dbs_latent_16_reg_segment_0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal dbs_latent_8_reg_segment_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal dbs_latent_8_reg_segment_1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal dbs_latent_8_reg_segment_2 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal dbs_rdv_count_enable :  STD_LOGIC;
                signal dbs_rdv_counter_overflow :  STD_LOGIC;
                signal dummy_sink :  STD_LOGIC;
                signal internal_cpu_instruction_master_address_to_slave :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal internal_cpu_instruction_master_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal internal_cpu_instruction_master_latency_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal internal_cpu_instruction_master_waitrequest :  STD_LOGIC;
                signal latency_load_value :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal next_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_cpu_instruction_master_latency_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_dbs_16_reg_segment_0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal p1_dbs_latent_16_reg_segment_0 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal p1_dbs_latent_8_reg_segment_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal p1_dbs_latent_8_reg_segment_1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal p1_dbs_latent_8_reg_segment_2 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal pre_dbs_count_enable :  STD_LOGIC;
                signal pre_flush_cpu_instruction_master_readdatavalid :  STD_LOGIC;
                signal r_0 :  STD_LOGIC;
                signal r_1 :  STD_LOGIC;
                signal r_2 :  STD_LOGIC;

begin

  --r_0 master_run cascaded wait assignment, which is an e_assign
  r_0 <= Vector_To_Std_Logic((((((((((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_qualified_request_cpu_jtag_debug_module OR NOT cpu_instruction_master_requests_cpu_jtag_debug_module)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_granted_cpu_jtag_debug_module OR NOT cpu_instruction_master_qualified_request_cpu_jtag_debug_module)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_instruction_master_qualified_request_cpu_jtag_debug_module OR NOT cpu_instruction_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_cpu_jtag_debug_module_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_read)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_qualified_request_epcs_controller_epcs_control_port OR NOT cpu_instruction_master_requests_epcs_controller_epcs_control_port)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_granted_epcs_controller_epcs_control_port OR NOT cpu_instruction_master_qualified_request_epcs_controller_epcs_control_port)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_instruction_master_qualified_request_epcs_controller_epcs_control_port OR NOT cpu_instruction_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_epcs_controller_epcs_control_port_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_read)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_qualified_request_flash_s1 OR NOT cpu_instruction_master_requests_flash_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_granted_flash_s1 OR NOT cpu_instruction_master_qualified_request_flash_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_instruction_master_qualified_request_flash_s1 OR NOT cpu_instruction_master_read)))) OR ((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((flash_s1_wait_counter_eq_0 AND NOT d1_ext_bus_avalon_slave_end_xfer)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((internal_cpu_instruction_master_dbs_address(1) AND internal_cpu_instruction_master_dbs_address(0))))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_read)))))))));
  --cascaded wait assignment, which is an e_assign
  cpu_instruction_master_run <= (r_0 AND r_1) AND r_2;
  --r_1 master_run cascaded wait assignment, which is an e_assign
  r_1 <= Vector_To_Std_Logic((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_qualified_request_sdram_s1 OR NOT cpu_instruction_master_requests_sdram_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_granted_sdram_s1 OR NOT cpu_instruction_master_qualified_request_sdram_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_instruction_master_qualified_request_sdram_s1 OR NOT cpu_instruction_master_read)))) OR ((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT sdram_s1_waitrequest_from_sa)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((internal_cpu_instruction_master_dbs_address(1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_read)))))))));
  --r_2 master_run cascaded wait assignment, which is an e_assign
  r_2 <= Vector_To_Std_Logic((((((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_qualified_request_seven_seg_avalonS OR NOT cpu_instruction_master_requests_seven_seg_avalonS)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_granted_seven_seg_avalonS OR NOT cpu_instruction_master_qualified_request_seven_seg_avalonS)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_instruction_master_qualified_request_seven_seg_avalonS OR NOT cpu_instruction_master_read)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_read)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_qualified_request_sram_avalonS OR NOT cpu_instruction_master_requests_sram_avalonS)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_granted_sram_avalonS OR NOT cpu_instruction_master_qualified_request_sram_avalonS)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_instruction_master_qualified_request_sram_avalonS OR NOT cpu_instruction_master_read)))) OR ((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_sram_avalonS_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((internal_cpu_instruction_master_dbs_address(1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_read)))))))));
  --optimize select-logic by passing only those address bits which matter.
  internal_cpu_instruction_master_address_to_slave <= cpu_instruction_master_address(23 DOWNTO 0);
  --cpu_instruction_master_read_but_no_slave_selected assignment, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_instruction_master_read_but_no_slave_selected <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        cpu_instruction_master_read_but_no_slave_selected <= (cpu_instruction_master_read AND cpu_instruction_master_run) AND NOT cpu_instruction_master_is_granted_some_slave;
      end if;
    end if;

  end process;

  --some slave is getting selected, which is an e_mux
  cpu_instruction_master_is_granted_some_slave <= ((((cpu_instruction_master_granted_cpu_jtag_debug_module OR cpu_instruction_master_granted_epcs_controller_epcs_control_port) OR cpu_instruction_master_granted_flash_s1) OR cpu_instruction_master_granted_sdram_s1) OR cpu_instruction_master_granted_seven_seg_avalonS) OR cpu_instruction_master_granted_sram_avalonS;
  --latent slave read data valids which may be flushed, which is an e_mux
  pre_flush_cpu_instruction_master_readdatavalid <= ((cpu_instruction_master_read_data_valid_flash_s1 AND dbs_rdv_counter_overflow)) OR ((cpu_instruction_master_read_data_valid_sdram_s1 AND dbs_rdv_counter_overflow));
  --latent slave read data valid which is not flushed, which is an e_mux
  cpu_instruction_master_readdatavalid <= ((((((((((((((cpu_instruction_master_read_but_no_slave_selected OR pre_flush_cpu_instruction_master_readdatavalid) OR cpu_instruction_master_read_data_valid_cpu_jtag_debug_module) OR cpu_instruction_master_read_but_no_slave_selected) OR pre_flush_cpu_instruction_master_readdatavalid) OR cpu_instruction_master_read_data_valid_epcs_controller_epcs_control_port) OR cpu_instruction_master_read_but_no_slave_selected) OR pre_flush_cpu_instruction_master_readdatavalid) OR cpu_instruction_master_read_but_no_slave_selected) OR pre_flush_cpu_instruction_master_readdatavalid) OR cpu_instruction_master_read_but_no_slave_selected) OR pre_flush_cpu_instruction_master_readdatavalid) OR cpu_instruction_master_read_data_valid_seven_seg_avalonS) OR cpu_instruction_master_read_but_no_slave_selected) OR pre_flush_cpu_instruction_master_readdatavalid) OR ((cpu_instruction_master_read_data_valid_sram_avalonS AND dbs_counter_overflow));
  --cpu/instruction_master readdata mux, which is an e_mux
  cpu_instruction_master_readdata <= (((((A_REP(NOT cpu_instruction_master_qualified_request_cpu_jtag_debug_module, 32) OR cpu_jtag_debug_module_readdata_from_sa)) AND ((A_REP(NOT cpu_instruction_master_qualified_request_epcs_controller_epcs_control_port, 32) OR epcs_controller_epcs_control_port_readdata_from_sa))) AND ((A_REP(NOT cpu_instruction_master_read_data_valid_flash_s1, 32) OR (incoming_ext_bus_data & dbs_latent_8_reg_segment_2 & dbs_latent_8_reg_segment_1 & dbs_latent_8_reg_segment_0)))) AND ((A_REP(NOT cpu_instruction_master_read_data_valid_sdram_s1, 32) OR (sdram_s1_readdata_from_sa & dbs_latent_16_reg_segment_0)))) AND ((A_REP(NOT cpu_instruction_master_qualified_request_sram_avalonS, 32) OR (sram_avalonS_readdata_from_sa & dbs_16_reg_segment_0)));
  --actual waitrequest port, which is an e_assign
  internal_cpu_instruction_master_waitrequest <= NOT cpu_instruction_master_run;
  --latent max counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_instruction_master_latency_counter <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        internal_cpu_instruction_master_latency_counter <= p1_cpu_instruction_master_latency_counter;
      end if;
    end if;

  end process;

  --latency counter load mux, which is an e_mux
  p1_cpu_instruction_master_latency_counter <= A_EXT (A_WE_StdLogicVector((std_logic'(((cpu_instruction_master_run AND cpu_instruction_master_read))) = '1'), (std_logic_vector'("0000000000000000000000000000000") & (latency_load_value)), A_WE_StdLogicVector((((internal_cpu_instruction_master_latency_counter)) /= std_logic_vector'("00")), ((std_logic_vector'("0000000000000000000000000000000") & (internal_cpu_instruction_master_latency_counter)) - std_logic_vector'("000000000000000000000000000000001")), std_logic_vector'("000000000000000000000000000000000"))), 2);
  --read latency load values, which is an e_mux
  latency_load_value <= A_EXT (((std_logic_vector'("000000000000000000000000000000") & (A_REP(cpu_instruction_master_requests_flash_s1, 2))) AND std_logic_vector'("00000000000000000000000000000010")), 2);
  --input to latent dbs-8 stored 0, which is an e_mux
  p1_dbs_latent_8_reg_segment_0 <= incoming_ext_bus_data;
  --dbs register for latent dbs-8 segment 0, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dbs_latent_8_reg_segment_0 <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      if std_logic'((dbs_rdv_count_enable AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & ((cpu_instruction_master_dbs_rdv_counter(1 DOWNTO 0)))) = std_logic_vector'("00000000000000000000000000000000")))))) = '1' then 
        dbs_latent_8_reg_segment_0 <= p1_dbs_latent_8_reg_segment_0;
      end if;
    end if;

  end process;

  --input to latent dbs-8 stored 1, which is an e_mux
  p1_dbs_latent_8_reg_segment_1 <= incoming_ext_bus_data;
  --dbs register for latent dbs-8 segment 1, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dbs_latent_8_reg_segment_1 <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      if std_logic'((dbs_rdv_count_enable AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & ((cpu_instruction_master_dbs_rdv_counter(1 DOWNTO 0)))) = std_logic_vector'("00000000000000000000000000000001")))))) = '1' then 
        dbs_latent_8_reg_segment_1 <= p1_dbs_latent_8_reg_segment_1;
      end if;
    end if;

  end process;

  --input to latent dbs-8 stored 2, which is an e_mux
  p1_dbs_latent_8_reg_segment_2 <= incoming_ext_bus_data;
  --dbs register for latent dbs-8 segment 2, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dbs_latent_8_reg_segment_2 <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      if std_logic'((dbs_rdv_count_enable AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & ((cpu_instruction_master_dbs_rdv_counter(1 DOWNTO 0)))) = std_logic_vector'("00000000000000000000000000000010")))))) = '1' then 
        dbs_latent_8_reg_segment_2 <= p1_dbs_latent_8_reg_segment_2;
      end if;
    end if;

  end process;

  --dbs count increment, which is an e_mux
  cpu_instruction_master_dbs_increment <= A_EXT (A_WE_StdLogicVector((std_logic'((cpu_instruction_master_requests_flash_s1)) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'((cpu_instruction_master_requests_sdram_s1)) = '1'), std_logic_vector'("00000000000000000000000000000010"), A_WE_StdLogicVector((std_logic'((cpu_instruction_master_requests_sram_avalonS)) = '1'), std_logic_vector'("00000000000000000000000000000010"), std_logic_vector'("00000000000000000000000000000000")))), 2);
  --dbs counter overflow, which is an e_assign
  dbs_counter_overflow <= internal_cpu_instruction_master_dbs_address(1) AND NOT((next_dbs_address(1)));
  --next master address, which is an e_assign
  next_dbs_address <= A_EXT (((std_logic_vector'("0") & (internal_cpu_instruction_master_dbs_address)) + (std_logic_vector'("0") & (cpu_instruction_master_dbs_increment))), 2);
  --dbs count enable, which is an e_mux
  dbs_count_enable <= pre_dbs_count_enable;
  --dbs counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_instruction_master_dbs_address <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(dbs_count_enable) = '1' then 
        internal_cpu_instruction_master_dbs_address <= next_dbs_address;
      end if;
    end if;

  end process;

  --p1 dbs rdv counter, which is an e_assign
  cpu_instruction_master_next_dbs_rdv_counter <= A_EXT (((std_logic_vector'("0") & (cpu_instruction_master_dbs_rdv_counter)) + (std_logic_vector'("0") & (cpu_instruction_master_dbs_rdv_counter_inc))), 2);
  --cpu_instruction_master_rdv_inc_mux, which is an e_mux
  cpu_instruction_master_dbs_rdv_counter_inc <= A_EXT (A_WE_StdLogicVector((std_logic'((cpu_instruction_master_read_data_valid_flash_s1)) = '1'), std_logic_vector'("00000000000000000000000000000001"), std_logic_vector'("00000000000000000000000000000010")), 2);
  --master any slave rdv, which is an e_mux
  dbs_rdv_count_enable <= cpu_instruction_master_read_data_valid_flash_s1 OR cpu_instruction_master_read_data_valid_sdram_s1;
  --dbs rdv counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_instruction_master_dbs_rdv_counter <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(dbs_rdv_count_enable) = '1' then 
        cpu_instruction_master_dbs_rdv_counter <= cpu_instruction_master_next_dbs_rdv_counter;
      end if;
    end if;

  end process;

  --dbs rdv counter overflow, which is an e_assign
  dbs_rdv_counter_overflow <= cpu_instruction_master_dbs_rdv_counter(1) AND NOT cpu_instruction_master_next_dbs_rdv_counter(1);
  --pre dbs count enable, which is an e_mux
  pre_dbs_count_enable <= Vector_To_Std_Logic((((((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((cpu_instruction_master_granted_flash_s1 AND cpu_instruction_master_read)))) AND std_logic_vector'("00000000000000000000000000000001")) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((flash_s1_wait_counter_eq_0 AND NOT d1_ext_bus_avalon_slave_end_xfer))))))) OR (((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((cpu_instruction_master_granted_sdram_s1 AND cpu_instruction_master_read)))) AND std_logic_vector'("00000000000000000000000000000001")) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT sdram_s1_waitrequest_from_sa)))))) OR (((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((cpu_instruction_master_granted_sram_avalonS AND cpu_instruction_master_read)))) AND std_logic_vector'("00000000000000000000000000000001")) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_sram_avalonS_end_xfer)))))));
  --input to latent dbs-16 stored 0, which is an e_mux
  p1_dbs_latent_16_reg_segment_0 <= sdram_s1_readdata_from_sa;
  --dbs register for latent dbs-16 segment 0, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dbs_latent_16_reg_segment_0 <= std_logic_vector'("0000000000000000");
    elsif clk'event and clk = '1' then
      if std_logic'((dbs_rdv_count_enable AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((cpu_instruction_master_dbs_rdv_counter(1))))) = std_logic_vector'("00000000000000000000000000000000")))))) = '1' then 
        dbs_latent_16_reg_segment_0 <= p1_dbs_latent_16_reg_segment_0;
      end if;
    end if;

  end process;

  --input to dbs-16 stored 0, which is an e_mux
  p1_dbs_16_reg_segment_0 <= sram_avalonS_readdata_from_sa;
  --dbs register for dbs-16 segment 0, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dbs_16_reg_segment_0 <= std_logic_vector'("0000000000000000");
    elsif clk'event and clk = '1' then
      if std_logic'((dbs_count_enable AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((internal_cpu_instruction_master_dbs_address(1))))) = std_logic_vector'("00000000000000000000000000000000")))))) = '1' then 
        dbs_16_reg_segment_0 <= p1_dbs_16_reg_segment_0;
      end if;
    end if;

  end process;

  --vhdl renameroo for output signals
  cpu_instruction_master_address_to_slave <= internal_cpu_instruction_master_address_to_slave;
  --vhdl renameroo for output signals
  cpu_instruction_master_dbs_address <= internal_cpu_instruction_master_dbs_address;
  --vhdl renameroo for output signals
  cpu_instruction_master_latency_counter <= internal_cpu_instruction_master_latency_counter;
  --vhdl renameroo for output signals
  cpu_instruction_master_waitrequest <= internal_cpu_instruction_master_waitrequest;
--synthesis translate_off
    --cpu_instruction_master_address check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_instruction_master_address_last_time <= std_logic_vector'("000000000000000000000000");
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          cpu_instruction_master_address_last_time <= cpu_instruction_master_address;
        end if;
      end if;

    end process;

    --cpu/instruction_master waited last time, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        active_and_waiting_last_time <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          active_and_waiting_last_time <= internal_cpu_instruction_master_waitrequest AND (cpu_instruction_master_read);
        end if;
      end if;

    end process;

    --cpu_instruction_master_address matches last port_name, which is an e_process
    process (active_and_waiting_last_time, cpu_instruction_master_address, cpu_instruction_master_address_last_time)
    VARIABLE write_line2 : line;
    begin
        if std_logic'((active_and_waiting_last_time AND to_std_logic(((cpu_instruction_master_address /= cpu_instruction_master_address_last_time))))) = '1' then 
          write(write_line2, now);
          write(write_line2, string'(": "));
          write(write_line2, string'("cpu_instruction_master_address did not heed wait!!!"));
          write(output, write_line2.all);
          deallocate (write_line2);
          assert false report "VHDL STOP" severity failure;
        end if;

    end process;

    --cpu_instruction_master_read check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_instruction_master_read_last_time <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          cpu_instruction_master_read_last_time <= cpu_instruction_master_read;
        end if;
      end if;

    end process;

    --cpu_instruction_master_read matches last port_name, which is an e_process
    process (active_and_waiting_last_time, cpu_instruction_master_read, cpu_instruction_master_read_last_time)
    VARIABLE write_line3 : line;
    begin
        if std_logic'((active_and_waiting_last_time AND to_std_logic(((std_logic'(cpu_instruction_master_read) /= std_logic'(cpu_instruction_master_read_last_time)))))) = '1' then 
          write(write_line3, now);
          write(write_line3, string'(": "));
          write(write_line3, string'("cpu_instruction_master_read did not heed wait!!!"));
          write(output, write_line3.all);
          deallocate (write_line3);
          assert false report "VHDL STOP" severity failure;
        end if;

    end process;

--synthesis translate_on

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity epcs_controller_epcs_control_port_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_sdram_s1_shift_register : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal epcs_controller_epcs_control_port_dataavailable : IN STD_LOGIC;
                 signal epcs_controller_epcs_control_port_endofpacket : IN STD_LOGIC;
                 signal epcs_controller_epcs_control_port_irq : IN STD_LOGIC;
                 signal epcs_controller_epcs_control_port_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal epcs_controller_epcs_control_port_readyfordata : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_epcs_controller_epcs_control_port : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_epcs_controller_epcs_control_port : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_epcs_controller_epcs_control_port : OUT STD_LOGIC;
                 signal cpu_data_master_requests_epcs_controller_epcs_control_port : OUT STD_LOGIC;
                 signal cpu_instruction_master_granted_epcs_controller_epcs_control_port : OUT STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_epcs_controller_epcs_control_port : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_epcs_controller_epcs_control_port : OUT STD_LOGIC;
                 signal cpu_instruction_master_requests_epcs_controller_epcs_control_port : OUT STD_LOGIC;
                 signal d1_epcs_controller_epcs_control_port_end_xfer : OUT STD_LOGIC;
                 signal epcs_controller_epcs_control_port_address : OUT STD_LOGIC_VECTOR (8 DOWNTO 0);
                 signal epcs_controller_epcs_control_port_chipselect : OUT STD_LOGIC;
                 signal epcs_controller_epcs_control_port_dataavailable_from_sa : OUT STD_LOGIC;
                 signal epcs_controller_epcs_control_port_endofpacket_from_sa : OUT STD_LOGIC;
                 signal epcs_controller_epcs_control_port_irq_from_sa : OUT STD_LOGIC;
                 signal epcs_controller_epcs_control_port_read_n : OUT STD_LOGIC;
                 signal epcs_controller_epcs_control_port_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal epcs_controller_epcs_control_port_readyfordata_from_sa : OUT STD_LOGIC;
                 signal epcs_controller_epcs_control_port_reset_n : OUT STD_LOGIC;
                 signal epcs_controller_epcs_control_port_write_n : OUT STD_LOGIC;
                 signal epcs_controller_epcs_control_port_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of epcs_controller_epcs_control_port_arbitrator : entity is FALSE;
end entity epcs_controller_epcs_control_port_arbitrator;


architecture europa of epcs_controller_epcs_control_port_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_epcs_controller_epcs_control_port :  STD_LOGIC;
                signal cpu_instruction_master_arbiterlock :  STD_LOGIC;
                signal cpu_instruction_master_continuerequest :  STD_LOGIC;
                signal cpu_instruction_master_saved_grant_epcs_controller_epcs_control_port :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_allgrants :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_allow_new_arb_cycle :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_any_continuerequest :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_arb_addend :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal epcs_controller_epcs_control_port_arb_counter_enable :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal epcs_controller_epcs_control_port_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal epcs_controller_epcs_control_port_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal epcs_controller_epcs_control_port_arb_winner :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal epcs_controller_epcs_control_port_arbitration_holdoff_internal :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_beginbursttransfer_internal :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_begins_xfer :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_chosen_master_double_vector :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal epcs_controller_epcs_control_port_chosen_master_rot_left :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal epcs_controller_epcs_control_port_end_xfer :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_firsttransfer :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_grant_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal epcs_controller_epcs_control_port_in_a_read_cycle :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_in_a_write_cycle :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_master_qreq_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal epcs_controller_epcs_control_port_saved_chosen_master_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal epcs_controller_epcs_control_port_slavearbiterlockenable :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_waits_for_read :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_waits_for_write :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_epcs_controller_epcs_control_port :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_epcs_controller_epcs_control_port :  STD_LOGIC;
                signal internal_cpu_data_master_requests_epcs_controller_epcs_control_port :  STD_LOGIC;
                signal internal_cpu_instruction_master_granted_epcs_controller_epcs_control_port :  STD_LOGIC;
                signal internal_cpu_instruction_master_qualified_request_epcs_controller_epcs_control_port :  STD_LOGIC;
                signal internal_cpu_instruction_master_requests_epcs_controller_epcs_control_port :  STD_LOGIC;
                signal last_cycle_cpu_data_master_granted_slave_epcs_controller_epcs_control_port :  STD_LOGIC;
                signal last_cycle_cpu_instruction_master_granted_slave_epcs_controller_epcs_control_port :  STD_LOGIC;
                signal wait_for_epcs_controller_epcs_control_port_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT epcs_controller_epcs_control_port_end_xfer;
      end if;
    end if;

  end process;

  epcs_controller_epcs_control_port_begins_xfer <= NOT d1_reasons_to_wait AND ((internal_cpu_data_master_qualified_request_epcs_controller_epcs_control_port OR internal_cpu_instruction_master_qualified_request_epcs_controller_epcs_control_port));
  --assign epcs_controller_epcs_control_port_readdata_from_sa = epcs_controller_epcs_control_port_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  epcs_controller_epcs_control_port_readdata_from_sa <= epcs_controller_epcs_control_port_readdata;
  internal_cpu_data_master_requests_epcs_controller_epcs_control_port <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 11) & std_logic_vector'("00000000000")) = std_logic_vector'("000110000000000000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign epcs_controller_epcs_control_port_dataavailable_from_sa = epcs_controller_epcs_control_port_dataavailable so that symbol knows where to group signals which may go to master only, which is an e_assign
  epcs_controller_epcs_control_port_dataavailable_from_sa <= epcs_controller_epcs_control_port_dataavailable;
  --assign epcs_controller_epcs_control_port_readyfordata_from_sa = epcs_controller_epcs_control_port_readyfordata so that symbol knows where to group signals which may go to master only, which is an e_assign
  epcs_controller_epcs_control_port_readyfordata_from_sa <= epcs_controller_epcs_control_port_readyfordata;
  --epcs_controller_epcs_control_port_arb_share_counter set values, which is an e_mux
  epcs_controller_epcs_control_port_arb_share_set_values <= std_logic_vector'("001");
  --epcs_controller_epcs_control_port_arb_share_counter_next_value assignment, which is an e_assign
  epcs_controller_epcs_control_port_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(epcs_controller_epcs_control_port_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (epcs_controller_epcs_control_port_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(epcs_controller_epcs_control_port_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (epcs_controller_epcs_control_port_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --epcs_controller_epcs_control_port_allgrants all slave grants, which is an e_mux
  epcs_controller_epcs_control_port_allgrants <= ((or_reduce(epcs_controller_epcs_control_port_grant_vector) OR or_reduce(epcs_controller_epcs_control_port_grant_vector)) OR or_reduce(epcs_controller_epcs_control_port_grant_vector)) OR or_reduce(epcs_controller_epcs_control_port_grant_vector);
  --epcs_controller_epcs_control_port_end_xfer assignment, which is an e_assign
  epcs_controller_epcs_control_port_end_xfer <= NOT ((epcs_controller_epcs_control_port_waits_for_read OR epcs_controller_epcs_control_port_waits_for_write));
  --epcs_controller_epcs_control_port_arb_share_counter arbitration counter enable, which is an e_assign
  epcs_controller_epcs_control_port_arb_counter_enable <= epcs_controller_epcs_control_port_end_xfer AND epcs_controller_epcs_control_port_allgrants;
  --epcs_controller_epcs_control_port_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      epcs_controller_epcs_control_port_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(epcs_controller_epcs_control_port_arb_counter_enable) = '1' then 
        epcs_controller_epcs_control_port_arb_share_counter <= epcs_controller_epcs_control_port_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --epcs_controller_epcs_control_port_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      epcs_controller_epcs_control_port_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((or_reduce(epcs_controller_epcs_control_port_master_qreq_vector) AND epcs_controller_epcs_control_port_end_xfer)) = '1' then 
        epcs_controller_epcs_control_port_slavearbiterlockenable <= or_reduce(epcs_controller_epcs_control_port_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master epcs_controller/epcs_control_port arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= epcs_controller_epcs_control_port_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --cpu/instruction_master epcs_controller/epcs_control_port arbiterlock, which is an e_assign
  cpu_instruction_master_arbiterlock <= epcs_controller_epcs_control_port_slavearbiterlockenable AND cpu_instruction_master_continuerequest;
  --cpu/instruction_master granted epcs_controller/epcs_control_port last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_instruction_master_granted_slave_epcs_controller_epcs_control_port <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_instruction_master_granted_slave_epcs_controller_epcs_control_port <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_instruction_master_saved_grant_epcs_controller_epcs_control_port) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((epcs_controller_epcs_control_port_arbitration_holdoff_internal OR NOT internal_cpu_instruction_master_requests_epcs_controller_epcs_control_port))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_instruction_master_granted_slave_epcs_controller_epcs_control_port))))));
      end if;
    end if;

  end process;

  --cpu_instruction_master_continuerequest continued request, which is an e_mux
  cpu_instruction_master_continuerequest <= last_cycle_cpu_instruction_master_granted_slave_epcs_controller_epcs_control_port AND internal_cpu_instruction_master_requests_epcs_controller_epcs_control_port;
  --epcs_controller_epcs_control_port_any_continuerequest at least one master continues requesting, which is an e_mux
  epcs_controller_epcs_control_port_any_continuerequest <= cpu_instruction_master_continuerequest OR cpu_data_master_continuerequest;
  internal_cpu_data_master_qualified_request_epcs_controller_epcs_control_port <= internal_cpu_data_master_requests_epcs_controller_epcs_control_port AND NOT (cpu_instruction_master_arbiterlock);
  --epcs_controller_epcs_control_port_writedata mux, which is an e_mux
  epcs_controller_epcs_control_port_writedata <= cpu_data_master_writedata;
  --assign epcs_controller_epcs_control_port_endofpacket_from_sa = epcs_controller_epcs_control_port_endofpacket so that symbol knows where to group signals which may go to master only, which is an e_assign
  epcs_controller_epcs_control_port_endofpacket_from_sa <= epcs_controller_epcs_control_port_endofpacket;
  internal_cpu_instruction_master_requests_epcs_controller_epcs_control_port <= ((to_std_logic(((Std_Logic_Vector'(cpu_instruction_master_address_to_slave(23 DOWNTO 11) & std_logic_vector'("00000000000")) = std_logic_vector'("000110000000000000000000")))) AND (cpu_instruction_master_read))) AND cpu_instruction_master_read;
  --cpu/data_master granted epcs_controller/epcs_control_port last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_data_master_granted_slave_epcs_controller_epcs_control_port <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_data_master_granted_slave_epcs_controller_epcs_control_port <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_data_master_saved_grant_epcs_controller_epcs_control_port) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((epcs_controller_epcs_control_port_arbitration_holdoff_internal OR NOT internal_cpu_data_master_requests_epcs_controller_epcs_control_port))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_data_master_granted_slave_epcs_controller_epcs_control_port))))));
      end if;
    end if;

  end process;

  --cpu_data_master_continuerequest continued request, which is an e_mux
  cpu_data_master_continuerequest <= last_cycle_cpu_data_master_granted_slave_epcs_controller_epcs_control_port AND internal_cpu_data_master_requests_epcs_controller_epcs_control_port;
  internal_cpu_instruction_master_qualified_request_epcs_controller_epcs_control_port <= internal_cpu_instruction_master_requests_epcs_controller_epcs_control_port AND NOT ((((cpu_instruction_master_read AND ((to_std_logic((((std_logic_vector'("000000000000000000000000000000") & (cpu_instruction_master_latency_counter)) /= std_logic_vector'("00000000000000000000000000000000")))) OR (or_reduce(cpu_instruction_master_read_data_valid_sdram_s1_shift_register)))))) OR cpu_data_master_arbiterlock));
  --local readdatavalid cpu_instruction_master_read_data_valid_epcs_controller_epcs_control_port, which is an e_mux
  cpu_instruction_master_read_data_valid_epcs_controller_epcs_control_port <= (internal_cpu_instruction_master_granted_epcs_controller_epcs_control_port AND cpu_instruction_master_read) AND NOT epcs_controller_epcs_control_port_waits_for_read;
  --allow new arb cycle for epcs_controller/epcs_control_port, which is an e_assign
  epcs_controller_epcs_control_port_allow_new_arb_cycle <= NOT cpu_data_master_arbiterlock AND NOT cpu_instruction_master_arbiterlock;
  --cpu/instruction_master assignment into master qualified-requests vector for epcs_controller/epcs_control_port, which is an e_assign
  epcs_controller_epcs_control_port_master_qreq_vector(0) <= internal_cpu_instruction_master_qualified_request_epcs_controller_epcs_control_port;
  --cpu/instruction_master grant epcs_controller/epcs_control_port, which is an e_assign
  internal_cpu_instruction_master_granted_epcs_controller_epcs_control_port <= epcs_controller_epcs_control_port_grant_vector(0);
  --cpu/instruction_master saved-grant epcs_controller/epcs_control_port, which is an e_assign
  cpu_instruction_master_saved_grant_epcs_controller_epcs_control_port <= epcs_controller_epcs_control_port_arb_winner(0) AND internal_cpu_instruction_master_requests_epcs_controller_epcs_control_port;
  --cpu/data_master assignment into master qualified-requests vector for epcs_controller/epcs_control_port, which is an e_assign
  epcs_controller_epcs_control_port_master_qreq_vector(1) <= internal_cpu_data_master_qualified_request_epcs_controller_epcs_control_port;
  --cpu/data_master grant epcs_controller/epcs_control_port, which is an e_assign
  internal_cpu_data_master_granted_epcs_controller_epcs_control_port <= epcs_controller_epcs_control_port_grant_vector(1);
  --cpu/data_master saved-grant epcs_controller/epcs_control_port, which is an e_assign
  cpu_data_master_saved_grant_epcs_controller_epcs_control_port <= epcs_controller_epcs_control_port_arb_winner(1) AND internal_cpu_data_master_requests_epcs_controller_epcs_control_port;
  --epcs_controller/epcs_control_port chosen-master double-vector, which is an e_assign
  epcs_controller_epcs_control_port_chosen_master_double_vector <= A_EXT (((std_logic_vector'("0") & ((epcs_controller_epcs_control_port_master_qreq_vector & epcs_controller_epcs_control_port_master_qreq_vector))) AND (((std_logic_vector'("0") & (Std_Logic_Vector'(NOT epcs_controller_epcs_control_port_master_qreq_vector & NOT epcs_controller_epcs_control_port_master_qreq_vector))) + (std_logic_vector'("000") & (epcs_controller_epcs_control_port_arb_addend))))), 4);
  --stable onehot encoding of arb winner
  epcs_controller_epcs_control_port_arb_winner <= A_WE_StdLogicVector((std_logic'(((epcs_controller_epcs_control_port_allow_new_arb_cycle AND or_reduce(epcs_controller_epcs_control_port_grant_vector)))) = '1'), epcs_controller_epcs_control_port_grant_vector, epcs_controller_epcs_control_port_saved_chosen_master_vector);
  --saved epcs_controller_epcs_control_port_grant_vector, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      epcs_controller_epcs_control_port_saved_chosen_master_vector <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(epcs_controller_epcs_control_port_allow_new_arb_cycle) = '1' then 
        epcs_controller_epcs_control_port_saved_chosen_master_vector <= A_WE_StdLogicVector((std_logic'(or_reduce(epcs_controller_epcs_control_port_grant_vector)) = '1'), epcs_controller_epcs_control_port_grant_vector, epcs_controller_epcs_control_port_saved_chosen_master_vector);
      end if;
    end if;

  end process;

  --onehot encoding of chosen master
  epcs_controller_epcs_control_port_grant_vector <= Std_Logic_Vector'(A_ToStdLogicVector(((epcs_controller_epcs_control_port_chosen_master_double_vector(1) OR epcs_controller_epcs_control_port_chosen_master_double_vector(3)))) & A_ToStdLogicVector(((epcs_controller_epcs_control_port_chosen_master_double_vector(0) OR epcs_controller_epcs_control_port_chosen_master_double_vector(2)))));
  --epcs_controller/epcs_control_port chosen master rotated left, which is an e_assign
  epcs_controller_epcs_control_port_chosen_master_rot_left <= A_EXT (A_WE_StdLogicVector((((A_SLL(epcs_controller_epcs_control_port_arb_winner,std_logic_vector'("00000000000000000000000000000001")))) /= std_logic_vector'("00")), (std_logic_vector'("000000000000000000000000000000") & ((A_SLL(epcs_controller_epcs_control_port_arb_winner,std_logic_vector'("00000000000000000000000000000001"))))), std_logic_vector'("00000000000000000000000000000001")), 2);
  --epcs_controller/epcs_control_port's addend for next-master-grant
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      epcs_controller_epcs_control_port_arb_addend <= std_logic_vector'("01");
    elsif clk'event and clk = '1' then
      if std_logic'(or_reduce(epcs_controller_epcs_control_port_grant_vector)) = '1' then 
        epcs_controller_epcs_control_port_arb_addend <= A_WE_StdLogicVector((std_logic'(epcs_controller_epcs_control_port_end_xfer) = '1'), epcs_controller_epcs_control_port_chosen_master_rot_left, epcs_controller_epcs_control_port_grant_vector);
      end if;
    end if;

  end process;

  --epcs_controller_epcs_control_port_reset_n assignment, which is an e_assign
  epcs_controller_epcs_control_port_reset_n <= reset_n;
  epcs_controller_epcs_control_port_chipselect <= internal_cpu_data_master_granted_epcs_controller_epcs_control_port OR internal_cpu_instruction_master_granted_epcs_controller_epcs_control_port;
  --epcs_controller_epcs_control_port_firsttransfer first transaction, which is an e_assign
  epcs_controller_epcs_control_port_firsttransfer <= NOT ((epcs_controller_epcs_control_port_slavearbiterlockenable AND epcs_controller_epcs_control_port_any_continuerequest));
  --epcs_controller_epcs_control_port_beginbursttransfer_internal begin burst transfer, which is an e_assign
  epcs_controller_epcs_control_port_beginbursttransfer_internal <= epcs_controller_epcs_control_port_begins_xfer AND epcs_controller_epcs_control_port_firsttransfer;
  --epcs_controller_epcs_control_port_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  epcs_controller_epcs_control_port_arbitration_holdoff_internal <= epcs_controller_epcs_control_port_begins_xfer AND epcs_controller_epcs_control_port_firsttransfer;
  --~epcs_controller_epcs_control_port_read_n assignment, which is an e_mux
  epcs_controller_epcs_control_port_read_n <= NOT ((((internal_cpu_data_master_granted_epcs_controller_epcs_control_port AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_epcs_controller_epcs_control_port AND cpu_instruction_master_read))));
  --~epcs_controller_epcs_control_port_write_n assignment, which is an e_mux
  epcs_controller_epcs_control_port_write_n <= NOT ((internal_cpu_data_master_granted_epcs_controller_epcs_control_port AND cpu_data_master_write));
  --epcs_controller_epcs_control_port_address mux, which is an e_mux
  epcs_controller_epcs_control_port_address <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_epcs_controller_epcs_control_port)) = '1'), (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010"))), (A_SRL(cpu_instruction_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")))), 9);
  --d1_epcs_controller_epcs_control_port_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_epcs_controller_epcs_control_port_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_epcs_controller_epcs_control_port_end_xfer <= epcs_controller_epcs_control_port_end_xfer;
      end if;
    end if;

  end process;

  --epcs_controller_epcs_control_port_waits_for_read in a cycle, which is an e_mux
  epcs_controller_epcs_control_port_waits_for_read <= epcs_controller_epcs_control_port_in_a_read_cycle AND epcs_controller_epcs_control_port_begins_xfer;
  --epcs_controller_epcs_control_port_in_a_read_cycle assignment, which is an e_assign
  epcs_controller_epcs_control_port_in_a_read_cycle <= ((internal_cpu_data_master_granted_epcs_controller_epcs_control_port AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_epcs_controller_epcs_control_port AND cpu_instruction_master_read));
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= epcs_controller_epcs_control_port_in_a_read_cycle;
  --epcs_controller_epcs_control_port_waits_for_write in a cycle, which is an e_mux
  epcs_controller_epcs_control_port_waits_for_write <= epcs_controller_epcs_control_port_in_a_write_cycle AND epcs_controller_epcs_control_port_begins_xfer;
  --epcs_controller_epcs_control_port_in_a_write_cycle assignment, which is an e_assign
  epcs_controller_epcs_control_port_in_a_write_cycle <= internal_cpu_data_master_granted_epcs_controller_epcs_control_port AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= epcs_controller_epcs_control_port_in_a_write_cycle;
  wait_for_epcs_controller_epcs_control_port_counter <= std_logic'('0');
  --assign epcs_controller_epcs_control_port_irq_from_sa = epcs_controller_epcs_control_port_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  epcs_controller_epcs_control_port_irq_from_sa <= epcs_controller_epcs_control_port_irq;
  --vhdl renameroo for output signals
  cpu_data_master_granted_epcs_controller_epcs_control_port <= internal_cpu_data_master_granted_epcs_controller_epcs_control_port;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_epcs_controller_epcs_control_port <= internal_cpu_data_master_qualified_request_epcs_controller_epcs_control_port;
  --vhdl renameroo for output signals
  cpu_data_master_requests_epcs_controller_epcs_control_port <= internal_cpu_data_master_requests_epcs_controller_epcs_control_port;
  --vhdl renameroo for output signals
  cpu_instruction_master_granted_epcs_controller_epcs_control_port <= internal_cpu_instruction_master_granted_epcs_controller_epcs_control_port;
  --vhdl renameroo for output signals
  cpu_instruction_master_qualified_request_epcs_controller_epcs_control_port <= internal_cpu_instruction_master_qualified_request_epcs_controller_epcs_control_port;
  --vhdl renameroo for output signals
  cpu_instruction_master_requests_epcs_controller_epcs_control_port <= internal_cpu_instruction_master_requests_epcs_controller_epcs_control_port;
--synthesis translate_off
    --grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line4 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_data_master_granted_epcs_controller_epcs_control_port))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_instruction_master_granted_epcs_controller_epcs_control_port))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line4, now);
          write(write_line4, string'(": "));
          write(write_line4, string'("> 1 of grant signals are active simultaneously"));
          write(output, write_line4.all);
          deallocate (write_line4);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --saved_grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line5 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_data_master_saved_grant_epcs_controller_epcs_control_port))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_saved_grant_epcs_controller_epcs_control_port))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line5, now);
          write(write_line5, string'(": "));
          write(write_line5, string'("> 1 of saved_grant signals are active simultaneously"));
          write(output, write_line5.all);
          deallocate (write_line5);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity ext_bus_avalon_slave_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_dbs_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_dbs_write_8 : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal cpu_data_master_no_byte_enables_and_last_term : IN STD_LOGIC;
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_instruction_master_dbs_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_sdram_s1_shift_register : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_byteenable_flash_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_granted_flash_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_flash_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_flash_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_flash_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_granted_flash_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_flash_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_flash_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_requests_flash_s1 : OUT STD_LOGIC;
                 signal d1_ext_bus_avalon_slave_end_xfer : OUT STD_LOGIC;
                 signal ext_bus_address : OUT STD_LOGIC_VECTOR (19 DOWNTO 0);
                 signal ext_bus_data : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal ext_bus_readn : OUT STD_LOGIC;
                 signal flash_s1_wait_counter_eq_0 : OUT STD_LOGIC;
                 signal flash_s1_wait_counter_eq_1 : OUT STD_LOGIC;
                 signal incoming_ext_bus_data : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal incoming_ext_bus_data_with_Xs_converted_to_0 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal registered_cpu_data_master_read_data_valid_flash_s1 : OUT STD_LOGIC;
                 signal select_n_to_the_flash : OUT STD_LOGIC;
                 signal write_n_to_the_flash : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of ext_bus_avalon_slave_arbitrator : entity is FALSE;
end entity ext_bus_avalon_slave_arbitrator;


architecture europa of ext_bus_avalon_slave_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_byteenable_flash_s1_segment_0 :  STD_LOGIC;
                signal cpu_data_master_byteenable_flash_s1_segment_1 :  STD_LOGIC;
                signal cpu_data_master_byteenable_flash_s1_segment_2 :  STD_LOGIC;
                signal cpu_data_master_byteenable_flash_s1_segment_3 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_flash_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_read_data_valid_flash_s1_shift_register_in :  STD_LOGIC;
                signal cpu_data_master_saved_grant_flash_s1 :  STD_LOGIC;
                signal cpu_instruction_master_arbiterlock :  STD_LOGIC;
                signal cpu_instruction_master_continuerequest :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_flash_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_instruction_master_read_data_valid_flash_s1_shift_register_in :  STD_LOGIC;
                signal cpu_instruction_master_saved_grant_flash_s1 :  STD_LOGIC;
                signal d1_in_a_write_cycle :  STD_LOGIC;
                signal d1_outgoing_ext_bus_data :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal ext_bus_avalon_slave_allgrants :  STD_LOGIC;
                signal ext_bus_avalon_slave_allow_new_arb_cycle :  STD_LOGIC;
                signal ext_bus_avalon_slave_any_continuerequest :  STD_LOGIC;
                signal ext_bus_avalon_slave_arb_addend :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal ext_bus_avalon_slave_arb_counter_enable :  STD_LOGIC;
                signal ext_bus_avalon_slave_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal ext_bus_avalon_slave_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal ext_bus_avalon_slave_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal ext_bus_avalon_slave_arb_winner :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal ext_bus_avalon_slave_arbitration_holdoff_internal :  STD_LOGIC;
                signal ext_bus_avalon_slave_beginbursttransfer_internal :  STD_LOGIC;
                signal ext_bus_avalon_slave_begins_xfer :  STD_LOGIC;
                signal ext_bus_avalon_slave_chosen_master_double_vector :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal ext_bus_avalon_slave_chosen_master_rot_left :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal ext_bus_avalon_slave_end_xfer :  STD_LOGIC;
                signal ext_bus_avalon_slave_firsttransfer :  STD_LOGIC;
                signal ext_bus_avalon_slave_grant_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal ext_bus_avalon_slave_master_qreq_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal ext_bus_avalon_slave_read_pending :  STD_LOGIC;
                signal ext_bus_avalon_slave_saved_chosen_master_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal ext_bus_avalon_slave_slavearbiterlockenable :  STD_LOGIC;
                signal ext_bus_avalon_slave_write_pending :  STD_LOGIC;
                signal flash_s1_counter_load_value :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal flash_s1_in_a_read_cycle :  STD_LOGIC;
                signal flash_s1_in_a_write_cycle :  STD_LOGIC;
                signal flash_s1_pretend_byte_enable :  STD_LOGIC;
                signal flash_s1_wait_counter :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal flash_s1_waits_for_read :  STD_LOGIC;
                signal flash_s1_waits_for_write :  STD_LOGIC;
                signal flash_s1_with_write_latency :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal incoming_ext_bus_data_bit_0_is_x :  STD_LOGIC;
                signal incoming_ext_bus_data_bit_1_is_x :  STD_LOGIC;
                signal incoming_ext_bus_data_bit_2_is_x :  STD_LOGIC;
                signal incoming_ext_bus_data_bit_3_is_x :  STD_LOGIC;
                signal incoming_ext_bus_data_bit_4_is_x :  STD_LOGIC;
                signal incoming_ext_bus_data_bit_5_is_x :  STD_LOGIC;
                signal incoming_ext_bus_data_bit_6_is_x :  STD_LOGIC;
                signal incoming_ext_bus_data_bit_7_is_x :  STD_LOGIC;
                signal internal_cpu_data_master_byteenable_flash_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_granted_flash_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_flash_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_flash_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_granted_flash_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_qualified_request_flash_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_requests_flash_s1 :  STD_LOGIC;
                signal internal_flash_s1_wait_counter_eq_0 :  STD_LOGIC;
                signal internal_incoming_ext_bus_data :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal last_cycle_cpu_data_master_granted_slave_flash_s1 :  STD_LOGIC;
                signal last_cycle_cpu_instruction_master_granted_slave_flash_s1 :  STD_LOGIC;
                signal outgoing_ext_bus_data :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal p1_cpu_data_master_read_data_valid_flash_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_cpu_instruction_master_read_data_valid_flash_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_ext_bus_address :  STD_LOGIC_VECTOR (19 DOWNTO 0);
                signal p1_ext_bus_readn :  STD_LOGIC;
                signal p1_select_n_to_the_flash :  STD_LOGIC;
                signal p1_write_n_to_the_flash :  STD_LOGIC;
                signal time_to_write :  STD_LOGIC;
                signal wait_for_flash_s1_counter :  STD_LOGIC;
attribute ALTERA_ATTRIBUTE : string;
attribute ALTERA_ATTRIBUTE of d1_in_a_write_cycle : signal is "FAST_OUTPUT_ENABLE_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of d1_outgoing_ext_bus_data : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of ext_bus_address : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of ext_bus_readn : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of internal_incoming_ext_bus_data : signal is "FAST_INPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of select_n_to_the_flash : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of write_n_to_the_flash : signal is "FAST_OUTPUT_REGISTER=ON";

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT ext_bus_avalon_slave_end_xfer;
      end if;
    end if;

  end process;

  ext_bus_avalon_slave_begins_xfer <= NOT d1_reasons_to_wait AND ((internal_cpu_data_master_qualified_request_flash_s1 OR internal_cpu_instruction_master_qualified_request_flash_s1));
  internal_cpu_data_master_requests_flash_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 20) & std_logic_vector'("00000000000000000000")) = std_logic_vector'("000000000000000000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --~select_n_to_the_flash of type chipselect to ~p1_select_n_to_the_flash, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      select_n_to_the_flash <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        select_n_to_the_flash <= p1_select_n_to_the_flash;
      end if;
    end if;

  end process;

  ext_bus_avalon_slave_write_pending <= std_logic'('0');
  --registered rdv signal_name registered_cpu_data_master_read_data_valid_flash_s1 assignment, which is an e_assign
  registered_cpu_data_master_read_data_valid_flash_s1 <= cpu_data_master_read_data_valid_flash_s1_shift_register(0);
  ext_bus_avalon_slave_read_pending <= std_logic'('0');
  --ext_bus_avalon_slave_arb_share_counter set values, which is an e_mux
  ext_bus_avalon_slave_arb_share_set_values <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_flash_s1)) = '1'), std_logic_vector'("00000000000000000000000000000100"), A_WE_StdLogicVector((std_logic'((internal_cpu_instruction_master_granted_flash_s1)) = '1'), std_logic_vector'("00000000000000000000000000000100"), A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_flash_s1)) = '1'), std_logic_vector'("00000000000000000000000000000100"), A_WE_StdLogicVector((std_logic'((internal_cpu_instruction_master_granted_flash_s1)) = '1'), std_logic_vector'("00000000000000000000000000000100"), std_logic_vector'("00000000000000000000000000000001"))))), 3);
  --ext_bus_avalon_slave_arb_share_counter_next_value assignment, which is an e_assign
  ext_bus_avalon_slave_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(ext_bus_avalon_slave_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (ext_bus_avalon_slave_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(ext_bus_avalon_slave_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (ext_bus_avalon_slave_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --ext_bus_avalon_slave_allgrants all slave grants, which is an e_mux
  ext_bus_avalon_slave_allgrants <= ((or_reduce(ext_bus_avalon_slave_grant_vector) OR or_reduce(ext_bus_avalon_slave_grant_vector)) OR or_reduce(ext_bus_avalon_slave_grant_vector)) OR or_reduce(ext_bus_avalon_slave_grant_vector);
  --ext_bus_avalon_slave_end_xfer assignment, which is an e_assign
  ext_bus_avalon_slave_end_xfer <= NOT ((flash_s1_waits_for_read OR flash_s1_waits_for_write));
  --ext_bus_avalon_slave_arb_share_counter arbitration counter enable, which is an e_assign
  ext_bus_avalon_slave_arb_counter_enable <= ext_bus_avalon_slave_end_xfer AND ext_bus_avalon_slave_allgrants;
  --ext_bus_avalon_slave_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      ext_bus_avalon_slave_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(ext_bus_avalon_slave_arb_counter_enable) = '1' then 
        ext_bus_avalon_slave_arb_share_counter <= ext_bus_avalon_slave_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --ext_bus_avalon_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      ext_bus_avalon_slave_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((or_reduce(ext_bus_avalon_slave_master_qreq_vector) AND ext_bus_avalon_slave_end_xfer)) = '1' then 
        ext_bus_avalon_slave_slavearbiterlockenable <= or_reduce(ext_bus_avalon_slave_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master ext_bus/avalon_slave arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= ext_bus_avalon_slave_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --cpu/instruction_master ext_bus/avalon_slave arbiterlock, which is an e_assign
  cpu_instruction_master_arbiterlock <= ext_bus_avalon_slave_slavearbiterlockenable AND cpu_instruction_master_continuerequest;
  --cpu/instruction_master granted flash/s1 last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_instruction_master_granted_slave_flash_s1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_instruction_master_granted_slave_flash_s1 <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_instruction_master_saved_grant_flash_s1) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((ext_bus_avalon_slave_arbitration_holdoff_internal OR NOT internal_cpu_instruction_master_requests_flash_s1))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_instruction_master_granted_slave_flash_s1))))));
      end if;
    end if;

  end process;

  --cpu_instruction_master_continuerequest continued request, which is an e_mux
  cpu_instruction_master_continuerequest <= last_cycle_cpu_instruction_master_granted_slave_flash_s1 AND internal_cpu_instruction_master_requests_flash_s1;
  --ext_bus_avalon_slave_any_continuerequest at least one master continues requesting, which is an e_mux
  ext_bus_avalon_slave_any_continuerequest <= cpu_instruction_master_continuerequest OR cpu_data_master_continuerequest;
  internal_cpu_data_master_qualified_request_flash_s1 <= internal_cpu_data_master_requests_flash_s1 AND NOT (((((cpu_data_master_read AND ((ext_bus_avalon_slave_write_pending OR (or_reduce(cpu_data_master_read_data_valid_flash_s1_shift_register)))))) OR (((((ext_bus_avalon_slave_read_pending OR cpu_data_master_no_byte_enables_and_last_term) OR NOT(internal_cpu_data_master_byteenable_flash_s1))) AND cpu_data_master_write))) OR cpu_instruction_master_arbiterlock));
  --cpu_data_master_read_data_valid_flash_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_data_master_read_data_valid_flash_s1_shift_register_in <= ((internal_cpu_data_master_granted_flash_s1 AND cpu_data_master_read) AND NOT flash_s1_waits_for_read) AND NOT (or_reduce(cpu_data_master_read_data_valid_flash_s1_shift_register));
  --shift register p1 cpu_data_master_read_data_valid_flash_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_data_master_read_data_valid_flash_s1_shift_register <= A_EXT ((cpu_data_master_read_data_valid_flash_s1_shift_register & A_ToStdLogicVector(cpu_data_master_read_data_valid_flash_s1_shift_register_in)), 2);
  --cpu_data_master_read_data_valid_flash_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_data_master_read_data_valid_flash_s1_shift_register <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        cpu_data_master_read_data_valid_flash_s1_shift_register <= p1_cpu_data_master_read_data_valid_flash_s1_shift_register;
      end if;
    end if;

  end process;

  --local readdatavalid cpu_data_master_read_data_valid_flash_s1, which is an e_mux
  cpu_data_master_read_data_valid_flash_s1 <= cpu_data_master_read_data_valid_flash_s1_shift_register(1);
  --ext_bus_data register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_incoming_ext_bus_data <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        internal_incoming_ext_bus_data <= ext_bus_data;
      end if;
    end if;

  end process;

  --flash_s1_with_write_latency assignment, which is an e_assign
  flash_s1_with_write_latency <= in_a_write_cycle AND ((internal_cpu_data_master_qualified_request_flash_s1 OR internal_cpu_instruction_master_qualified_request_flash_s1));
  --time to write the data, which is an e_mux
  time_to_write <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'((flash_s1_with_write_latency)) = '1'), std_logic_vector'("00000000000000000000000000000001"), std_logic_vector'("00000000000000000000000000000000")));
  --d1_outgoing_ext_bus_data register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_outgoing_ext_bus_data <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_outgoing_ext_bus_data <= outgoing_ext_bus_data;
      end if;
    end if;

  end process;

  --write cycle delayed by 1, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_in_a_write_cycle <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_in_a_write_cycle <= time_to_write;
      end if;
    end if;

  end process;

  --d1_outgoing_ext_bus_data tristate driver, which is an e_assign
  ext_bus_data <= A_WE_StdLogicVector((std_logic'((d1_in_a_write_cycle)) = '1'), d1_outgoing_ext_bus_data, A_REP(std_logic'('Z'), 8));
  --outgoing_ext_bus_data mux, which is an e_mux
  outgoing_ext_bus_data <= cpu_data_master_dbs_write_8;
  internal_cpu_instruction_master_requests_flash_s1 <= ((to_std_logic(((Std_Logic_Vector'(cpu_instruction_master_address_to_slave(23 DOWNTO 20) & std_logic_vector'("00000000000000000000")) = std_logic_vector'("000000000000000000000000")))) AND (cpu_instruction_master_read))) AND cpu_instruction_master_read;
  --cpu/data_master granted flash/s1 last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_data_master_granted_slave_flash_s1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_data_master_granted_slave_flash_s1 <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_data_master_saved_grant_flash_s1) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((ext_bus_avalon_slave_arbitration_holdoff_internal OR NOT internal_cpu_data_master_requests_flash_s1))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_data_master_granted_slave_flash_s1))))));
      end if;
    end if;

  end process;

  --cpu_data_master_continuerequest continued request, which is an e_mux
  cpu_data_master_continuerequest <= last_cycle_cpu_data_master_granted_slave_flash_s1 AND internal_cpu_data_master_requests_flash_s1;
  internal_cpu_instruction_master_qualified_request_flash_s1 <= internal_cpu_instruction_master_requests_flash_s1 AND NOT ((((cpu_instruction_master_read AND (((ext_bus_avalon_slave_write_pending OR to_std_logic(((std_logic_vector'("00000000000000000000000000000010")<(std_logic_vector'("000000000000000000000000000000") & (cpu_instruction_master_latency_counter)))))) OR (or_reduce(cpu_instruction_master_read_data_valid_sdram_s1_shift_register)))))) OR cpu_data_master_arbiterlock));
  --cpu_instruction_master_read_data_valid_flash_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_instruction_master_read_data_valid_flash_s1_shift_register_in <= (internal_cpu_instruction_master_granted_flash_s1 AND cpu_instruction_master_read) AND NOT flash_s1_waits_for_read;
  --shift register p1 cpu_instruction_master_read_data_valid_flash_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_instruction_master_read_data_valid_flash_s1_shift_register <= A_EXT ((cpu_instruction_master_read_data_valid_flash_s1_shift_register & A_ToStdLogicVector(cpu_instruction_master_read_data_valid_flash_s1_shift_register_in)), 2);
  --cpu_instruction_master_read_data_valid_flash_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_instruction_master_read_data_valid_flash_s1_shift_register <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        cpu_instruction_master_read_data_valid_flash_s1_shift_register <= p1_cpu_instruction_master_read_data_valid_flash_s1_shift_register;
      end if;
    end if;

  end process;

  --local readdatavalid cpu_instruction_master_read_data_valid_flash_s1, which is an e_mux
  cpu_instruction_master_read_data_valid_flash_s1 <= cpu_instruction_master_read_data_valid_flash_s1_shift_register(1);
  --allow new arb cycle for ext_bus/avalon_slave, which is an e_assign
  ext_bus_avalon_slave_allow_new_arb_cycle <= NOT cpu_data_master_arbiterlock AND NOT cpu_instruction_master_arbiterlock;
  --cpu/instruction_master assignment into master qualified-requests vector for flash/s1, which is an e_assign
  ext_bus_avalon_slave_master_qreq_vector(0) <= internal_cpu_instruction_master_qualified_request_flash_s1;
  --cpu/instruction_master grant flash/s1, which is an e_assign
  internal_cpu_instruction_master_granted_flash_s1 <= ext_bus_avalon_slave_grant_vector(0);
  --cpu/instruction_master saved-grant flash/s1, which is an e_assign
  cpu_instruction_master_saved_grant_flash_s1 <= ext_bus_avalon_slave_arb_winner(0) AND internal_cpu_instruction_master_requests_flash_s1;
  --cpu/data_master assignment into master qualified-requests vector for flash/s1, which is an e_assign
  ext_bus_avalon_slave_master_qreq_vector(1) <= internal_cpu_data_master_qualified_request_flash_s1;
  --cpu/data_master grant flash/s1, which is an e_assign
  internal_cpu_data_master_granted_flash_s1 <= ext_bus_avalon_slave_grant_vector(1);
  --cpu/data_master saved-grant flash/s1, which is an e_assign
  cpu_data_master_saved_grant_flash_s1 <= ext_bus_avalon_slave_arb_winner(1) AND internal_cpu_data_master_requests_flash_s1;
  --ext_bus/avalon_slave chosen-master double-vector, which is an e_assign
  ext_bus_avalon_slave_chosen_master_double_vector <= A_EXT (((std_logic_vector'("0") & ((ext_bus_avalon_slave_master_qreq_vector & ext_bus_avalon_slave_master_qreq_vector))) AND (((std_logic_vector'("0") & (Std_Logic_Vector'(NOT ext_bus_avalon_slave_master_qreq_vector & NOT ext_bus_avalon_slave_master_qreq_vector))) + (std_logic_vector'("000") & (ext_bus_avalon_slave_arb_addend))))), 4);
  --stable onehot encoding of arb winner
  ext_bus_avalon_slave_arb_winner <= A_WE_StdLogicVector((std_logic'(((ext_bus_avalon_slave_allow_new_arb_cycle AND or_reduce(ext_bus_avalon_slave_grant_vector)))) = '1'), ext_bus_avalon_slave_grant_vector, ext_bus_avalon_slave_saved_chosen_master_vector);
  --saved ext_bus_avalon_slave_grant_vector, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      ext_bus_avalon_slave_saved_chosen_master_vector <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(ext_bus_avalon_slave_allow_new_arb_cycle) = '1' then 
        ext_bus_avalon_slave_saved_chosen_master_vector <= A_WE_StdLogicVector((std_logic'(or_reduce(ext_bus_avalon_slave_grant_vector)) = '1'), ext_bus_avalon_slave_grant_vector, ext_bus_avalon_slave_saved_chosen_master_vector);
      end if;
    end if;

  end process;

  --onehot encoding of chosen master
  ext_bus_avalon_slave_grant_vector <= Std_Logic_Vector'(A_ToStdLogicVector(((ext_bus_avalon_slave_chosen_master_double_vector(1) OR ext_bus_avalon_slave_chosen_master_double_vector(3)))) & A_ToStdLogicVector(((ext_bus_avalon_slave_chosen_master_double_vector(0) OR ext_bus_avalon_slave_chosen_master_double_vector(2)))));
  --ext_bus/avalon_slave chosen master rotated left, which is an e_assign
  ext_bus_avalon_slave_chosen_master_rot_left <= A_EXT (A_WE_StdLogicVector((((A_SLL(ext_bus_avalon_slave_arb_winner,std_logic_vector'("00000000000000000000000000000001")))) /= std_logic_vector'("00")), (std_logic_vector'("000000000000000000000000000000") & ((A_SLL(ext_bus_avalon_slave_arb_winner,std_logic_vector'("00000000000000000000000000000001"))))), std_logic_vector'("00000000000000000000000000000001")), 2);
  --ext_bus/avalon_slave's addend for next-master-grant
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      ext_bus_avalon_slave_arb_addend <= std_logic_vector'("01");
    elsif clk'event and clk = '1' then
      if std_logic'(or_reduce(ext_bus_avalon_slave_grant_vector)) = '1' then 
        ext_bus_avalon_slave_arb_addend <= A_WE_StdLogicVector((std_logic'(ext_bus_avalon_slave_end_xfer) = '1'), ext_bus_avalon_slave_chosen_master_rot_left, ext_bus_avalon_slave_grant_vector);
      end if;
    end if;

  end process;

  p1_select_n_to_the_flash <= NOT ((internal_cpu_data_master_granted_flash_s1 OR internal_cpu_instruction_master_granted_flash_s1));
  --ext_bus_avalon_slave_firsttransfer first transaction, which is an e_assign
  ext_bus_avalon_slave_firsttransfer <= NOT ((ext_bus_avalon_slave_slavearbiterlockenable AND ext_bus_avalon_slave_any_continuerequest));
  --ext_bus_avalon_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  ext_bus_avalon_slave_beginbursttransfer_internal <= ext_bus_avalon_slave_begins_xfer AND ext_bus_avalon_slave_firsttransfer;
  --ext_bus_avalon_slave_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  ext_bus_avalon_slave_arbitration_holdoff_internal <= ext_bus_avalon_slave_begins_xfer AND ext_bus_avalon_slave_firsttransfer;
  --~ext_bus_readn of type read to ~p1_ext_bus_readn, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      ext_bus_readn <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        ext_bus_readn <= p1_ext_bus_readn;
      end if;
    end if;

  end process;

  --~write_n_to_the_flash of type write to ~p1_write_n_to_the_flash, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      write_n_to_the_flash <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        write_n_to_the_flash <= p1_write_n_to_the_flash;
      end if;
    end if;

  end process;

  --~p1_ext_bus_readn assignment, which is an e_mux
  p1_ext_bus_readn <= NOT (((((((internal_cpu_data_master_granted_flash_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_flash_s1 AND cpu_instruction_master_read)))) AND NOT ext_bus_avalon_slave_begins_xfer) AND to_std_logic((((std_logic_vector'("0000000000000000000000000000") & (flash_s1_wait_counter))<std_logic_vector'("00000000000000000000000000001000"))))));
  --~p1_write_n_to_the_flash assignment, which is an e_mux
  p1_write_n_to_the_flash <= NOT (((((((internal_cpu_data_master_granted_flash_s1 AND cpu_data_master_write)) AND NOT ext_bus_avalon_slave_begins_xfer) AND to_std_logic((((std_logic_vector'("0000000000000000000000000000") & (flash_s1_wait_counter))>=std_logic_vector'("00000000000000000000000000000010"))))) AND to_std_logic((((std_logic_vector'("0000000000000000000000000000") & (flash_s1_wait_counter))<std_logic_vector'("00000000000000000000000000001010"))))) AND flash_s1_pretend_byte_enable));
  --ext_bus_address of type address to p1_ext_bus_address, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      ext_bus_address <= std_logic_vector'("00000000000000000000");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        ext_bus_address <= p1_ext_bus_address;
      end if;
    end if;

  end process;

  --p1_ext_bus_address mux, which is an e_mux
  p1_ext_bus_address <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_flash_s1)) = '1'), (Std_Logic_Vector'(A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")) & cpu_data_master_dbs_address(1 DOWNTO 0))), (Std_Logic_Vector'(A_SRL(cpu_instruction_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")) & cpu_instruction_master_dbs_address(1 DOWNTO 0)))), 20);
  --d1_ext_bus_avalon_slave_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_ext_bus_avalon_slave_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_ext_bus_avalon_slave_end_xfer <= ext_bus_avalon_slave_end_xfer;
      end if;
    end if;

  end process;

  --flash_s1_wait_counter_eq_1 assignment, which is an e_assign
  flash_s1_wait_counter_eq_1 <= to_std_logic(((std_logic_vector'("0000000000000000000000000000") & (flash_s1_wait_counter)) = std_logic_vector'("00000000000000000000000000000001")));
  --flash_s1_waits_for_read in a cycle, which is an e_mux
  flash_s1_waits_for_read <= flash_s1_in_a_read_cycle AND wait_for_flash_s1_counter;
  --flash_s1_in_a_read_cycle assignment, which is an e_assign
  flash_s1_in_a_read_cycle <= ((internal_cpu_data_master_granted_flash_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_flash_s1 AND cpu_instruction_master_read));
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= flash_s1_in_a_read_cycle;
  --flash_s1_waits_for_write in a cycle, which is an e_mux
  flash_s1_waits_for_write <= flash_s1_in_a_write_cycle AND wait_for_flash_s1_counter;
  --flash_s1_in_a_write_cycle assignment, which is an e_assign
  flash_s1_in_a_write_cycle <= internal_cpu_data_master_granted_flash_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= flash_s1_in_a_write_cycle;
  internal_flash_s1_wait_counter_eq_0 <= to_std_logic(((std_logic_vector'("0000000000000000000000000000") & (flash_s1_wait_counter)) = std_logic_vector'("00000000000000000000000000000000")));
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      flash_s1_wait_counter <= std_logic_vector'("0000");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        flash_s1_wait_counter <= flash_s1_counter_load_value;
      end if;
    end if;

  end process;

  flash_s1_counter_load_value <= A_EXT (A_WE_StdLogicVector((std_logic'(((flash_s1_in_a_write_cycle AND ext_bus_avalon_slave_begins_xfer))) = '1'), std_logic_vector'("000000000000000000000000000001010"), A_WE_StdLogicVector((std_logic'(((flash_s1_in_a_read_cycle AND ext_bus_avalon_slave_begins_xfer))) = '1'), std_logic_vector'("000000000000000000000000000001000"), A_WE_StdLogicVector((std_logic'((NOT internal_flash_s1_wait_counter_eq_0)) = '1'), ((std_logic_vector'("00000000000000000000000000000") & (flash_s1_wait_counter)) - std_logic_vector'("000000000000000000000000000000001")), std_logic_vector'("000000000000000000000000000000000")))), 4);
  wait_for_flash_s1_counter <= ext_bus_avalon_slave_begins_xfer OR NOT internal_flash_s1_wait_counter_eq_0;
  --flash_s1_pretend_byte_enable byte enable port mux, which is an e_mux
  flash_s1_pretend_byte_enable <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_flash_s1)) = '1'), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(internal_cpu_data_master_byteenable_flash_s1))), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))));
  (cpu_data_master_byteenable_flash_s1_segment_3, cpu_data_master_byteenable_flash_s1_segment_2, cpu_data_master_byteenable_flash_s1_segment_1, cpu_data_master_byteenable_flash_s1_segment_0) <= cpu_data_master_byteenable;
  internal_cpu_data_master_byteenable_flash_s1 <= A_WE_StdLogic((((std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_dbs_address(1 DOWNTO 0))) = std_logic_vector'("00000000000000000000000000000000"))), cpu_data_master_byteenable_flash_s1_segment_0, A_WE_StdLogic((((std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_dbs_address(1 DOWNTO 0))) = std_logic_vector'("00000000000000000000000000000001"))), cpu_data_master_byteenable_flash_s1_segment_1, A_WE_StdLogic((((std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_dbs_address(1 DOWNTO 0))) = std_logic_vector'("00000000000000000000000000000010"))), cpu_data_master_byteenable_flash_s1_segment_2, cpu_data_master_byteenable_flash_s1_segment_3)));
  --vhdl renameroo for output signals
  cpu_data_master_byteenable_flash_s1 <= internal_cpu_data_master_byteenable_flash_s1;
  --vhdl renameroo for output signals
  cpu_data_master_granted_flash_s1 <= internal_cpu_data_master_granted_flash_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_flash_s1 <= internal_cpu_data_master_qualified_request_flash_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_flash_s1 <= internal_cpu_data_master_requests_flash_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_granted_flash_s1 <= internal_cpu_instruction_master_granted_flash_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_qualified_request_flash_s1 <= internal_cpu_instruction_master_qualified_request_flash_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_requests_flash_s1 <= internal_cpu_instruction_master_requests_flash_s1;
  --vhdl renameroo for output signals
  flash_s1_wait_counter_eq_0 <= internal_flash_s1_wait_counter_eq_0;
  --vhdl renameroo for output signals
  incoming_ext_bus_data <= internal_incoming_ext_bus_data;
--synthesis translate_off
    --incoming_ext_bus_data_bit_0_is_x x check, which is an e_assign_is_x
    incoming_ext_bus_data_bit_0_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_ext_bus_data(0))), '1','0');
    --Crush incoming_ext_bus_data_with_Xs_converted_to_0[0] Xs to 0, which is an e_assign
    incoming_ext_bus_data_with_Xs_converted_to_0(0) <= A_WE_StdLogic((std_logic'(incoming_ext_bus_data_bit_0_is_x) = '1'), std_logic'('0'), internal_incoming_ext_bus_data(0));
    --incoming_ext_bus_data_bit_1_is_x x check, which is an e_assign_is_x
    incoming_ext_bus_data_bit_1_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_ext_bus_data(1))), '1','0');
    --Crush incoming_ext_bus_data_with_Xs_converted_to_0[1] Xs to 0, which is an e_assign
    incoming_ext_bus_data_with_Xs_converted_to_0(1) <= A_WE_StdLogic((std_logic'(incoming_ext_bus_data_bit_1_is_x) = '1'), std_logic'('0'), internal_incoming_ext_bus_data(1));
    --incoming_ext_bus_data_bit_2_is_x x check, which is an e_assign_is_x
    incoming_ext_bus_data_bit_2_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_ext_bus_data(2))), '1','0');
    --Crush incoming_ext_bus_data_with_Xs_converted_to_0[2] Xs to 0, which is an e_assign
    incoming_ext_bus_data_with_Xs_converted_to_0(2) <= A_WE_StdLogic((std_logic'(incoming_ext_bus_data_bit_2_is_x) = '1'), std_logic'('0'), internal_incoming_ext_bus_data(2));
    --incoming_ext_bus_data_bit_3_is_x x check, which is an e_assign_is_x
    incoming_ext_bus_data_bit_3_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_ext_bus_data(3))), '1','0');
    --Crush incoming_ext_bus_data_with_Xs_converted_to_0[3] Xs to 0, which is an e_assign
    incoming_ext_bus_data_with_Xs_converted_to_0(3) <= A_WE_StdLogic((std_logic'(incoming_ext_bus_data_bit_3_is_x) = '1'), std_logic'('0'), internal_incoming_ext_bus_data(3));
    --incoming_ext_bus_data_bit_4_is_x x check, which is an e_assign_is_x
    incoming_ext_bus_data_bit_4_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_ext_bus_data(4))), '1','0');
    --Crush incoming_ext_bus_data_with_Xs_converted_to_0[4] Xs to 0, which is an e_assign
    incoming_ext_bus_data_with_Xs_converted_to_0(4) <= A_WE_StdLogic((std_logic'(incoming_ext_bus_data_bit_4_is_x) = '1'), std_logic'('0'), internal_incoming_ext_bus_data(4));
    --incoming_ext_bus_data_bit_5_is_x x check, which is an e_assign_is_x
    incoming_ext_bus_data_bit_5_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_ext_bus_data(5))), '1','0');
    --Crush incoming_ext_bus_data_with_Xs_converted_to_0[5] Xs to 0, which is an e_assign
    incoming_ext_bus_data_with_Xs_converted_to_0(5) <= A_WE_StdLogic((std_logic'(incoming_ext_bus_data_bit_5_is_x) = '1'), std_logic'('0'), internal_incoming_ext_bus_data(5));
    --incoming_ext_bus_data_bit_6_is_x x check, which is an e_assign_is_x
    incoming_ext_bus_data_bit_6_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_ext_bus_data(6))), '1','0');
    --Crush incoming_ext_bus_data_with_Xs_converted_to_0[6] Xs to 0, which is an e_assign
    incoming_ext_bus_data_with_Xs_converted_to_0(6) <= A_WE_StdLogic((std_logic'(incoming_ext_bus_data_bit_6_is_x) = '1'), std_logic'('0'), internal_incoming_ext_bus_data(6));
    --incoming_ext_bus_data_bit_7_is_x x check, which is an e_assign_is_x
    incoming_ext_bus_data_bit_7_is_x <= A_WE_StdLogic(is_x(std_ulogic(internal_incoming_ext_bus_data(7))), '1','0');
    --Crush incoming_ext_bus_data_with_Xs_converted_to_0[7] Xs to 0, which is an e_assign
    incoming_ext_bus_data_with_Xs_converted_to_0(7) <= A_WE_StdLogic((std_logic'(incoming_ext_bus_data_bit_7_is_x) = '1'), std_logic'('0'), internal_incoming_ext_bus_data(7));
    --grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line6 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_data_master_granted_flash_s1))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_instruction_master_granted_flash_s1))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line6, now);
          write(write_line6, string'(": "));
          write(write_line6, string'("> 1 of grant signals are active simultaneously"));
          write(output, write_line6.all);
          deallocate (write_line6);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --saved_grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line7 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_data_master_saved_grant_flash_s1))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_saved_grant_flash_s1))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line7, now);
          write(write_line7, string'(": "));
          write(write_line7, string'("> 1 of saved_grant signals are active simultaneously"));
          write(output, write_line7.all);
          deallocate (write_line7);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

--synthesis translate_on
--synthesis read_comments_as_HDL on
--    
--    incoming_ext_bus_data_with_Xs_converted_to_0 <= internal_incoming_ext_bus_data;
--synthesis read_comments_as_HDL off

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity ext_bus_bridge_arbitrator is 
end entity ext_bus_bridge_arbitrator;


architecture europa of ext_bus_bridge_arbitrator is

begin


end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity jtag_avalon_jtag_slave_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal jtag_avalon_jtag_slave_dataavailable : IN STD_LOGIC;
                 signal jtag_avalon_jtag_slave_irq : IN STD_LOGIC;
                 signal jtag_avalon_jtag_slave_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal jtag_avalon_jtag_slave_readyfordata : IN STD_LOGIC;
                 signal jtag_avalon_jtag_slave_waitrequest : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_jtag_avalon_jtag_slave : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_jtag_avalon_jtag_slave : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_jtag_avalon_jtag_slave : OUT STD_LOGIC;
                 signal cpu_data_master_requests_jtag_avalon_jtag_slave : OUT STD_LOGIC;
                 signal d1_jtag_avalon_jtag_slave_end_xfer : OUT STD_LOGIC;
                 signal jtag_avalon_jtag_slave_address : OUT STD_LOGIC;
                 signal jtag_avalon_jtag_slave_chipselect : OUT STD_LOGIC;
                 signal jtag_avalon_jtag_slave_dataavailable_from_sa : OUT STD_LOGIC;
                 signal jtag_avalon_jtag_slave_irq_from_sa : OUT STD_LOGIC;
                 signal jtag_avalon_jtag_slave_read_n : OUT STD_LOGIC;
                 signal jtag_avalon_jtag_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal jtag_avalon_jtag_slave_readyfordata_from_sa : OUT STD_LOGIC;
                 signal jtag_avalon_jtag_slave_reset_n : OUT STD_LOGIC;
                 signal jtag_avalon_jtag_slave_waitrequest_from_sa : OUT STD_LOGIC;
                 signal jtag_avalon_jtag_slave_write_n : OUT STD_LOGIC;
                 signal jtag_avalon_jtag_slave_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of jtag_avalon_jtag_slave_arbitrator : entity is FALSE;
end entity jtag_avalon_jtag_slave_arbitrator;


architecture europa of jtag_avalon_jtag_slave_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_jtag_avalon_jtag_slave :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_jtag_avalon_jtag_slave :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_jtag_avalon_jtag_slave :  STD_LOGIC;
                signal internal_cpu_data_master_requests_jtag_avalon_jtag_slave :  STD_LOGIC;
                signal internal_jtag_avalon_jtag_slave_waitrequest_from_sa :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_allgrants :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_allow_new_arb_cycle :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_any_continuerequest :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_arb_counter_enable :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal jtag_avalon_jtag_slave_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal jtag_avalon_jtag_slave_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal jtag_avalon_jtag_slave_arbitration_holdoff_internal :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_beginbursttransfer_internal :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_begins_xfer :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_end_xfer :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_firsttransfer :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_grant_vector :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_in_a_read_cycle :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_in_a_write_cycle :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_master_qreq_vector :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_slavearbiterlockenable :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_waits_for_read :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_waits_for_write :  STD_LOGIC;
                signal wait_for_jtag_avalon_jtag_slave_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT jtag_avalon_jtag_slave_end_xfer;
      end if;
    end if;

  end process;

  jtag_avalon_jtag_slave_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_jtag_avalon_jtag_slave);
  --assign jtag_avalon_jtag_slave_readdata_from_sa = jtag_avalon_jtag_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  jtag_avalon_jtag_slave_readdata_from_sa <= jtag_avalon_jtag_slave_readdata;
  internal_cpu_data_master_requests_jtag_avalon_jtag_slave <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 3) & std_logic_vector'("000")) = std_logic_vector'("001000100000000010000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign jtag_avalon_jtag_slave_dataavailable_from_sa = jtag_avalon_jtag_slave_dataavailable so that symbol knows where to group signals which may go to master only, which is an e_assign
  jtag_avalon_jtag_slave_dataavailable_from_sa <= jtag_avalon_jtag_slave_dataavailable;
  --assign jtag_avalon_jtag_slave_readyfordata_from_sa = jtag_avalon_jtag_slave_readyfordata so that symbol knows where to group signals which may go to master only, which is an e_assign
  jtag_avalon_jtag_slave_readyfordata_from_sa <= jtag_avalon_jtag_slave_readyfordata;
  --assign jtag_avalon_jtag_slave_waitrequest_from_sa = jtag_avalon_jtag_slave_waitrequest so that symbol knows where to group signals which may go to master only, which is an e_assign
  internal_jtag_avalon_jtag_slave_waitrequest_from_sa <= jtag_avalon_jtag_slave_waitrequest;
  --jtag_avalon_jtag_slave_arb_share_counter set values, which is an e_mux
  jtag_avalon_jtag_slave_arb_share_set_values <= std_logic_vector'("001");
  --jtag_avalon_jtag_slave_arb_share_counter_next_value assignment, which is an e_assign
  jtag_avalon_jtag_slave_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(jtag_avalon_jtag_slave_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (jtag_avalon_jtag_slave_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(jtag_avalon_jtag_slave_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (jtag_avalon_jtag_slave_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --jtag_avalon_jtag_slave_allgrants all slave grants, which is an e_mux
  jtag_avalon_jtag_slave_allgrants <= jtag_avalon_jtag_slave_grant_vector;
  --jtag_avalon_jtag_slave_end_xfer assignment, which is an e_assign
  jtag_avalon_jtag_slave_end_xfer <= NOT ((jtag_avalon_jtag_slave_waits_for_read OR jtag_avalon_jtag_slave_waits_for_write));
  --jtag_avalon_jtag_slave_arb_share_counter arbitration counter enable, which is an e_assign
  jtag_avalon_jtag_slave_arb_counter_enable <= jtag_avalon_jtag_slave_end_xfer AND jtag_avalon_jtag_slave_allgrants;
  --jtag_avalon_jtag_slave_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      jtag_avalon_jtag_slave_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(jtag_avalon_jtag_slave_arb_counter_enable) = '1' then 
        jtag_avalon_jtag_slave_arb_share_counter <= jtag_avalon_jtag_slave_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --jtag_avalon_jtag_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      jtag_avalon_jtag_slave_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((jtag_avalon_jtag_slave_master_qreq_vector AND jtag_avalon_jtag_slave_end_xfer)) = '1' then 
        jtag_avalon_jtag_slave_slavearbiterlockenable <= or_reduce(jtag_avalon_jtag_slave_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master jtag/avalon_jtag_slave arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= jtag_avalon_jtag_slave_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --jtag_avalon_jtag_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  jtag_avalon_jtag_slave_any_continuerequest <= std_logic'('0');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('0');
  internal_cpu_data_master_qualified_request_jtag_avalon_jtag_slave <= internal_cpu_data_master_requests_jtag_avalon_jtag_slave AND NOT ((((cpu_data_master_read AND (NOT cpu_data_master_waitrequest))) OR (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write))));
  --jtag_avalon_jtag_slave_writedata mux, which is an e_mux
  jtag_avalon_jtag_slave_writedata <= cpu_data_master_writedata;
  --master is always granted when requested
  internal_cpu_data_master_granted_jtag_avalon_jtag_slave <= internal_cpu_data_master_qualified_request_jtag_avalon_jtag_slave;
  --cpu/data_master saved-grant jtag/avalon_jtag_slave, which is an e_assign
  cpu_data_master_saved_grant_jtag_avalon_jtag_slave <= internal_cpu_data_master_requests_jtag_avalon_jtag_slave;
  --allow new arb cycle for jtag/avalon_jtag_slave, which is an e_assign
  jtag_avalon_jtag_slave_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  jtag_avalon_jtag_slave_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  jtag_avalon_jtag_slave_master_qreq_vector <= std_logic'('1');
  --jtag_avalon_jtag_slave_reset_n assignment, which is an e_assign
  jtag_avalon_jtag_slave_reset_n <= reset_n;
  jtag_avalon_jtag_slave_chipselect <= internal_cpu_data_master_granted_jtag_avalon_jtag_slave;
  --jtag_avalon_jtag_slave_firsttransfer first transaction, which is an e_assign
  jtag_avalon_jtag_slave_firsttransfer <= NOT ((jtag_avalon_jtag_slave_slavearbiterlockenable AND jtag_avalon_jtag_slave_any_continuerequest));
  --jtag_avalon_jtag_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  jtag_avalon_jtag_slave_beginbursttransfer_internal <= jtag_avalon_jtag_slave_begins_xfer AND jtag_avalon_jtag_slave_firsttransfer;
  --jtag_avalon_jtag_slave_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  jtag_avalon_jtag_slave_arbitration_holdoff_internal <= jtag_avalon_jtag_slave_begins_xfer AND jtag_avalon_jtag_slave_firsttransfer;
  --~jtag_avalon_jtag_slave_read_n assignment, which is an e_mux
  jtag_avalon_jtag_slave_read_n <= NOT ((internal_cpu_data_master_granted_jtag_avalon_jtag_slave AND cpu_data_master_read));
  --~jtag_avalon_jtag_slave_write_n assignment, which is an e_mux
  jtag_avalon_jtag_slave_write_n <= NOT ((internal_cpu_data_master_granted_jtag_avalon_jtag_slave AND cpu_data_master_write));
  --jtag_avalon_jtag_slave_address mux, which is an e_mux
  jtag_avalon_jtag_slave_address <= Vector_To_Std_Logic(A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")));
  --d1_jtag_avalon_jtag_slave_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_jtag_avalon_jtag_slave_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_jtag_avalon_jtag_slave_end_xfer <= jtag_avalon_jtag_slave_end_xfer;
      end if;
    end if;

  end process;

  --jtag_avalon_jtag_slave_waits_for_read in a cycle, which is an e_mux
  jtag_avalon_jtag_slave_waits_for_read <= jtag_avalon_jtag_slave_in_a_read_cycle AND internal_jtag_avalon_jtag_slave_waitrequest_from_sa;
  --jtag_avalon_jtag_slave_in_a_read_cycle assignment, which is an e_assign
  jtag_avalon_jtag_slave_in_a_read_cycle <= internal_cpu_data_master_granted_jtag_avalon_jtag_slave AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= jtag_avalon_jtag_slave_in_a_read_cycle;
  --jtag_avalon_jtag_slave_waits_for_write in a cycle, which is an e_mux
  jtag_avalon_jtag_slave_waits_for_write <= jtag_avalon_jtag_slave_in_a_write_cycle AND internal_jtag_avalon_jtag_slave_waitrequest_from_sa;
  --jtag_avalon_jtag_slave_in_a_write_cycle assignment, which is an e_assign
  jtag_avalon_jtag_slave_in_a_write_cycle <= internal_cpu_data_master_granted_jtag_avalon_jtag_slave AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= jtag_avalon_jtag_slave_in_a_write_cycle;
  wait_for_jtag_avalon_jtag_slave_counter <= std_logic'('0');
  --assign jtag_avalon_jtag_slave_irq_from_sa = jtag_avalon_jtag_slave_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  jtag_avalon_jtag_slave_irq_from_sa <= jtag_avalon_jtag_slave_irq;
  --vhdl renameroo for output signals
  cpu_data_master_granted_jtag_avalon_jtag_slave <= internal_cpu_data_master_granted_jtag_avalon_jtag_slave;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_jtag_avalon_jtag_slave <= internal_cpu_data_master_qualified_request_jtag_avalon_jtag_slave;
  --vhdl renameroo for output signals
  cpu_data_master_requests_jtag_avalon_jtag_slave <= internal_cpu_data_master_requests_jtag_avalon_jtag_slave;
  --vhdl renameroo for output signals
  jtag_avalon_jtag_slave_waitrequest_from_sa <= internal_jtag_avalon_jtag_slave_waitrequest_from_sa;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity lcd_control_slave_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal lcd_control_slave_readdata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_lcd_control_slave : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_lcd_control_slave : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_lcd_control_slave : OUT STD_LOGIC;
                 signal cpu_data_master_requests_lcd_control_slave : OUT STD_LOGIC;
                 signal d1_lcd_control_slave_end_xfer : OUT STD_LOGIC;
                 signal lcd_control_slave_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal lcd_control_slave_begintransfer : OUT STD_LOGIC;
                 signal lcd_control_slave_read : OUT STD_LOGIC;
                 signal lcd_control_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal lcd_control_slave_wait_counter_eq_0 : OUT STD_LOGIC;
                 signal lcd_control_slave_wait_counter_eq_1 : OUT STD_LOGIC;
                 signal lcd_control_slave_write : OUT STD_LOGIC;
                 signal lcd_control_slave_writedata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of lcd_control_slave_arbitrator : entity is FALSE;
end entity lcd_control_slave_arbitrator;


architecture europa of lcd_control_slave_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_lcd_control_slave :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_lcd_control_slave :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_lcd_control_slave :  STD_LOGIC;
                signal internal_cpu_data_master_requests_lcd_control_slave :  STD_LOGIC;
                signal internal_lcd_control_slave_wait_counter_eq_0 :  STD_LOGIC;
                signal lcd_control_slave_allgrants :  STD_LOGIC;
                signal lcd_control_slave_allow_new_arb_cycle :  STD_LOGIC;
                signal lcd_control_slave_any_continuerequest :  STD_LOGIC;
                signal lcd_control_slave_arb_counter_enable :  STD_LOGIC;
                signal lcd_control_slave_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal lcd_control_slave_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal lcd_control_slave_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal lcd_control_slave_arbitration_holdoff_internal :  STD_LOGIC;
                signal lcd_control_slave_beginbursttransfer_internal :  STD_LOGIC;
                signal lcd_control_slave_begins_xfer :  STD_LOGIC;
                signal lcd_control_slave_counter_load_value :  STD_LOGIC_VECTOR (5 DOWNTO 0);
                signal lcd_control_slave_end_xfer :  STD_LOGIC;
                signal lcd_control_slave_firsttransfer :  STD_LOGIC;
                signal lcd_control_slave_grant_vector :  STD_LOGIC;
                signal lcd_control_slave_in_a_read_cycle :  STD_LOGIC;
                signal lcd_control_slave_in_a_write_cycle :  STD_LOGIC;
                signal lcd_control_slave_master_qreq_vector :  STD_LOGIC;
                signal lcd_control_slave_pretend_byte_enable :  STD_LOGIC;
                signal lcd_control_slave_slavearbiterlockenable :  STD_LOGIC;
                signal lcd_control_slave_wait_counter :  STD_LOGIC_VECTOR (5 DOWNTO 0);
                signal lcd_control_slave_waits_for_read :  STD_LOGIC;
                signal lcd_control_slave_waits_for_write :  STD_LOGIC;
                signal wait_for_lcd_control_slave_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT lcd_control_slave_end_xfer;
      end if;
    end if;

  end process;

  lcd_control_slave_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_lcd_control_slave);
  --assign lcd_control_slave_readdata_from_sa = lcd_control_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  lcd_control_slave_readdata_from_sa <= lcd_control_slave_readdata;
  internal_cpu_data_master_requests_lcd_control_slave <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("001000100000000000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --lcd_control_slave_arb_share_counter set values, which is an e_mux
  lcd_control_slave_arb_share_set_values <= std_logic_vector'("001");
  --lcd_control_slave_arb_share_counter_next_value assignment, which is an e_assign
  lcd_control_slave_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(lcd_control_slave_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (lcd_control_slave_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(lcd_control_slave_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (lcd_control_slave_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --lcd_control_slave_allgrants all slave grants, which is an e_mux
  lcd_control_slave_allgrants <= lcd_control_slave_grant_vector;
  --lcd_control_slave_end_xfer assignment, which is an e_assign
  lcd_control_slave_end_xfer <= NOT ((lcd_control_slave_waits_for_read OR lcd_control_slave_waits_for_write));
  --lcd_control_slave_arb_share_counter arbitration counter enable, which is an e_assign
  lcd_control_slave_arb_counter_enable <= lcd_control_slave_end_xfer AND lcd_control_slave_allgrants;
  --lcd_control_slave_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      lcd_control_slave_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(lcd_control_slave_arb_counter_enable) = '1' then 
        lcd_control_slave_arb_share_counter <= lcd_control_slave_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --lcd_control_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      lcd_control_slave_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((lcd_control_slave_master_qreq_vector AND lcd_control_slave_end_xfer)) = '1' then 
        lcd_control_slave_slavearbiterlockenable <= or_reduce(lcd_control_slave_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master lcd/control_slave arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= lcd_control_slave_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --lcd_control_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  lcd_control_slave_any_continuerequest <= std_logic'('0');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('0');
  internal_cpu_data_master_qualified_request_lcd_control_slave <= internal_cpu_data_master_requests_lcd_control_slave;
  --lcd_control_slave_writedata mux, which is an e_mux
  lcd_control_slave_writedata <= cpu_data_master_writedata (7 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_lcd_control_slave <= internal_cpu_data_master_qualified_request_lcd_control_slave;
  --cpu/data_master saved-grant lcd/control_slave, which is an e_assign
  cpu_data_master_saved_grant_lcd_control_slave <= internal_cpu_data_master_requests_lcd_control_slave;
  --allow new arb cycle for lcd/control_slave, which is an e_assign
  lcd_control_slave_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  lcd_control_slave_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  lcd_control_slave_master_qreq_vector <= std_logic'('1');
  lcd_control_slave_begintransfer <= lcd_control_slave_begins_xfer;
  --lcd_control_slave_firsttransfer first transaction, which is an e_assign
  lcd_control_slave_firsttransfer <= NOT ((lcd_control_slave_slavearbiterlockenable AND lcd_control_slave_any_continuerequest));
  --lcd_control_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  lcd_control_slave_beginbursttransfer_internal <= lcd_control_slave_begins_xfer AND lcd_control_slave_firsttransfer;
  --lcd_control_slave_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  lcd_control_slave_arbitration_holdoff_internal <= lcd_control_slave_begins_xfer AND lcd_control_slave_firsttransfer;
  --lcd_control_slave_read assignment, which is an e_mux
  lcd_control_slave_read <= (((internal_cpu_data_master_granted_lcd_control_slave AND cpu_data_master_read)) AND NOT lcd_control_slave_begins_xfer) AND to_std_logic((((std_logic_vector'("00000000000000000000000000") & (lcd_control_slave_wait_counter))<std_logic_vector'("00000000000000000000000000001101"))));
  --lcd_control_slave_write assignment, which is an e_mux
  lcd_control_slave_write <= (((((internal_cpu_data_master_granted_lcd_control_slave AND cpu_data_master_write)) AND NOT lcd_control_slave_begins_xfer) AND to_std_logic((((std_logic_vector'("00000000000000000000000000") & (lcd_control_slave_wait_counter))>=std_logic_vector'("00000000000000000000000000001101"))))) AND to_std_logic((((std_logic_vector'("00000000000000000000000000") & (lcd_control_slave_wait_counter))<std_logic_vector'("00000000000000000000000000011010"))))) AND lcd_control_slave_pretend_byte_enable;
  --lcd_control_slave_address mux, which is an e_mux
  lcd_control_slave_address <= A_EXT (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_lcd_control_slave_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_lcd_control_slave_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_lcd_control_slave_end_xfer <= lcd_control_slave_end_xfer;
      end if;
    end if;

  end process;

  --lcd_control_slave_wait_counter_eq_1 assignment, which is an e_assign
  lcd_control_slave_wait_counter_eq_1 <= to_std_logic(((std_logic_vector'("00000000000000000000000000") & (lcd_control_slave_wait_counter)) = std_logic_vector'("00000000000000000000000000000001")));
  --lcd_control_slave_waits_for_read in a cycle, which is an e_mux
  lcd_control_slave_waits_for_read <= lcd_control_slave_in_a_read_cycle AND wait_for_lcd_control_slave_counter;
  --lcd_control_slave_in_a_read_cycle assignment, which is an e_assign
  lcd_control_slave_in_a_read_cycle <= internal_cpu_data_master_granted_lcd_control_slave AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= lcd_control_slave_in_a_read_cycle;
  --lcd_control_slave_waits_for_write in a cycle, which is an e_mux
  lcd_control_slave_waits_for_write <= lcd_control_slave_in_a_write_cycle AND wait_for_lcd_control_slave_counter;
  --lcd_control_slave_in_a_write_cycle assignment, which is an e_assign
  lcd_control_slave_in_a_write_cycle <= internal_cpu_data_master_granted_lcd_control_slave AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= lcd_control_slave_in_a_write_cycle;
  internal_lcd_control_slave_wait_counter_eq_0 <= to_std_logic(((std_logic_vector'("00000000000000000000000000") & (lcd_control_slave_wait_counter)) = std_logic_vector'("00000000000000000000000000000000")));
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      lcd_control_slave_wait_counter <= std_logic_vector'("000000");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        lcd_control_slave_wait_counter <= lcd_control_slave_counter_load_value;
      end if;
    end if;

  end process;

  lcd_control_slave_counter_load_value <= A_EXT (A_WE_StdLogicVector((std_logic'(((lcd_control_slave_in_a_write_cycle AND lcd_control_slave_begins_xfer))) = '1'), std_logic_vector'("000000000000000000000000000100101"), A_WE_StdLogicVector((std_logic'(((lcd_control_slave_in_a_read_cycle AND lcd_control_slave_begins_xfer))) = '1'), std_logic_vector'("000000000000000000000000000011000"), A_WE_StdLogicVector((std_logic'((NOT internal_lcd_control_slave_wait_counter_eq_0)) = '1'), ((std_logic_vector'("000000000000000000000000000") & (lcd_control_slave_wait_counter)) - std_logic_vector'("000000000000000000000000000000001")), std_logic_vector'("000000000000000000000000000000000")))), 6);
  wait_for_lcd_control_slave_counter <= lcd_control_slave_begins_xfer OR NOT internal_lcd_control_slave_wait_counter_eq_0;
  --lcd_control_slave_pretend_byte_enable byte enable port mux, which is an e_mux
  lcd_control_slave_pretend_byte_enable <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_lcd_control_slave)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))));
  --vhdl renameroo for output signals
  cpu_data_master_granted_lcd_control_slave <= internal_cpu_data_master_granted_lcd_control_slave;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_lcd_control_slave <= internal_cpu_data_master_qualified_request_lcd_control_slave;
  --vhdl renameroo for output signals
  cpu_data_master_requests_lcd_control_slave <= internal_cpu_data_master_requests_lcd_control_slave;
  --vhdl renameroo for output signals
  lcd_control_slave_wait_counter_eq_0 <= internal_lcd_control_slave_wait_counter_eq_0;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity led_green_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_led_green_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_led_green_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_led_green_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_led_green_s1 : OUT STD_LOGIC;
                 signal d1_led_green_s1_end_xfer : OUT STD_LOGIC;
                 signal led_green_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal led_green_s1_chipselect : OUT STD_LOGIC;
                 signal led_green_s1_reset_n : OUT STD_LOGIC;
                 signal led_green_s1_write_n : OUT STD_LOGIC;
                 signal led_green_s1_writedata : OUT STD_LOGIC_VECTOR (8 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of led_green_s1_arbitrator : entity is FALSE;
end entity led_green_s1_arbitrator;


architecture europa of led_green_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_led_green_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_led_green_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_led_green_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_led_green_s1 :  STD_LOGIC;
                signal led_green_s1_allgrants :  STD_LOGIC;
                signal led_green_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal led_green_s1_any_continuerequest :  STD_LOGIC;
                signal led_green_s1_arb_counter_enable :  STD_LOGIC;
                signal led_green_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal led_green_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal led_green_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal led_green_s1_arbitration_holdoff_internal :  STD_LOGIC;
                signal led_green_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal led_green_s1_begins_xfer :  STD_LOGIC;
                signal led_green_s1_end_xfer :  STD_LOGIC;
                signal led_green_s1_firsttransfer :  STD_LOGIC;
                signal led_green_s1_grant_vector :  STD_LOGIC;
                signal led_green_s1_in_a_read_cycle :  STD_LOGIC;
                signal led_green_s1_in_a_write_cycle :  STD_LOGIC;
                signal led_green_s1_master_qreq_vector :  STD_LOGIC;
                signal led_green_s1_slavearbiterlockenable :  STD_LOGIC;
                signal led_green_s1_waits_for_read :  STD_LOGIC;
                signal led_green_s1_waits_for_write :  STD_LOGIC;
                signal wait_for_led_green_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT led_green_s1_end_xfer;
      end if;
    end if;

  end process;

  led_green_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_led_green_s1);
  internal_cpu_data_master_requests_led_green_s1 <= ((to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("001000100000000100000000")))) AND ((cpu_data_master_read OR cpu_data_master_write)))) AND cpu_data_master_write;
  --led_green_s1_arb_share_counter set values, which is an e_mux
  led_green_s1_arb_share_set_values <= std_logic_vector'("001");
  --led_green_s1_arb_share_counter_next_value assignment, which is an e_assign
  led_green_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(led_green_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (led_green_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(led_green_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (led_green_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --led_green_s1_allgrants all slave grants, which is an e_mux
  led_green_s1_allgrants <= led_green_s1_grant_vector;
  --led_green_s1_end_xfer assignment, which is an e_assign
  led_green_s1_end_xfer <= NOT ((led_green_s1_waits_for_read OR led_green_s1_waits_for_write));
  --led_green_s1_arb_share_counter arbitration counter enable, which is an e_assign
  led_green_s1_arb_counter_enable <= led_green_s1_end_xfer AND led_green_s1_allgrants;
  --led_green_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      led_green_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(led_green_s1_arb_counter_enable) = '1' then 
        led_green_s1_arb_share_counter <= led_green_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --led_green_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      led_green_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((led_green_s1_master_qreq_vector AND led_green_s1_end_xfer)) = '1' then 
        led_green_s1_slavearbiterlockenable <= or_reduce(led_green_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master led_green/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= led_green_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --led_green_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  led_green_s1_any_continuerequest <= std_logic'('0');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('0');
  internal_cpu_data_master_qualified_request_led_green_s1 <= internal_cpu_data_master_requests_led_green_s1 AND NOT (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write));
  --led_green_s1_writedata mux, which is an e_mux
  led_green_s1_writedata <= cpu_data_master_writedata (8 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_led_green_s1 <= internal_cpu_data_master_qualified_request_led_green_s1;
  --cpu/data_master saved-grant led_green/s1, which is an e_assign
  cpu_data_master_saved_grant_led_green_s1 <= internal_cpu_data_master_requests_led_green_s1;
  --allow new arb cycle for led_green/s1, which is an e_assign
  led_green_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  led_green_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  led_green_s1_master_qreq_vector <= std_logic'('1');
  --led_green_s1_reset_n assignment, which is an e_assign
  led_green_s1_reset_n <= reset_n;
  led_green_s1_chipselect <= internal_cpu_data_master_granted_led_green_s1;
  --led_green_s1_firsttransfer first transaction, which is an e_assign
  led_green_s1_firsttransfer <= NOT ((led_green_s1_slavearbiterlockenable AND led_green_s1_any_continuerequest));
  --led_green_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  led_green_s1_beginbursttransfer_internal <= led_green_s1_begins_xfer AND led_green_s1_firsttransfer;
  --led_green_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  led_green_s1_arbitration_holdoff_internal <= led_green_s1_begins_xfer AND led_green_s1_firsttransfer;
  --~led_green_s1_write_n assignment, which is an e_mux
  led_green_s1_write_n <= NOT ((internal_cpu_data_master_granted_led_green_s1 AND cpu_data_master_write));
  --led_green_s1_address mux, which is an e_mux
  led_green_s1_address <= A_EXT (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_led_green_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_led_green_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_led_green_s1_end_xfer <= led_green_s1_end_xfer;
      end if;
    end if;

  end process;

  --led_green_s1_waits_for_read in a cycle, which is an e_mux
  led_green_s1_waits_for_read <= led_green_s1_in_a_read_cycle AND led_green_s1_begins_xfer;
  --led_green_s1_in_a_read_cycle assignment, which is an e_assign
  led_green_s1_in_a_read_cycle <= internal_cpu_data_master_granted_led_green_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= led_green_s1_in_a_read_cycle;
  --led_green_s1_waits_for_write in a cycle, which is an e_mux
  led_green_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(led_green_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --led_green_s1_in_a_write_cycle assignment, which is an e_assign
  led_green_s1_in_a_write_cycle <= internal_cpu_data_master_granted_led_green_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= led_green_s1_in_a_write_cycle;
  wait_for_led_green_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_data_master_granted_led_green_s1 <= internal_cpu_data_master_granted_led_green_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_led_green_s1 <= internal_cpu_data_master_qualified_request_led_green_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_led_green_s1 <= internal_cpu_data_master_requests_led_green_s1;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity led_red_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_led_red_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_led_red_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_led_red_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_led_red_s1 : OUT STD_LOGIC;
                 signal d1_led_red_s1_end_xfer : OUT STD_LOGIC;
                 signal led_red_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal led_red_s1_chipselect : OUT STD_LOGIC;
                 signal led_red_s1_reset_n : OUT STD_LOGIC;
                 signal led_red_s1_write_n : OUT STD_LOGIC;
                 signal led_red_s1_writedata : OUT STD_LOGIC_VECTOR (17 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of led_red_s1_arbitrator : entity is FALSE;
end entity led_red_s1_arbitrator;


architecture europa of led_red_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_led_red_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_led_red_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_led_red_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_led_red_s1 :  STD_LOGIC;
                signal led_red_s1_allgrants :  STD_LOGIC;
                signal led_red_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal led_red_s1_any_continuerequest :  STD_LOGIC;
                signal led_red_s1_arb_counter_enable :  STD_LOGIC;
                signal led_red_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal led_red_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal led_red_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal led_red_s1_arbitration_holdoff_internal :  STD_LOGIC;
                signal led_red_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal led_red_s1_begins_xfer :  STD_LOGIC;
                signal led_red_s1_end_xfer :  STD_LOGIC;
                signal led_red_s1_firsttransfer :  STD_LOGIC;
                signal led_red_s1_grant_vector :  STD_LOGIC;
                signal led_red_s1_in_a_read_cycle :  STD_LOGIC;
                signal led_red_s1_in_a_write_cycle :  STD_LOGIC;
                signal led_red_s1_master_qreq_vector :  STD_LOGIC;
                signal led_red_s1_slavearbiterlockenable :  STD_LOGIC;
                signal led_red_s1_waits_for_read :  STD_LOGIC;
                signal led_red_s1_waits_for_write :  STD_LOGIC;
                signal wait_for_led_red_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT led_red_s1_end_xfer;
      end if;
    end if;

  end process;

  led_red_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_led_red_s1);
  internal_cpu_data_master_requests_led_red_s1 <= ((to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("001000100000000001110000")))) AND ((cpu_data_master_read OR cpu_data_master_write)))) AND cpu_data_master_write;
  --led_red_s1_arb_share_counter set values, which is an e_mux
  led_red_s1_arb_share_set_values <= std_logic_vector'("001");
  --led_red_s1_arb_share_counter_next_value assignment, which is an e_assign
  led_red_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(led_red_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (led_red_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(led_red_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (led_red_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --led_red_s1_allgrants all slave grants, which is an e_mux
  led_red_s1_allgrants <= led_red_s1_grant_vector;
  --led_red_s1_end_xfer assignment, which is an e_assign
  led_red_s1_end_xfer <= NOT ((led_red_s1_waits_for_read OR led_red_s1_waits_for_write));
  --led_red_s1_arb_share_counter arbitration counter enable, which is an e_assign
  led_red_s1_arb_counter_enable <= led_red_s1_end_xfer AND led_red_s1_allgrants;
  --led_red_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      led_red_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(led_red_s1_arb_counter_enable) = '1' then 
        led_red_s1_arb_share_counter <= led_red_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --led_red_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      led_red_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((led_red_s1_master_qreq_vector AND led_red_s1_end_xfer)) = '1' then 
        led_red_s1_slavearbiterlockenable <= or_reduce(led_red_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master led_red/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= led_red_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --led_red_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  led_red_s1_any_continuerequest <= std_logic'('0');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('0');
  internal_cpu_data_master_qualified_request_led_red_s1 <= internal_cpu_data_master_requests_led_red_s1 AND NOT (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write));
  --led_red_s1_writedata mux, which is an e_mux
  led_red_s1_writedata <= cpu_data_master_writedata (17 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_led_red_s1 <= internal_cpu_data_master_qualified_request_led_red_s1;
  --cpu/data_master saved-grant led_red/s1, which is an e_assign
  cpu_data_master_saved_grant_led_red_s1 <= internal_cpu_data_master_requests_led_red_s1;
  --allow new arb cycle for led_red/s1, which is an e_assign
  led_red_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  led_red_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  led_red_s1_master_qreq_vector <= std_logic'('1');
  --led_red_s1_reset_n assignment, which is an e_assign
  led_red_s1_reset_n <= reset_n;
  led_red_s1_chipselect <= internal_cpu_data_master_granted_led_red_s1;
  --led_red_s1_firsttransfer first transaction, which is an e_assign
  led_red_s1_firsttransfer <= NOT ((led_red_s1_slavearbiterlockenable AND led_red_s1_any_continuerequest));
  --led_red_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  led_red_s1_beginbursttransfer_internal <= led_red_s1_begins_xfer AND led_red_s1_firsttransfer;
  --led_red_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  led_red_s1_arbitration_holdoff_internal <= led_red_s1_begins_xfer AND led_red_s1_firsttransfer;
  --~led_red_s1_write_n assignment, which is an e_mux
  led_red_s1_write_n <= NOT ((internal_cpu_data_master_granted_led_red_s1 AND cpu_data_master_write));
  --led_red_s1_address mux, which is an e_mux
  led_red_s1_address <= A_EXT (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_led_red_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_led_red_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_led_red_s1_end_xfer <= led_red_s1_end_xfer;
      end if;
    end if;

  end process;

  --led_red_s1_waits_for_read in a cycle, which is an e_mux
  led_red_s1_waits_for_read <= led_red_s1_in_a_read_cycle AND led_red_s1_begins_xfer;
  --led_red_s1_in_a_read_cycle assignment, which is an e_assign
  led_red_s1_in_a_read_cycle <= internal_cpu_data_master_granted_led_red_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= led_red_s1_in_a_read_cycle;
  --led_red_s1_waits_for_write in a cycle, which is an e_mux
  led_red_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(led_red_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --led_red_s1_in_a_write_cycle assignment, which is an e_assign
  led_red_s1_in_a_write_cycle <= internal_cpu_data_master_granted_led_red_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= led_red_s1_in_a_write_cycle;
  wait_for_led_red_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_data_master_granted_led_red_s1 <= internal_cpu_data_master_granted_led_red_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_led_red_s1 <= internal_cpu_data_master_qualified_request_led_red_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_led_red_s1 <= internal_cpu_data_master_requests_led_red_s1;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity sdram_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_dbs_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_dbs_write_16 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal cpu_data_master_no_byte_enables_and_last_term : IN STD_LOGIC;
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_instruction_master_dbs_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;
                 signal sdram_s1_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal sdram_s1_readdatavalid : IN STD_LOGIC;
                 signal sdram_s1_waitrequest : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_byteenable_sdram_s1 : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_granted_sdram_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_sdram_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_sdram_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_sdram_s1_shift_register : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal cpu_data_master_requests_sdram_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_granted_sdram_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_sdram_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_sdram_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_sdram_s1_shift_register : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal cpu_instruction_master_requests_sdram_s1 : OUT STD_LOGIC;
                 signal d1_sdram_s1_end_xfer : OUT STD_LOGIC;
                 signal sdram_s1_address : OUT STD_LOGIC_VECTOR (21 DOWNTO 0);
                 signal sdram_s1_byteenable_n : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal sdram_s1_chipselect : OUT STD_LOGIC;
                 signal sdram_s1_posted_fifo_readenable : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal sdram_s1_posted_fifo_writenable : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal sdram_s1_read_n : OUT STD_LOGIC;
                 signal sdram_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal sdram_s1_reset_n : OUT STD_LOGIC;
                 signal sdram_s1_waitrequest_from_sa : OUT STD_LOGIC;
                 signal sdram_s1_write_n : OUT STD_LOGIC;
                 signal sdram_s1_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of sdram_s1_arbitrator : entity is FALSE;
end entity sdram_s1_arbitrator;


architecture europa of sdram_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_byteenable_sdram_s1_segment_0 :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_byteenable_sdram_s1_segment_1 :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_sdram_s1_fifo_output :  STD_LOGIC;
                signal cpu_data_master_saved_grant_sdram_s1 :  STD_LOGIC;
                signal cpu_instruction_master_arbiterlock :  STD_LOGIC;
                signal cpu_instruction_master_continuerequest :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_sdram_s1_fifo_output :  STD_LOGIC;
                signal cpu_instruction_master_saved_grant_sdram_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_byteenable_sdram_s1 :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal internal_cpu_data_master_granted_sdram_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_sdram_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_read_data_valid_sdram_s1_shift_register :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal internal_cpu_data_master_requests_sdram_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_granted_sdram_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_qualified_request_sdram_s1 :  STD_LOGIC;
                signal internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal internal_cpu_instruction_master_requests_sdram_s1 :  STD_LOGIC;
                signal internal_sdram_s1_posted_fifo_readenable :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal internal_sdram_s1_posted_fifo_writenable :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal internal_sdram_s1_waitrequest_from_sa :  STD_LOGIC;
                signal last_cycle_cpu_data_master_granted_slave_sdram_s1 :  STD_LOGIC;
                signal last_cycle_cpu_instruction_master_granted_slave_sdram_s1 :  STD_LOGIC;
                signal sdram_s1_allgrants :  STD_LOGIC;
                signal sdram_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal sdram_s1_any_continuerequest :  STD_LOGIC;
                signal sdram_s1_arb_addend :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal sdram_s1_arb_counter_enable :  STD_LOGIC;
                signal sdram_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal sdram_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal sdram_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal sdram_s1_arb_winner :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal sdram_s1_arbitration_holdoff_internal :  STD_LOGIC;
                signal sdram_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal sdram_s1_begins_xfer :  STD_LOGIC;
                signal sdram_s1_chosen_master_double_vector :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal sdram_s1_chosen_master_rot_left :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal sdram_s1_end_xfer :  STD_LOGIC;
                signal sdram_s1_firsttransfer :  STD_LOGIC;
                signal sdram_s1_grant_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal sdram_s1_in_a_read_cycle :  STD_LOGIC;
                signal sdram_s1_in_a_write_cycle :  STD_LOGIC;
                signal sdram_s1_master_qreq_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal sdram_s1_readdatavalid_from_sa :  STD_LOGIC;
                signal sdram_s1_saved_chosen_master_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal sdram_s1_slavearbiterlockenable :  STD_LOGIC;
                signal sdram_s1_waits_for_read :  STD_LOGIC;
                signal sdram_s1_waits_for_write :  STD_LOGIC;
                signal wait_for_sdram_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT sdram_s1_end_xfer;
      end if;
    end if;

  end process;

  sdram_s1_begins_xfer <= NOT d1_reasons_to_wait AND ((internal_cpu_data_master_qualified_request_sdram_s1 OR internal_cpu_instruction_master_qualified_request_sdram_s1));
  --assign sdram_s1_readdatavalid_from_sa = sdram_s1_readdatavalid so that symbol knows where to group signals which may go to master only, which is an e_assign
  sdram_s1_readdatavalid_from_sa <= sdram_s1_readdatavalid;
  --assign sdram_s1_readdata_from_sa = sdram_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  sdram_s1_readdata_from_sa <= sdram_s1_readdata;
  internal_cpu_data_master_requests_sdram_s1 <= to_std_logic(((Std_Logic_Vector'(A_ToStdLogicVector(cpu_data_master_address_to_slave(23)) & std_logic_vector'("00000000000000000000000")) = std_logic_vector'("100000000000000000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign sdram_s1_waitrequest_from_sa = sdram_s1_waitrequest so that symbol knows where to group signals which may go to master only, which is an e_assign
  internal_sdram_s1_waitrequest_from_sa <= sdram_s1_waitrequest;
  --sdram_s1_arb_share_counter set values, which is an e_mux
  sdram_s1_arb_share_set_values <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_sdram_s1)) = '1'), std_logic_vector'("00000000000000000000000000000010"), A_WE_StdLogicVector((std_logic'((internal_cpu_instruction_master_granted_sdram_s1)) = '1'), std_logic_vector'("00000000000000000000000000000010"), A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_sdram_s1)) = '1'), std_logic_vector'("00000000000000000000000000000010"), A_WE_StdLogicVector((std_logic'((internal_cpu_instruction_master_granted_sdram_s1)) = '1'), std_logic_vector'("00000000000000000000000000000010"), std_logic_vector'("00000000000000000000000000000001"))))), 3);
  --sdram_s1_arb_share_counter_next_value assignment, which is an e_assign
  sdram_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(sdram_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (sdram_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(sdram_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (sdram_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --sdram_s1_allgrants all slave grants, which is an e_mux
  sdram_s1_allgrants <= ((or_reduce(sdram_s1_grant_vector) OR or_reduce(sdram_s1_grant_vector)) OR or_reduce(sdram_s1_grant_vector)) OR or_reduce(sdram_s1_grant_vector);
  --sdram_s1_end_xfer assignment, which is an e_assign
  sdram_s1_end_xfer <= NOT ((sdram_s1_waits_for_read OR sdram_s1_waits_for_write));
  --sdram_s1_arb_share_counter arbitration counter enable, which is an e_assign
  sdram_s1_arb_counter_enable <= sdram_s1_end_xfer AND sdram_s1_allgrants;
  --sdram_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sdram_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(sdram_s1_arb_counter_enable) = '1' then 
        sdram_s1_arb_share_counter <= sdram_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --sdram_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sdram_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((or_reduce(sdram_s1_master_qreq_vector) AND sdram_s1_end_xfer)) = '1' then 
        sdram_s1_slavearbiterlockenable <= or_reduce(sdram_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master sdram/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= sdram_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --cpu/instruction_master sdram/s1 arbiterlock, which is an e_assign
  cpu_instruction_master_arbiterlock <= sdram_s1_slavearbiterlockenable AND cpu_instruction_master_continuerequest;
  --cpu/instruction_master granted sdram/s1 last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_instruction_master_granted_slave_sdram_s1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_instruction_master_granted_slave_sdram_s1 <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_instruction_master_saved_grant_sdram_s1) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((sdram_s1_arbitration_holdoff_internal OR NOT internal_cpu_instruction_master_requests_sdram_s1))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_instruction_master_granted_slave_sdram_s1))))));
      end if;
    end if;

  end process;

  --cpu_instruction_master_continuerequest continued request, which is an e_mux
  cpu_instruction_master_continuerequest <= last_cycle_cpu_instruction_master_granted_slave_sdram_s1 AND internal_cpu_instruction_master_requests_sdram_s1;
  --sdram_s1_any_continuerequest at least one master continues requesting, which is an e_mux
  sdram_s1_any_continuerequest <= cpu_instruction_master_continuerequest OR cpu_data_master_continuerequest;
  internal_cpu_data_master_qualified_request_sdram_s1 <= internal_cpu_data_master_requests_sdram_s1 AND NOT (((((cpu_data_master_read AND ((NOT cpu_data_master_waitrequest OR (or_reduce(internal_cpu_data_master_read_data_valid_sdram_s1_shift_register)))))) OR (((((NOT cpu_data_master_waitrequest OR cpu_data_master_no_byte_enables_and_last_term) OR NOT(or_reduce(internal_cpu_data_master_byteenable_sdram_s1)))) AND cpu_data_master_write))) OR cpu_instruction_master_arbiterlock));
  --sdram_s1_posted_fifo_writenable register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_sdram_s1_posted_fifo_writenable <= std_logic_vector'("0000001");
    elsif clk'event and clk = '1' then
      if std_logic'((in_a_read_cycle AND NOT sdram_s1_waits_for_read)) = '1' then 
        internal_sdram_s1_posted_fifo_writenable <= Std_Logic_Vector'(A_ToStdLogicVector(internal_sdram_s1_posted_fifo_writenable(5)) & A_ToStdLogicVector(internal_sdram_s1_posted_fifo_writenable(4)) & A_ToStdLogicVector(internal_sdram_s1_posted_fifo_writenable(3)) & A_ToStdLogicVector(internal_sdram_s1_posted_fifo_writenable(2)) & A_ToStdLogicVector(internal_sdram_s1_posted_fifo_writenable(1)) & A_ToStdLogicVector(internal_sdram_s1_posted_fifo_writenable(0)) & A_ToStdLogicVector(internal_sdram_s1_posted_fifo_writenable(6)));
      end if;
    end if;

  end process;

  --sdram_s1_posted_fifo_readenable register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_sdram_s1_posted_fifo_readenable <= std_logic_vector'("0000001");
    elsif clk'event and clk = '1' then
      if std_logic'(sdram_s1_readdatavalid_from_sa) = '1' then 
        internal_sdram_s1_posted_fifo_readenable <= Std_Logic_Vector'(A_ToStdLogicVector(internal_sdram_s1_posted_fifo_readenable(5)) & A_ToStdLogicVector(internal_sdram_s1_posted_fifo_readenable(4)) & A_ToStdLogicVector(internal_sdram_s1_posted_fifo_readenable(3)) & A_ToStdLogicVector(internal_sdram_s1_posted_fifo_readenable(2)) & A_ToStdLogicVector(internal_sdram_s1_posted_fifo_readenable(1)) & A_ToStdLogicVector(internal_sdram_s1_posted_fifo_readenable(0)) & A_ToStdLogicVector(internal_sdram_s1_posted_fifo_readenable(6)));
      end if;
    end if;

  end process;

  --cpu_data_master_read_data_valid_sdram_s1_shift_register[0] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(0) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_data_master_granted_sdram_s1 AND cpu_data_master_read) AND internal_sdram_s1_posted_fifo_writenable(0)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(0) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(0))) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(0) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_data_master_read_data_valid_sdram_s1_shift_register[1] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(1) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_data_master_granted_sdram_s1 AND cpu_data_master_read) AND internal_sdram_s1_posted_fifo_writenable(1)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(1) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(1))) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(1) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_data_master_read_data_valid_sdram_s1_shift_register[2] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(2) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_data_master_granted_sdram_s1 AND cpu_data_master_read) AND internal_sdram_s1_posted_fifo_writenable(2)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(2) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(2))) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(2) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_data_master_read_data_valid_sdram_s1_shift_register[3] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(3) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_data_master_granted_sdram_s1 AND cpu_data_master_read) AND internal_sdram_s1_posted_fifo_writenable(3)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(3) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(3))) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(3) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_data_master_read_data_valid_sdram_s1_shift_register[4] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(4) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_data_master_granted_sdram_s1 AND cpu_data_master_read) AND internal_sdram_s1_posted_fifo_writenable(4)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(4) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(4))) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(4) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_data_master_read_data_valid_sdram_s1_shift_register[5] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(5) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_data_master_granted_sdram_s1 AND cpu_data_master_read) AND internal_sdram_s1_posted_fifo_writenable(5)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(5) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(5))) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(5) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_data_master_read_data_valid_sdram_s1_shift_register[6] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(6) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_data_master_granted_sdram_s1 AND cpu_data_master_read) AND internal_sdram_s1_posted_fifo_writenable(6)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(6) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(6))) = '1' then 
          internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(6) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_data_master_read_data_valid_sdram_s1_fifo_output mux: inputs:: variable latency fifo state.  Output selects master which gets readdata, which is an e_mux
  cpu_data_master_read_data_valid_sdram_s1_fifo_output <= (((((((internal_sdram_s1_posted_fifo_readenable(0) AND internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(0))) OR ((internal_sdram_s1_posted_fifo_readenable(1) AND internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(1)))) OR ((internal_sdram_s1_posted_fifo_readenable(2) AND internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(2)))) OR ((internal_sdram_s1_posted_fifo_readenable(3) AND internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(3)))) OR ((internal_sdram_s1_posted_fifo_readenable(4) AND internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(4)))) OR ((internal_sdram_s1_posted_fifo_readenable(5) AND internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(5)))) OR ((internal_sdram_s1_posted_fifo_readenable(6) AND internal_cpu_data_master_read_data_valid_sdram_s1_shift_register(6)));
  --local readdatavalid cpu_data_master_read_data_valid_sdram_s1, which is an e_mux
  cpu_data_master_read_data_valid_sdram_s1 <= sdram_s1_readdatavalid_from_sa AND cpu_data_master_read_data_valid_sdram_s1_fifo_output;
  --sdram_s1_writedata mux, which is an e_mux
  sdram_s1_writedata <= cpu_data_master_dbs_write_16;
  internal_cpu_instruction_master_requests_sdram_s1 <= ((to_std_logic(((Std_Logic_Vector'(A_ToStdLogicVector(cpu_instruction_master_address_to_slave(23)) & std_logic_vector'("00000000000000000000000")) = std_logic_vector'("100000000000000000000000")))) AND (cpu_instruction_master_read))) AND cpu_instruction_master_read;
  --cpu/data_master granted sdram/s1 last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_data_master_granted_slave_sdram_s1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_data_master_granted_slave_sdram_s1 <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_data_master_saved_grant_sdram_s1) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((sdram_s1_arbitration_holdoff_internal OR NOT internal_cpu_data_master_requests_sdram_s1))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_data_master_granted_slave_sdram_s1))))));
      end if;
    end if;

  end process;

  --cpu_data_master_continuerequest continued request, which is an e_mux
  cpu_data_master_continuerequest <= last_cycle_cpu_data_master_granted_slave_sdram_s1 AND internal_cpu_data_master_requests_sdram_s1;
  internal_cpu_instruction_master_qualified_request_sdram_s1 <= internal_cpu_instruction_master_requests_sdram_s1 AND NOT ((((cpu_instruction_master_read AND to_std_logic((((((std_logic_vector'("000000000000000000000000000000") & (cpu_instruction_master_latency_counter)) /= std_logic_vector'("00000000000000000000000000000000"))) OR ((std_logic_vector'("00000000000000000000000000000001")<(std_logic_vector'("000000000000000000000000000000") & (cpu_instruction_master_latency_counter))))))))) OR cpu_data_master_arbiterlock));
  --cpu_instruction_master_read_data_valid_sdram_s1_shift_register[0] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(0) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_instruction_master_granted_sdram_s1 AND cpu_instruction_master_read) AND internal_sdram_s1_posted_fifo_writenable(0)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(0) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(0))) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(0) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_instruction_master_read_data_valid_sdram_s1_shift_register[1] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(1) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_instruction_master_granted_sdram_s1 AND cpu_instruction_master_read) AND internal_sdram_s1_posted_fifo_writenable(1)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(1) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(1))) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(1) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_instruction_master_read_data_valid_sdram_s1_shift_register[2] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(2) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_instruction_master_granted_sdram_s1 AND cpu_instruction_master_read) AND internal_sdram_s1_posted_fifo_writenable(2)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(2) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(2))) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(2) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_instruction_master_read_data_valid_sdram_s1_shift_register[3] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(3) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_instruction_master_granted_sdram_s1 AND cpu_instruction_master_read) AND internal_sdram_s1_posted_fifo_writenable(3)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(3) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(3))) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(3) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_instruction_master_read_data_valid_sdram_s1_shift_register[4] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(4) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_instruction_master_granted_sdram_s1 AND cpu_instruction_master_read) AND internal_sdram_s1_posted_fifo_writenable(4)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(4) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(4))) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(4) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_instruction_master_read_data_valid_sdram_s1_shift_register[5] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(5) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_instruction_master_granted_sdram_s1 AND cpu_instruction_master_read) AND internal_sdram_s1_posted_fifo_writenable(5)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(5) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(5))) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(5) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_instruction_master_read_data_valid_sdram_s1_shift_register[6] variable latency, sets when master starts reading, clears slave data is valid, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(6) <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((((internal_cpu_instruction_master_granted_sdram_s1 AND cpu_instruction_master_read) AND internal_sdram_s1_posted_fifo_writenable(6)) AND NOT sdram_s1_waits_for_read)) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(6) <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        elsif std_logic'((sdram_s1_readdatavalid_from_sa AND internal_sdram_s1_posted_fifo_readenable(6))) = '1' then 
          internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(6) <= std_logic'('0');
        end if;
      end if;
    end if;

  end process;

  --cpu_instruction_master_read_data_valid_sdram_s1_fifo_output mux: inputs:: variable latency fifo state.  Output selects master which gets readdata, which is an e_mux
  cpu_instruction_master_read_data_valid_sdram_s1_fifo_output <= (((((((internal_sdram_s1_posted_fifo_readenable(0) AND internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(0))) OR ((internal_sdram_s1_posted_fifo_readenable(1) AND internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(1)))) OR ((internal_sdram_s1_posted_fifo_readenable(2) AND internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(2)))) OR ((internal_sdram_s1_posted_fifo_readenable(3) AND internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(3)))) OR ((internal_sdram_s1_posted_fifo_readenable(4) AND internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(4)))) OR ((internal_sdram_s1_posted_fifo_readenable(5) AND internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(5)))) OR ((internal_sdram_s1_posted_fifo_readenable(6) AND internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register(6)));
  --local readdatavalid cpu_instruction_master_read_data_valid_sdram_s1, which is an e_mux
  cpu_instruction_master_read_data_valid_sdram_s1 <= sdram_s1_readdatavalid_from_sa AND cpu_instruction_master_read_data_valid_sdram_s1_fifo_output;
  --allow new arb cycle for sdram/s1, which is an e_assign
  sdram_s1_allow_new_arb_cycle <= NOT cpu_data_master_arbiterlock AND NOT cpu_instruction_master_arbiterlock;
  --cpu/instruction_master assignment into master qualified-requests vector for sdram/s1, which is an e_assign
  sdram_s1_master_qreq_vector(0) <= internal_cpu_instruction_master_qualified_request_sdram_s1;
  --cpu/instruction_master grant sdram/s1, which is an e_assign
  internal_cpu_instruction_master_granted_sdram_s1 <= sdram_s1_grant_vector(0);
  --cpu/instruction_master saved-grant sdram/s1, which is an e_assign
  cpu_instruction_master_saved_grant_sdram_s1 <= sdram_s1_arb_winner(0) AND internal_cpu_instruction_master_requests_sdram_s1;
  --cpu/data_master assignment into master qualified-requests vector for sdram/s1, which is an e_assign
  sdram_s1_master_qreq_vector(1) <= internal_cpu_data_master_qualified_request_sdram_s1;
  --cpu/data_master grant sdram/s1, which is an e_assign
  internal_cpu_data_master_granted_sdram_s1 <= sdram_s1_grant_vector(1);
  --cpu/data_master saved-grant sdram/s1, which is an e_assign
  cpu_data_master_saved_grant_sdram_s1 <= sdram_s1_arb_winner(1) AND internal_cpu_data_master_requests_sdram_s1;
  --sdram/s1 chosen-master double-vector, which is an e_assign
  sdram_s1_chosen_master_double_vector <= A_EXT (((std_logic_vector'("0") & ((sdram_s1_master_qreq_vector & sdram_s1_master_qreq_vector))) AND (((std_logic_vector'("0") & (Std_Logic_Vector'(NOT sdram_s1_master_qreq_vector & NOT sdram_s1_master_qreq_vector))) + (std_logic_vector'("000") & (sdram_s1_arb_addend))))), 4);
  --stable onehot encoding of arb winner
  sdram_s1_arb_winner <= A_WE_StdLogicVector((std_logic'(((sdram_s1_allow_new_arb_cycle AND or_reduce(sdram_s1_grant_vector)))) = '1'), sdram_s1_grant_vector, sdram_s1_saved_chosen_master_vector);
  --saved sdram_s1_grant_vector, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sdram_s1_saved_chosen_master_vector <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(sdram_s1_allow_new_arb_cycle) = '1' then 
        sdram_s1_saved_chosen_master_vector <= A_WE_StdLogicVector((std_logic'(or_reduce(sdram_s1_grant_vector)) = '1'), sdram_s1_grant_vector, sdram_s1_saved_chosen_master_vector);
      end if;
    end if;

  end process;

  --onehot encoding of chosen master
  sdram_s1_grant_vector <= Std_Logic_Vector'(A_ToStdLogicVector(((sdram_s1_chosen_master_double_vector(1) OR sdram_s1_chosen_master_double_vector(3)))) & A_ToStdLogicVector(((sdram_s1_chosen_master_double_vector(0) OR sdram_s1_chosen_master_double_vector(2)))));
  --sdram/s1 chosen master rotated left, which is an e_assign
  sdram_s1_chosen_master_rot_left <= A_EXT (A_WE_StdLogicVector((((A_SLL(sdram_s1_arb_winner,std_logic_vector'("00000000000000000000000000000001")))) /= std_logic_vector'("00")), (std_logic_vector'("000000000000000000000000000000") & ((A_SLL(sdram_s1_arb_winner,std_logic_vector'("00000000000000000000000000000001"))))), std_logic_vector'("00000000000000000000000000000001")), 2);
  --sdram/s1's addend for next-master-grant
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sdram_s1_arb_addend <= std_logic_vector'("01");
    elsif clk'event and clk = '1' then
      if std_logic'(or_reduce(sdram_s1_grant_vector)) = '1' then 
        sdram_s1_arb_addend <= A_WE_StdLogicVector((std_logic'(sdram_s1_end_xfer) = '1'), sdram_s1_chosen_master_rot_left, sdram_s1_grant_vector);
      end if;
    end if;

  end process;

  --sdram_s1_reset_n assignment, which is an e_assign
  sdram_s1_reset_n <= reset_n;
  sdram_s1_chipselect <= internal_cpu_data_master_granted_sdram_s1 OR internal_cpu_instruction_master_granted_sdram_s1;
  --sdram_s1_firsttransfer first transaction, which is an e_assign
  sdram_s1_firsttransfer <= NOT ((sdram_s1_slavearbiterlockenable AND sdram_s1_any_continuerequest));
  --sdram_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  sdram_s1_beginbursttransfer_internal <= sdram_s1_begins_xfer AND sdram_s1_firsttransfer;
  --sdram_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  sdram_s1_arbitration_holdoff_internal <= sdram_s1_begins_xfer AND sdram_s1_firsttransfer;
  --~sdram_s1_read_n assignment, which is an e_mux
  sdram_s1_read_n <= NOT ((((internal_cpu_data_master_granted_sdram_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_sdram_s1 AND cpu_instruction_master_read))));
  --~sdram_s1_write_n assignment, which is an e_mux
  sdram_s1_write_n <= NOT ((internal_cpu_data_master_granted_sdram_s1 AND cpu_data_master_write));
  --sdram_s1_address mux, which is an e_mux
  sdram_s1_address <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_sdram_s1)) = '1'), (Std_Logic_Vector'(A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")) & A_ToStdLogicVector(cpu_data_master_dbs_address(1)))), (Std_Logic_Vector'(A_SRL(cpu_instruction_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")) & A_ToStdLogicVector(cpu_instruction_master_dbs_address(1))))), 22);
  --d1_sdram_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_sdram_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_sdram_s1_end_xfer <= sdram_s1_end_xfer;
      end if;
    end if;

  end process;

  --sdram_s1_waits_for_read in a cycle, which is an e_mux
  sdram_s1_waits_for_read <= sdram_s1_in_a_read_cycle AND internal_sdram_s1_waitrequest_from_sa;
  --sdram_s1_in_a_read_cycle assignment, which is an e_assign
  sdram_s1_in_a_read_cycle <= ((internal_cpu_data_master_granted_sdram_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_sdram_s1 AND cpu_instruction_master_read));
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= sdram_s1_in_a_read_cycle;
  --sdram_s1_waits_for_write in a cycle, which is an e_mux
  sdram_s1_waits_for_write <= sdram_s1_in_a_write_cycle AND internal_sdram_s1_waitrequest_from_sa;
  --sdram_s1_in_a_write_cycle assignment, which is an e_assign
  sdram_s1_in_a_write_cycle <= internal_cpu_data_master_granted_sdram_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= sdram_s1_in_a_write_cycle;
  wait_for_sdram_s1_counter <= std_logic'('0');
  --~sdram_s1_byteenable_n byte enable port mux, which is an e_mux
  sdram_s1_byteenable_n <= A_EXT (NOT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_sdram_s1)) = '1'), (std_logic_vector'("000000000000000000000000000000") & (internal_cpu_data_master_byteenable_sdram_s1)), -SIGNED(std_logic_vector'("00000000000000000000000000000001")))), 2);
  (cpu_data_master_byteenable_sdram_s1_segment_1(1), cpu_data_master_byteenable_sdram_s1_segment_1(0), cpu_data_master_byteenable_sdram_s1_segment_0(1), cpu_data_master_byteenable_sdram_s1_segment_0(0)) <= cpu_data_master_byteenable;
  internal_cpu_data_master_byteenable_sdram_s1 <= A_WE_StdLogicVector((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_dbs_address(1)))) = std_logic_vector'("00000000000000000000000000000000"))), cpu_data_master_byteenable_sdram_s1_segment_0, cpu_data_master_byteenable_sdram_s1_segment_1);
  --vhdl renameroo for output signals
  cpu_data_master_byteenable_sdram_s1 <= internal_cpu_data_master_byteenable_sdram_s1;
  --vhdl renameroo for output signals
  cpu_data_master_granted_sdram_s1 <= internal_cpu_data_master_granted_sdram_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_sdram_s1 <= internal_cpu_data_master_qualified_request_sdram_s1;
  --vhdl renameroo for output signals
  cpu_data_master_read_data_valid_sdram_s1_shift_register <= internal_cpu_data_master_read_data_valid_sdram_s1_shift_register;
  --vhdl renameroo for output signals
  cpu_data_master_requests_sdram_s1 <= internal_cpu_data_master_requests_sdram_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_granted_sdram_s1 <= internal_cpu_instruction_master_granted_sdram_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_qualified_request_sdram_s1 <= internal_cpu_instruction_master_qualified_request_sdram_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_read_data_valid_sdram_s1_shift_register <= internal_cpu_instruction_master_read_data_valid_sdram_s1_shift_register;
  --vhdl renameroo for output signals
  cpu_instruction_master_requests_sdram_s1 <= internal_cpu_instruction_master_requests_sdram_s1;
  --vhdl renameroo for output signals
  sdram_s1_posted_fifo_readenable <= internal_sdram_s1_posted_fifo_readenable;
  --vhdl renameroo for output signals
  sdram_s1_posted_fifo_writenable <= internal_sdram_s1_posted_fifo_writenable;
  --vhdl renameroo for output signals
  sdram_s1_waitrequest_from_sa <= internal_sdram_s1_waitrequest_from_sa;
--synthesis translate_off
    --grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line8 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_data_master_granted_sdram_s1))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_instruction_master_granted_sdram_s1))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line8, now);
          write(write_line8, string'(": "));
          write(write_line8, string'("> 1 of grant signals are active simultaneously"));
          write(output, write_line8.all);
          deallocate (write_line8);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --saved_grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line9 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_data_master_saved_grant_sdram_s1))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_saved_grant_sdram_s1))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line9, now);
          write(write_line9, string'(": "));
          write(write_line9, string'("> 1 of saved_grant signals are active simultaneously"));
          write(output, write_line9.all);
          deallocate (write_line9);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity seven_seg_avalonS_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_seven_seg_avalonS : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_seven_seg_avalonS : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_seven_seg_avalonS : OUT STD_LOGIC;
                 signal cpu_data_master_requests_seven_seg_avalonS : OUT STD_LOGIC;
                 signal cpu_instruction_master_granted_seven_seg_avalonS : OUT STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_seven_seg_avalonS : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_seven_seg_avalonS : OUT STD_LOGIC;
                 signal cpu_instruction_master_requests_seven_seg_avalonS : OUT STD_LOGIC;
                 signal d1_seven_seg_avalonS_end_xfer : OUT STD_LOGIC;
                 signal seven_seg_avalonS_reset_n : OUT STD_LOGIC;
                 signal seven_seg_avalonS_write : OUT STD_LOGIC;
                 signal seven_seg_avalonS_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of seven_seg_avalonS_arbitrator : entity is FALSE;
end entity seven_seg_avalonS_arbitrator;


architecture europa of seven_seg_avalonS_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_seven_seg_avalonS :  STD_LOGIC;
                signal cpu_instruction_master_arbiterlock :  STD_LOGIC;
                signal cpu_instruction_master_continuerequest :  STD_LOGIC;
                signal cpu_instruction_master_saved_grant_seven_seg_avalonS :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_seven_seg_avalonS :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_seven_seg_avalonS :  STD_LOGIC;
                signal internal_cpu_data_master_requests_seven_seg_avalonS :  STD_LOGIC;
                signal internal_cpu_instruction_master_granted_seven_seg_avalonS :  STD_LOGIC;
                signal internal_cpu_instruction_master_qualified_request_seven_seg_avalonS :  STD_LOGIC;
                signal internal_cpu_instruction_master_requests_seven_seg_avalonS :  STD_LOGIC;
                signal last_cycle_cpu_data_master_granted_slave_seven_seg_avalonS :  STD_LOGIC;
                signal last_cycle_cpu_instruction_master_granted_slave_seven_seg_avalonS :  STD_LOGIC;
                signal seven_seg_avalonS_address_for_slave_wo_address :  STD_LOGIC;
                signal seven_seg_avalonS_allgrants :  STD_LOGIC;
                signal seven_seg_avalonS_allow_new_arb_cycle :  STD_LOGIC;
                signal seven_seg_avalonS_any_continuerequest :  STD_LOGIC;
                signal seven_seg_avalonS_arb_addend :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal seven_seg_avalonS_arb_counter_enable :  STD_LOGIC;
                signal seven_seg_avalonS_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal seven_seg_avalonS_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal seven_seg_avalonS_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal seven_seg_avalonS_arb_winner :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal seven_seg_avalonS_arbitration_holdoff_internal :  STD_LOGIC;
                signal seven_seg_avalonS_beginbursttransfer_internal :  STD_LOGIC;
                signal seven_seg_avalonS_begins_xfer :  STD_LOGIC;
                signal seven_seg_avalonS_chosen_master_double_vector :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal seven_seg_avalonS_chosen_master_rot_left :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal seven_seg_avalonS_end_xfer :  STD_LOGIC;
                signal seven_seg_avalonS_firsttransfer :  STD_LOGIC;
                signal seven_seg_avalonS_grant_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal seven_seg_avalonS_in_a_read_cycle :  STD_LOGIC;
                signal seven_seg_avalonS_in_a_write_cycle :  STD_LOGIC;
                signal seven_seg_avalonS_master_qreq_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal seven_seg_avalonS_saved_chosen_master_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal seven_seg_avalonS_slavearbiterlockenable :  STD_LOGIC;
                signal seven_seg_avalonS_waits_for_read :  STD_LOGIC;
                signal seven_seg_avalonS_waits_for_write :  STD_LOGIC;
                signal wait_for_seven_seg_avalonS_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT seven_seg_avalonS_end_xfer;
      end if;
    end if;

  end process;

  seven_seg_avalonS_begins_xfer <= NOT d1_reasons_to_wait AND ((internal_cpu_data_master_qualified_request_seven_seg_avalonS OR internal_cpu_instruction_master_qualified_request_seven_seg_avalonS));
  internal_cpu_data_master_requests_seven_seg_avalonS <= ((to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 2) & std_logic_vector'("00")) = std_logic_vector'("001000100000000010010000")))) AND ((cpu_data_master_read OR cpu_data_master_write)))) AND cpu_data_master_write;
  --seven_seg_avalonS_arb_share_counter set values, which is an e_mux
  seven_seg_avalonS_arb_share_set_values <= std_logic_vector'("001");
  --seven_seg_avalonS_arb_share_counter_next_value assignment, which is an e_assign
  seven_seg_avalonS_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(seven_seg_avalonS_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (seven_seg_avalonS_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(seven_seg_avalonS_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (seven_seg_avalonS_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --seven_seg_avalonS_allgrants all slave grants, which is an e_mux
  seven_seg_avalonS_allgrants <= ((or_reduce(seven_seg_avalonS_grant_vector) OR or_reduce(seven_seg_avalonS_grant_vector)) OR or_reduce(seven_seg_avalonS_grant_vector)) OR or_reduce(seven_seg_avalonS_grant_vector);
  --seven_seg_avalonS_end_xfer assignment, which is an e_assign
  seven_seg_avalonS_end_xfer <= NOT ((seven_seg_avalonS_waits_for_read OR seven_seg_avalonS_waits_for_write));
  --seven_seg_avalonS_arb_share_counter arbitration counter enable, which is an e_assign
  seven_seg_avalonS_arb_counter_enable <= seven_seg_avalonS_end_xfer AND seven_seg_avalonS_allgrants;
  --seven_seg_avalonS_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      seven_seg_avalonS_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(seven_seg_avalonS_arb_counter_enable) = '1' then 
        seven_seg_avalonS_arb_share_counter <= seven_seg_avalonS_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --seven_seg_avalonS_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      seven_seg_avalonS_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((or_reduce(seven_seg_avalonS_master_qreq_vector) AND seven_seg_avalonS_end_xfer)) = '1' then 
        seven_seg_avalonS_slavearbiterlockenable <= or_reduce(seven_seg_avalonS_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master seven_seg/avalonS arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= seven_seg_avalonS_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --cpu/instruction_master seven_seg/avalonS arbiterlock, which is an e_assign
  cpu_instruction_master_arbiterlock <= seven_seg_avalonS_slavearbiterlockenable AND cpu_instruction_master_continuerequest;
  --cpu/instruction_master granted seven_seg/avalonS last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_instruction_master_granted_slave_seven_seg_avalonS <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_instruction_master_granted_slave_seven_seg_avalonS <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_instruction_master_saved_grant_seven_seg_avalonS) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((seven_seg_avalonS_arbitration_holdoff_internal OR NOT internal_cpu_instruction_master_requests_seven_seg_avalonS))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_instruction_master_granted_slave_seven_seg_avalonS))))));
      end if;
    end if;

  end process;

  --cpu_instruction_master_continuerequest continued request, which is an e_mux
  cpu_instruction_master_continuerequest <= last_cycle_cpu_instruction_master_granted_slave_seven_seg_avalonS AND internal_cpu_instruction_master_requests_seven_seg_avalonS;
  --seven_seg_avalonS_any_continuerequest at least one master continues requesting, which is an e_mux
  seven_seg_avalonS_any_continuerequest <= cpu_instruction_master_continuerequest OR cpu_data_master_continuerequest;
  internal_cpu_data_master_qualified_request_seven_seg_avalonS <= internal_cpu_data_master_requests_seven_seg_avalonS AND NOT (((((NOT cpu_data_master_waitrequest) AND cpu_data_master_write)) OR cpu_instruction_master_arbiterlock));
  --seven_seg_avalonS_writedata mux, which is an e_mux
  seven_seg_avalonS_writedata <= cpu_data_master_writedata;
  internal_cpu_instruction_master_requests_seven_seg_avalonS <= to_std_logic(((Std_Logic_Vector'(cpu_instruction_master_address_to_slave(23 DOWNTO 2) & std_logic_vector'("00")) = std_logic_vector'("001000100000000010010000")))) AND (cpu_instruction_master_read);
  --cpu/data_master granted seven_seg/avalonS last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_data_master_granted_slave_seven_seg_avalonS <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_data_master_granted_slave_seven_seg_avalonS <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_data_master_saved_grant_seven_seg_avalonS) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((seven_seg_avalonS_arbitration_holdoff_internal OR NOT internal_cpu_data_master_requests_seven_seg_avalonS))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_data_master_granted_slave_seven_seg_avalonS))))));
      end if;
    end if;

  end process;

  --cpu_data_master_continuerequest continued request, which is an e_mux
  cpu_data_master_continuerequest <= last_cycle_cpu_data_master_granted_slave_seven_seg_avalonS AND internal_cpu_data_master_requests_seven_seg_avalonS;
  internal_cpu_instruction_master_qualified_request_seven_seg_avalonS <= internal_cpu_instruction_master_requests_seven_seg_avalonS AND NOT (cpu_data_master_arbiterlock);
  --local readdatavalid cpu_instruction_master_read_data_valid_seven_seg_avalonS, which is an e_mux
  cpu_instruction_master_read_data_valid_seven_seg_avalonS <= (internal_cpu_instruction_master_granted_seven_seg_avalonS AND cpu_instruction_master_read) AND NOT seven_seg_avalonS_waits_for_read;
  --allow new arb cycle for seven_seg/avalonS, which is an e_assign
  seven_seg_avalonS_allow_new_arb_cycle <= NOT cpu_data_master_arbiterlock AND NOT cpu_instruction_master_arbiterlock;
  --cpu/instruction_master assignment into master qualified-requests vector for seven_seg/avalonS, which is an e_assign
  seven_seg_avalonS_master_qreq_vector(0) <= internal_cpu_instruction_master_qualified_request_seven_seg_avalonS;
  --cpu/instruction_master grant seven_seg/avalonS, which is an e_assign
  internal_cpu_instruction_master_granted_seven_seg_avalonS <= seven_seg_avalonS_grant_vector(0);
  --cpu/instruction_master saved-grant seven_seg/avalonS, which is an e_assign
  cpu_instruction_master_saved_grant_seven_seg_avalonS <= seven_seg_avalonS_arb_winner(0) AND internal_cpu_instruction_master_requests_seven_seg_avalonS;
  --cpu/data_master assignment into master qualified-requests vector for seven_seg/avalonS, which is an e_assign
  seven_seg_avalonS_master_qreq_vector(1) <= internal_cpu_data_master_qualified_request_seven_seg_avalonS;
  --cpu/data_master grant seven_seg/avalonS, which is an e_assign
  internal_cpu_data_master_granted_seven_seg_avalonS <= seven_seg_avalonS_grant_vector(1);
  --cpu/data_master saved-grant seven_seg/avalonS, which is an e_assign
  cpu_data_master_saved_grant_seven_seg_avalonS <= seven_seg_avalonS_arb_winner(1) AND internal_cpu_data_master_requests_seven_seg_avalonS;
  --seven_seg/avalonS chosen-master double-vector, which is an e_assign
  seven_seg_avalonS_chosen_master_double_vector <= A_EXT (((std_logic_vector'("0") & ((seven_seg_avalonS_master_qreq_vector & seven_seg_avalonS_master_qreq_vector))) AND (((std_logic_vector'("0") & (Std_Logic_Vector'(NOT seven_seg_avalonS_master_qreq_vector & NOT seven_seg_avalonS_master_qreq_vector))) + (std_logic_vector'("000") & (seven_seg_avalonS_arb_addend))))), 4);
  --stable onehot encoding of arb winner
  seven_seg_avalonS_arb_winner <= A_WE_StdLogicVector((std_logic'(((seven_seg_avalonS_allow_new_arb_cycle AND or_reduce(seven_seg_avalonS_grant_vector)))) = '1'), seven_seg_avalonS_grant_vector, seven_seg_avalonS_saved_chosen_master_vector);
  --saved seven_seg_avalonS_grant_vector, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      seven_seg_avalonS_saved_chosen_master_vector <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(seven_seg_avalonS_allow_new_arb_cycle) = '1' then 
        seven_seg_avalonS_saved_chosen_master_vector <= A_WE_StdLogicVector((std_logic'(or_reduce(seven_seg_avalonS_grant_vector)) = '1'), seven_seg_avalonS_grant_vector, seven_seg_avalonS_saved_chosen_master_vector);
      end if;
    end if;

  end process;

  --onehot encoding of chosen master
  seven_seg_avalonS_grant_vector <= Std_Logic_Vector'(A_ToStdLogicVector(((seven_seg_avalonS_chosen_master_double_vector(1) OR seven_seg_avalonS_chosen_master_double_vector(3)))) & A_ToStdLogicVector(((seven_seg_avalonS_chosen_master_double_vector(0) OR seven_seg_avalonS_chosen_master_double_vector(2)))));
  --seven_seg/avalonS chosen master rotated left, which is an e_assign
  seven_seg_avalonS_chosen_master_rot_left <= A_EXT (A_WE_StdLogicVector((((A_SLL(seven_seg_avalonS_arb_winner,std_logic_vector'("00000000000000000000000000000001")))) /= std_logic_vector'("00")), (std_logic_vector'("000000000000000000000000000000") & ((A_SLL(seven_seg_avalonS_arb_winner,std_logic_vector'("00000000000000000000000000000001"))))), std_logic_vector'("00000000000000000000000000000001")), 2);
  --seven_seg/avalonS's addend for next-master-grant
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      seven_seg_avalonS_arb_addend <= std_logic_vector'("01");
    elsif clk'event and clk = '1' then
      if std_logic'(or_reduce(seven_seg_avalonS_grant_vector)) = '1' then 
        seven_seg_avalonS_arb_addend <= A_WE_StdLogicVector((std_logic'(seven_seg_avalonS_end_xfer) = '1'), seven_seg_avalonS_chosen_master_rot_left, seven_seg_avalonS_grant_vector);
      end if;
    end if;

  end process;

  --seven_seg_avalonS_reset_n assignment, which is an e_assign
  seven_seg_avalonS_reset_n <= reset_n;
  --seven_seg_avalonS_firsttransfer first transaction, which is an e_assign
  seven_seg_avalonS_firsttransfer <= NOT ((seven_seg_avalonS_slavearbiterlockenable AND seven_seg_avalonS_any_continuerequest));
  --seven_seg_avalonS_beginbursttransfer_internal begin burst transfer, which is an e_assign
  seven_seg_avalonS_beginbursttransfer_internal <= seven_seg_avalonS_begins_xfer AND seven_seg_avalonS_firsttransfer;
  --seven_seg_avalonS_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  seven_seg_avalonS_arbitration_holdoff_internal <= seven_seg_avalonS_begins_xfer AND seven_seg_avalonS_firsttransfer;
  --seven_seg_avalonS_write assignment, which is an e_mux
  seven_seg_avalonS_write <= internal_cpu_data_master_granted_seven_seg_avalonS AND cpu_data_master_write;
  --seven_seg_avalonS_address_for_slave_wo_address mux, which is an e_mux
  seven_seg_avalonS_address_for_slave_wo_address <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_seven_seg_avalonS)) = '1'), (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010"))), (A_SRL(cpu_instruction_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")))));
  --d1_seven_seg_avalonS_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_seven_seg_avalonS_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_seven_seg_avalonS_end_xfer <= seven_seg_avalonS_end_xfer;
      end if;
    end if;

  end process;

  --seven_seg_avalonS_waits_for_read in a cycle, which is an e_mux
  seven_seg_avalonS_waits_for_read <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(seven_seg_avalonS_in_a_read_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --seven_seg_avalonS_in_a_read_cycle assignment, which is an e_assign
  seven_seg_avalonS_in_a_read_cycle <= ((internal_cpu_data_master_granted_seven_seg_avalonS AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_seven_seg_avalonS AND cpu_instruction_master_read));
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= seven_seg_avalonS_in_a_read_cycle;
  --seven_seg_avalonS_waits_for_write in a cycle, which is an e_mux
  seven_seg_avalonS_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(seven_seg_avalonS_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --seven_seg_avalonS_in_a_write_cycle assignment, which is an e_assign
  seven_seg_avalonS_in_a_write_cycle <= internal_cpu_data_master_granted_seven_seg_avalonS AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= seven_seg_avalonS_in_a_write_cycle;
  wait_for_seven_seg_avalonS_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_data_master_granted_seven_seg_avalonS <= internal_cpu_data_master_granted_seven_seg_avalonS;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_seven_seg_avalonS <= internal_cpu_data_master_qualified_request_seven_seg_avalonS;
  --vhdl renameroo for output signals
  cpu_data_master_requests_seven_seg_avalonS <= internal_cpu_data_master_requests_seven_seg_avalonS;
  --vhdl renameroo for output signals
  cpu_instruction_master_granted_seven_seg_avalonS <= internal_cpu_instruction_master_granted_seven_seg_avalonS;
  --vhdl renameroo for output signals
  cpu_instruction_master_qualified_request_seven_seg_avalonS <= internal_cpu_instruction_master_qualified_request_seven_seg_avalonS;
  --vhdl renameroo for output signals
  cpu_instruction_master_requests_seven_seg_avalonS <= internal_cpu_instruction_master_requests_seven_seg_avalonS;
--synthesis translate_off
    --grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line10 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_data_master_granted_seven_seg_avalonS))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_instruction_master_granted_seven_seg_avalonS))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line10, now);
          write(write_line10, string'(": "));
          write(write_line10, string'("> 1 of grant signals are active simultaneously"));
          write(output, write_line10.all);
          deallocate (write_line10);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --saved_grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line11 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_data_master_saved_grant_seven_seg_avalonS))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_saved_grant_seven_seg_avalonS))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line11, now);
          write(write_line11, string'(": "));
          write(write_line11, string'("> 1 of saved_grant signals are active simultaneously"));
          write(output, write_line11.all);
          deallocate (write_line11);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity sram_avalonS_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_dbs_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_dbs_write_16 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal cpu_data_master_no_byte_enables_and_last_term : IN STD_LOGIC;
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_instruction_master_dbs_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_sdram_s1_shift_register : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;
                 signal sram_avalonS_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

              -- outputs:
                 signal cpu_data_master_byteenable_sram_avalonS : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_granted_sram_avalonS : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_sram_avalonS : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_sram_avalonS : OUT STD_LOGIC;
                 signal cpu_data_master_requests_sram_avalonS : OUT STD_LOGIC;
                 signal cpu_instruction_master_granted_sram_avalonS : OUT STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_sram_avalonS : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_sram_avalonS : OUT STD_LOGIC;
                 signal cpu_instruction_master_requests_sram_avalonS : OUT STD_LOGIC;
                 signal d1_sram_avalonS_end_xfer : OUT STD_LOGIC;
                 signal sram_avalonS_address : OUT STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal sram_avalonS_byteenable_n : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal sram_avalonS_chipselect_n : OUT STD_LOGIC;
                 signal sram_avalonS_outputenable_n : OUT STD_LOGIC;
                 signal sram_avalonS_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal sram_avalonS_reset_n : OUT STD_LOGIC;
                 signal sram_avalonS_wait_counter_eq_0 : OUT STD_LOGIC;
                 signal sram_avalonS_write_n : OUT STD_LOGIC;
                 signal sram_avalonS_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of sram_avalonS_arbitrator : entity is FALSE;
end entity sram_avalonS_arbitrator;


architecture europa of sram_avalonS_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_byteenable_sram_avalonS_segment_0 :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_byteenable_sram_avalonS_segment_1 :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_sram_avalonS :  STD_LOGIC;
                signal cpu_instruction_master_arbiterlock :  STD_LOGIC;
                signal cpu_instruction_master_continuerequest :  STD_LOGIC;
                signal cpu_instruction_master_saved_grant_sram_avalonS :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_byteenable_sram_avalonS :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal internal_cpu_data_master_granted_sram_avalonS :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_sram_avalonS :  STD_LOGIC;
                signal internal_cpu_data_master_requests_sram_avalonS :  STD_LOGIC;
                signal internal_cpu_instruction_master_granted_sram_avalonS :  STD_LOGIC;
                signal internal_cpu_instruction_master_qualified_request_sram_avalonS :  STD_LOGIC;
                signal internal_cpu_instruction_master_requests_sram_avalonS :  STD_LOGIC;
                signal internal_sram_avalonS_wait_counter_eq_0 :  STD_LOGIC;
                signal last_cycle_cpu_data_master_granted_slave_sram_avalonS :  STD_LOGIC;
                signal last_cycle_cpu_instruction_master_granted_slave_sram_avalonS :  STD_LOGIC;
                signal sram_avalonS_allgrants :  STD_LOGIC;
                signal sram_avalonS_allow_new_arb_cycle :  STD_LOGIC;
                signal sram_avalonS_any_continuerequest :  STD_LOGIC;
                signal sram_avalonS_arb_addend :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal sram_avalonS_arb_counter_enable :  STD_LOGIC;
                signal sram_avalonS_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal sram_avalonS_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal sram_avalonS_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal sram_avalonS_arb_winner :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal sram_avalonS_arbitration_holdoff_internal :  STD_LOGIC;
                signal sram_avalonS_beginbursttransfer_internal :  STD_LOGIC;
                signal sram_avalonS_begins_xfer :  STD_LOGIC;
                signal sram_avalonS_chosen_master_double_vector :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal sram_avalonS_chosen_master_rot_left :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal sram_avalonS_counter_load_value :  STD_LOGIC;
                signal sram_avalonS_end_xfer :  STD_LOGIC;
                signal sram_avalonS_firsttransfer :  STD_LOGIC;
                signal sram_avalonS_grant_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal sram_avalonS_in_a_read_cycle :  STD_LOGIC;
                signal sram_avalonS_in_a_write_cycle :  STD_LOGIC;
                signal sram_avalonS_master_qreq_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal sram_avalonS_saved_chosen_master_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal sram_avalonS_slavearbiterlockenable :  STD_LOGIC;
                signal sram_avalonS_wait_counter :  STD_LOGIC;
                signal sram_avalonS_waits_for_read :  STD_LOGIC;
                signal sram_avalonS_waits_for_write :  STD_LOGIC;
                signal wait_for_sram_avalonS_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT sram_avalonS_end_xfer;
      end if;
    end if;

  end process;

  sram_avalonS_begins_xfer <= NOT d1_reasons_to_wait AND ((internal_cpu_data_master_qualified_request_sram_avalonS OR internal_cpu_instruction_master_qualified_request_sram_avalonS));
  --assign sram_avalonS_readdata_from_sa = sram_avalonS_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  sram_avalonS_readdata_from_sa <= sram_avalonS_readdata;
  internal_cpu_data_master_requests_sram_avalonS <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 19) & std_logic_vector'("0000000000000000000")) = std_logic_vector'("000100000000000000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --sram_avalonS_arb_share_counter set values, which is an e_mux
  sram_avalonS_arb_share_set_values <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_sram_avalonS)) = '1'), std_logic_vector'("00000000000000000000000000000010"), A_WE_StdLogicVector((std_logic'((internal_cpu_instruction_master_granted_sram_avalonS)) = '1'), std_logic_vector'("00000000000000000000000000000010"), A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_sram_avalonS)) = '1'), std_logic_vector'("00000000000000000000000000000010"), A_WE_StdLogicVector((std_logic'((internal_cpu_instruction_master_granted_sram_avalonS)) = '1'), std_logic_vector'("00000000000000000000000000000010"), std_logic_vector'("00000000000000000000000000000001"))))), 3);
  --sram_avalonS_arb_share_counter_next_value assignment, which is an e_assign
  sram_avalonS_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(sram_avalonS_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (sram_avalonS_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(sram_avalonS_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (sram_avalonS_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --sram_avalonS_allgrants all slave grants, which is an e_mux
  sram_avalonS_allgrants <= ((or_reduce(sram_avalonS_grant_vector) OR or_reduce(sram_avalonS_grant_vector)) OR or_reduce(sram_avalonS_grant_vector)) OR or_reduce(sram_avalonS_grant_vector);
  --sram_avalonS_end_xfer assignment, which is an e_assign
  sram_avalonS_end_xfer <= NOT ((sram_avalonS_waits_for_read OR sram_avalonS_waits_for_write));
  --sram_avalonS_arb_share_counter arbitration counter enable, which is an e_assign
  sram_avalonS_arb_counter_enable <= sram_avalonS_end_xfer AND sram_avalonS_allgrants;
  --sram_avalonS_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sram_avalonS_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(sram_avalonS_arb_counter_enable) = '1' then 
        sram_avalonS_arb_share_counter <= sram_avalonS_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --sram_avalonS_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sram_avalonS_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((or_reduce(sram_avalonS_master_qreq_vector) AND sram_avalonS_end_xfer)) = '1' then 
        sram_avalonS_slavearbiterlockenable <= or_reduce(sram_avalonS_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master sram/avalonS arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= sram_avalonS_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --cpu/instruction_master sram/avalonS arbiterlock, which is an e_assign
  cpu_instruction_master_arbiterlock <= sram_avalonS_slavearbiterlockenable AND cpu_instruction_master_continuerequest;
  --cpu/instruction_master granted sram/avalonS last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_instruction_master_granted_slave_sram_avalonS <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_instruction_master_granted_slave_sram_avalonS <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_instruction_master_saved_grant_sram_avalonS) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((sram_avalonS_arbitration_holdoff_internal OR NOT internal_cpu_instruction_master_requests_sram_avalonS))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_instruction_master_granted_slave_sram_avalonS))))));
      end if;
    end if;

  end process;

  --cpu_instruction_master_continuerequest continued request, which is an e_mux
  cpu_instruction_master_continuerequest <= last_cycle_cpu_instruction_master_granted_slave_sram_avalonS AND internal_cpu_instruction_master_requests_sram_avalonS;
  --sram_avalonS_any_continuerequest at least one master continues requesting, which is an e_mux
  sram_avalonS_any_continuerequest <= cpu_instruction_master_continuerequest OR cpu_data_master_continuerequest;
  internal_cpu_data_master_qualified_request_sram_avalonS <= internal_cpu_data_master_requests_sram_avalonS AND NOT ((((((cpu_data_master_no_byte_enables_and_last_term OR NOT(or_reduce(internal_cpu_data_master_byteenable_sram_avalonS)))) AND cpu_data_master_write)) OR cpu_instruction_master_arbiterlock));
  --sram_avalonS_writedata mux, which is an e_mux
  sram_avalonS_writedata <= cpu_data_master_dbs_write_16;
  internal_cpu_instruction_master_requests_sram_avalonS <= ((to_std_logic(((Std_Logic_Vector'(cpu_instruction_master_address_to_slave(23 DOWNTO 19) & std_logic_vector'("0000000000000000000")) = std_logic_vector'("000100000000000000000000")))) AND (cpu_instruction_master_read))) AND cpu_instruction_master_read;
  --cpu/data_master granted sram/avalonS last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_data_master_granted_slave_sram_avalonS <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_data_master_granted_slave_sram_avalonS <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_data_master_saved_grant_sram_avalonS) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((sram_avalonS_arbitration_holdoff_internal OR NOT internal_cpu_data_master_requests_sram_avalonS))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_data_master_granted_slave_sram_avalonS))))));
      end if;
    end if;

  end process;

  --cpu_data_master_continuerequest continued request, which is an e_mux
  cpu_data_master_continuerequest <= last_cycle_cpu_data_master_granted_slave_sram_avalonS AND internal_cpu_data_master_requests_sram_avalonS;
  internal_cpu_instruction_master_qualified_request_sram_avalonS <= internal_cpu_instruction_master_requests_sram_avalonS AND NOT ((((cpu_instruction_master_read AND ((to_std_logic((((std_logic_vector'("000000000000000000000000000000") & (cpu_instruction_master_latency_counter)) /= std_logic_vector'("00000000000000000000000000000000")))) OR (or_reduce(cpu_instruction_master_read_data_valid_sdram_s1_shift_register)))))) OR cpu_data_master_arbiterlock));
  --local readdatavalid cpu_instruction_master_read_data_valid_sram_avalonS, which is an e_mux
  cpu_instruction_master_read_data_valid_sram_avalonS <= (internal_cpu_instruction_master_granted_sram_avalonS AND cpu_instruction_master_read) AND NOT sram_avalonS_waits_for_read;
  --allow new arb cycle for sram/avalonS, which is an e_assign
  sram_avalonS_allow_new_arb_cycle <= NOT cpu_data_master_arbiterlock AND NOT cpu_instruction_master_arbiterlock;
  --cpu/instruction_master assignment into master qualified-requests vector for sram/avalonS, which is an e_assign
  sram_avalonS_master_qreq_vector(0) <= internal_cpu_instruction_master_qualified_request_sram_avalonS;
  --cpu/instruction_master grant sram/avalonS, which is an e_assign
  internal_cpu_instruction_master_granted_sram_avalonS <= sram_avalonS_grant_vector(0);
  --cpu/instruction_master saved-grant sram/avalonS, which is an e_assign
  cpu_instruction_master_saved_grant_sram_avalonS <= sram_avalonS_arb_winner(0) AND internal_cpu_instruction_master_requests_sram_avalonS;
  --cpu/data_master assignment into master qualified-requests vector for sram/avalonS, which is an e_assign
  sram_avalonS_master_qreq_vector(1) <= internal_cpu_data_master_qualified_request_sram_avalonS;
  --cpu/data_master grant sram/avalonS, which is an e_assign
  internal_cpu_data_master_granted_sram_avalonS <= sram_avalonS_grant_vector(1);
  --cpu/data_master saved-grant sram/avalonS, which is an e_assign
  cpu_data_master_saved_grant_sram_avalonS <= sram_avalonS_arb_winner(1) AND internal_cpu_data_master_requests_sram_avalonS;
  --sram/avalonS chosen-master double-vector, which is an e_assign
  sram_avalonS_chosen_master_double_vector <= A_EXT (((std_logic_vector'("0") & ((sram_avalonS_master_qreq_vector & sram_avalonS_master_qreq_vector))) AND (((std_logic_vector'("0") & (Std_Logic_Vector'(NOT sram_avalonS_master_qreq_vector & NOT sram_avalonS_master_qreq_vector))) + (std_logic_vector'("000") & (sram_avalonS_arb_addend))))), 4);
  --stable onehot encoding of arb winner
  sram_avalonS_arb_winner <= A_WE_StdLogicVector((std_logic'(((sram_avalonS_allow_new_arb_cycle AND or_reduce(sram_avalonS_grant_vector)))) = '1'), sram_avalonS_grant_vector, sram_avalonS_saved_chosen_master_vector);
  --saved sram_avalonS_grant_vector, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sram_avalonS_saved_chosen_master_vector <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(sram_avalonS_allow_new_arb_cycle) = '1' then 
        sram_avalonS_saved_chosen_master_vector <= A_WE_StdLogicVector((std_logic'(or_reduce(sram_avalonS_grant_vector)) = '1'), sram_avalonS_grant_vector, sram_avalonS_saved_chosen_master_vector);
      end if;
    end if;

  end process;

  --onehot encoding of chosen master
  sram_avalonS_grant_vector <= Std_Logic_Vector'(A_ToStdLogicVector(((sram_avalonS_chosen_master_double_vector(1) OR sram_avalonS_chosen_master_double_vector(3)))) & A_ToStdLogicVector(((sram_avalonS_chosen_master_double_vector(0) OR sram_avalonS_chosen_master_double_vector(2)))));
  --sram/avalonS chosen master rotated left, which is an e_assign
  sram_avalonS_chosen_master_rot_left <= A_EXT (A_WE_StdLogicVector((((A_SLL(sram_avalonS_arb_winner,std_logic_vector'("00000000000000000000000000000001")))) /= std_logic_vector'("00")), (std_logic_vector'("000000000000000000000000000000") & ((A_SLL(sram_avalonS_arb_winner,std_logic_vector'("00000000000000000000000000000001"))))), std_logic_vector'("00000000000000000000000000000001")), 2);
  --sram/avalonS's addend for next-master-grant
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sram_avalonS_arb_addend <= std_logic_vector'("01");
    elsif clk'event and clk = '1' then
      if std_logic'(or_reduce(sram_avalonS_grant_vector)) = '1' then 
        sram_avalonS_arb_addend <= A_WE_StdLogicVector((std_logic'(sram_avalonS_end_xfer) = '1'), sram_avalonS_chosen_master_rot_left, sram_avalonS_grant_vector);
      end if;
    end if;

  end process;

  --~sram_avalonS_outputenable_n assignment, which is an e_mux
  sram_avalonS_outputenable_n <= NOT sram_avalonS_in_a_read_cycle;
  --sram_avalonS_reset_n assignment, which is an e_assign
  sram_avalonS_reset_n <= reset_n;
  sram_avalonS_chipselect_n <= NOT ((internal_cpu_data_master_granted_sram_avalonS OR internal_cpu_instruction_master_granted_sram_avalonS));
  --sram_avalonS_firsttransfer first transaction, which is an e_assign
  sram_avalonS_firsttransfer <= NOT ((sram_avalonS_slavearbiterlockenable AND sram_avalonS_any_continuerequest));
  --sram_avalonS_beginbursttransfer_internal begin burst transfer, which is an e_assign
  sram_avalonS_beginbursttransfer_internal <= sram_avalonS_begins_xfer AND sram_avalonS_firsttransfer;
  --sram_avalonS_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  sram_avalonS_arbitration_holdoff_internal <= sram_avalonS_begins_xfer AND sram_avalonS_firsttransfer;
  --~sram_avalonS_write_n assignment, which is an e_mux
  sram_avalonS_write_n <= NOT (((((internal_cpu_data_master_granted_sram_avalonS AND cpu_data_master_write)) AND NOT sram_avalonS_begins_xfer) AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(sram_avalonS_wait_counter)))>=std_logic_vector'("00000000000000000000000000000001"))))));
  --sram_avalonS_address mux, which is an e_mux
  sram_avalonS_address <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_sram_avalonS)) = '1'), (Std_Logic_Vector'(A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")) & A_ToStdLogicVector(cpu_data_master_dbs_address(1)))), (Std_Logic_Vector'(A_SRL(cpu_instruction_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")) & A_ToStdLogicVector(cpu_instruction_master_dbs_address(1))))), 18);
  --d1_sram_avalonS_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_sram_avalonS_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_sram_avalonS_end_xfer <= sram_avalonS_end_xfer;
      end if;
    end if;

  end process;

  --sram_avalonS_waits_for_read in a cycle, which is an e_mux
  sram_avalonS_waits_for_read <= sram_avalonS_in_a_read_cycle AND sram_avalonS_begins_xfer;
  --sram_avalonS_in_a_read_cycle assignment, which is an e_assign
  sram_avalonS_in_a_read_cycle <= ((internal_cpu_data_master_granted_sram_avalonS AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_sram_avalonS AND cpu_instruction_master_read));
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= sram_avalonS_in_a_read_cycle;
  --sram_avalonS_waits_for_write in a cycle, which is an e_mux
  sram_avalonS_waits_for_write <= sram_avalonS_in_a_write_cycle AND wait_for_sram_avalonS_counter;
  --sram_avalonS_in_a_write_cycle assignment, which is an e_assign
  sram_avalonS_in_a_write_cycle <= internal_cpu_data_master_granted_sram_avalonS AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= sram_avalonS_in_a_write_cycle;
  internal_sram_avalonS_wait_counter_eq_0 <= to_std_logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(sram_avalonS_wait_counter))) = std_logic_vector'("00000000000000000000000000000000")));
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sram_avalonS_wait_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        sram_avalonS_wait_counter <= sram_avalonS_counter_load_value;
      end if;
    end if;

  end process;

  sram_avalonS_counter_load_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(((sram_avalonS_in_a_write_cycle AND sram_avalonS_begins_xfer))) = '1'), std_logic_vector'("000000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'((NOT internal_sram_avalonS_wait_counter_eq_0)) = '1'), ((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(sram_avalonS_wait_counter))) - std_logic_vector'("000000000000000000000000000000001")), std_logic_vector'("000000000000000000000000000000000"))));
  wait_for_sram_avalonS_counter <= sram_avalonS_begins_xfer OR NOT internal_sram_avalonS_wait_counter_eq_0;
  --~sram_avalonS_byteenable_n byte enable port mux, which is an e_mux
  sram_avalonS_byteenable_n <= A_EXT (NOT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_sram_avalonS)) = '1'), (std_logic_vector'("000000000000000000000000000000") & (internal_cpu_data_master_byteenable_sram_avalonS)), -SIGNED(std_logic_vector'("00000000000000000000000000000001")))), 2);
  (cpu_data_master_byteenable_sram_avalonS_segment_1(1), cpu_data_master_byteenable_sram_avalonS_segment_1(0), cpu_data_master_byteenable_sram_avalonS_segment_0(1), cpu_data_master_byteenable_sram_avalonS_segment_0(0)) <= cpu_data_master_byteenable;
  internal_cpu_data_master_byteenable_sram_avalonS <= A_WE_StdLogicVector((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_dbs_address(1)))) = std_logic_vector'("00000000000000000000000000000000"))), cpu_data_master_byteenable_sram_avalonS_segment_0, cpu_data_master_byteenable_sram_avalonS_segment_1);
  --vhdl renameroo for output signals
  cpu_data_master_byteenable_sram_avalonS <= internal_cpu_data_master_byteenable_sram_avalonS;
  --vhdl renameroo for output signals
  cpu_data_master_granted_sram_avalonS <= internal_cpu_data_master_granted_sram_avalonS;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_sram_avalonS <= internal_cpu_data_master_qualified_request_sram_avalonS;
  --vhdl renameroo for output signals
  cpu_data_master_requests_sram_avalonS <= internal_cpu_data_master_requests_sram_avalonS;
  --vhdl renameroo for output signals
  cpu_instruction_master_granted_sram_avalonS <= internal_cpu_instruction_master_granted_sram_avalonS;
  --vhdl renameroo for output signals
  cpu_instruction_master_qualified_request_sram_avalonS <= internal_cpu_instruction_master_qualified_request_sram_avalonS;
  --vhdl renameroo for output signals
  cpu_instruction_master_requests_sram_avalonS <= internal_cpu_instruction_master_requests_sram_avalonS;
  --vhdl renameroo for output signals
  sram_avalonS_wait_counter_eq_0 <= internal_sram_avalonS_wait_counter_eq_0;
--synthesis translate_off
    --grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line12 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_data_master_granted_sram_avalonS))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_instruction_master_granted_sram_avalonS))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line12, now);
          write(write_line12, string'(": "));
          write(write_line12, string'("> 1 of grant signals are active simultaneously"));
          write(output, write_line12.all);
          deallocate (write_line12);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --saved_grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line13 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_data_master_saved_grant_sram_avalonS))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_saved_grant_sram_avalonS))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line13, now);
          write(write_line13, string'(": "));
          write(write_line13, string'("> 1 of saved_grant signals are active simultaneously"));
          write(output, write_line13.all);
          deallocate (write_line13);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity switches_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;
                 signal switches_s1_readdata : IN STD_LOGIC_VECTOR (17 DOWNTO 0);

              -- outputs:
                 signal cpu_data_master_granted_switches_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_switches_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_switches_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_switches_s1 : OUT STD_LOGIC;
                 signal d1_switches_s1_end_xfer : OUT STD_LOGIC;
                 signal switches_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal switches_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal switches_s1_reset_n : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of switches_s1_arbitrator : entity is FALSE;
end entity switches_s1_arbitrator;


architecture europa of switches_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_switches_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_switches_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_switches_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_switches_s1 :  STD_LOGIC;
                signal switches_s1_allgrants :  STD_LOGIC;
                signal switches_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal switches_s1_any_continuerequest :  STD_LOGIC;
                signal switches_s1_arb_counter_enable :  STD_LOGIC;
                signal switches_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal switches_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal switches_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal switches_s1_arbitration_holdoff_internal :  STD_LOGIC;
                signal switches_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal switches_s1_begins_xfer :  STD_LOGIC;
                signal switches_s1_end_xfer :  STD_LOGIC;
                signal switches_s1_firsttransfer :  STD_LOGIC;
                signal switches_s1_grant_vector :  STD_LOGIC;
                signal switches_s1_in_a_read_cycle :  STD_LOGIC;
                signal switches_s1_in_a_write_cycle :  STD_LOGIC;
                signal switches_s1_master_qreq_vector :  STD_LOGIC;
                signal switches_s1_slavearbiterlockenable :  STD_LOGIC;
                signal switches_s1_waits_for_read :  STD_LOGIC;
                signal switches_s1_waits_for_write :  STD_LOGIC;
                signal wait_for_switches_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT switches_s1_end_xfer;
      end if;
    end if;

  end process;

  switches_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_switches_s1);
  --assign switches_s1_readdata_from_sa = switches_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  switches_s1_readdata_from_sa <= switches_s1_readdata;
  internal_cpu_data_master_requests_switches_s1 <= ((to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("001000100000000001100000")))) AND ((cpu_data_master_read OR cpu_data_master_write)))) AND cpu_data_master_read;
  --switches_s1_arb_share_counter set values, which is an e_mux
  switches_s1_arb_share_set_values <= std_logic_vector'("001");
  --switches_s1_arb_share_counter_next_value assignment, which is an e_assign
  switches_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(switches_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (switches_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(switches_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (switches_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --switches_s1_allgrants all slave grants, which is an e_mux
  switches_s1_allgrants <= switches_s1_grant_vector;
  --switches_s1_end_xfer assignment, which is an e_assign
  switches_s1_end_xfer <= NOT ((switches_s1_waits_for_read OR switches_s1_waits_for_write));
  --switches_s1_arb_share_counter arbitration counter enable, which is an e_assign
  switches_s1_arb_counter_enable <= switches_s1_end_xfer AND switches_s1_allgrants;
  --switches_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      switches_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(switches_s1_arb_counter_enable) = '1' then 
        switches_s1_arb_share_counter <= switches_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --switches_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      switches_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((switches_s1_master_qreq_vector AND switches_s1_end_xfer)) = '1' then 
        switches_s1_slavearbiterlockenable <= or_reduce(switches_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master switches/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= switches_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --switches_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  switches_s1_any_continuerequest <= std_logic'('0');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('0');
  internal_cpu_data_master_qualified_request_switches_s1 <= internal_cpu_data_master_requests_switches_s1;
  --master is always granted when requested
  internal_cpu_data_master_granted_switches_s1 <= internal_cpu_data_master_qualified_request_switches_s1;
  --cpu/data_master saved-grant switches/s1, which is an e_assign
  cpu_data_master_saved_grant_switches_s1 <= internal_cpu_data_master_requests_switches_s1;
  --allow new arb cycle for switches/s1, which is an e_assign
  switches_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  switches_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  switches_s1_master_qreq_vector <= std_logic'('1');
  --switches_s1_reset_n assignment, which is an e_assign
  switches_s1_reset_n <= reset_n;
  --switches_s1_firsttransfer first transaction, which is an e_assign
  switches_s1_firsttransfer <= NOT ((switches_s1_slavearbiterlockenable AND switches_s1_any_continuerequest));
  --switches_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  switches_s1_beginbursttransfer_internal <= switches_s1_begins_xfer AND switches_s1_firsttransfer;
  --switches_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  switches_s1_arbitration_holdoff_internal <= switches_s1_begins_xfer AND switches_s1_firsttransfer;
  --switches_s1_address mux, which is an e_mux
  switches_s1_address <= A_EXT (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_switches_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_switches_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_switches_s1_end_xfer <= switches_s1_end_xfer;
      end if;
    end if;

  end process;

  --switches_s1_waits_for_read in a cycle, which is an e_mux
  switches_s1_waits_for_read <= switches_s1_in_a_read_cycle AND switches_s1_begins_xfer;
  --switches_s1_in_a_read_cycle assignment, which is an e_assign
  switches_s1_in_a_read_cycle <= internal_cpu_data_master_granted_switches_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= switches_s1_in_a_read_cycle;
  --switches_s1_waits_for_write in a cycle, which is an e_mux
  switches_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(switches_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --switches_s1_in_a_write_cycle assignment, which is an e_assign
  switches_s1_in_a_write_cycle <= internal_cpu_data_master_granted_switches_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= switches_s1_in_a_write_cycle;
  wait_for_switches_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_data_master_granted_switches_s1 <= internal_cpu_data_master_granted_switches_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_switches_s1 <= internal_cpu_data_master_qualified_request_switches_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_switches_s1 <= internal_cpu_data_master_requests_switches_s1;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity timer0_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;
                 signal timer0_s1_irq : IN STD_LOGIC;
                 signal timer0_s1_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

              -- outputs:
                 signal cpu_data_master_granted_timer0_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_timer0_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_timer0_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_timer0_s1 : OUT STD_LOGIC;
                 signal d1_timer0_s1_end_xfer : OUT STD_LOGIC;
                 signal timer0_s1_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                 signal timer0_s1_chipselect : OUT STD_LOGIC;
                 signal timer0_s1_irq_from_sa : OUT STD_LOGIC;
                 signal timer0_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal timer0_s1_reset_n : OUT STD_LOGIC;
                 signal timer0_s1_write_n : OUT STD_LOGIC;
                 signal timer0_s1_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of timer0_s1_arbitrator : entity is FALSE;
end entity timer0_s1_arbitrator;


architecture europa of timer0_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_timer0_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_timer0_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_timer0_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_timer0_s1 :  STD_LOGIC;
                signal timer0_s1_allgrants :  STD_LOGIC;
                signal timer0_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal timer0_s1_any_continuerequest :  STD_LOGIC;
                signal timer0_s1_arb_counter_enable :  STD_LOGIC;
                signal timer0_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal timer0_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal timer0_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal timer0_s1_arbitration_holdoff_internal :  STD_LOGIC;
                signal timer0_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal timer0_s1_begins_xfer :  STD_LOGIC;
                signal timer0_s1_end_xfer :  STD_LOGIC;
                signal timer0_s1_firsttransfer :  STD_LOGIC;
                signal timer0_s1_grant_vector :  STD_LOGIC;
                signal timer0_s1_in_a_read_cycle :  STD_LOGIC;
                signal timer0_s1_in_a_write_cycle :  STD_LOGIC;
                signal timer0_s1_master_qreq_vector :  STD_LOGIC;
                signal timer0_s1_slavearbiterlockenable :  STD_LOGIC;
                signal timer0_s1_waits_for_read :  STD_LOGIC;
                signal timer0_s1_waits_for_write :  STD_LOGIC;
                signal wait_for_timer0_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT timer0_s1_end_xfer;
      end if;
    end if;

  end process;

  timer0_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_timer0_s1);
  --assign timer0_s1_readdata_from_sa = timer0_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  timer0_s1_readdata_from_sa <= timer0_s1_readdata;
  internal_cpu_data_master_requests_timer0_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 5) & std_logic_vector'("00000")) = std_logic_vector'("001000100000000001000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --timer0_s1_arb_share_counter set values, which is an e_mux
  timer0_s1_arb_share_set_values <= std_logic_vector'("001");
  --timer0_s1_arb_share_counter_next_value assignment, which is an e_assign
  timer0_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(timer0_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (timer0_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(timer0_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (timer0_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --timer0_s1_allgrants all slave grants, which is an e_mux
  timer0_s1_allgrants <= timer0_s1_grant_vector;
  --timer0_s1_end_xfer assignment, which is an e_assign
  timer0_s1_end_xfer <= NOT ((timer0_s1_waits_for_read OR timer0_s1_waits_for_write));
  --timer0_s1_arb_share_counter arbitration counter enable, which is an e_assign
  timer0_s1_arb_counter_enable <= timer0_s1_end_xfer AND timer0_s1_allgrants;
  --timer0_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      timer0_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(timer0_s1_arb_counter_enable) = '1' then 
        timer0_s1_arb_share_counter <= timer0_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --timer0_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      timer0_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((timer0_s1_master_qreq_vector AND timer0_s1_end_xfer)) = '1' then 
        timer0_s1_slavearbiterlockenable <= or_reduce(timer0_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master timer0/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= timer0_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --timer0_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  timer0_s1_any_continuerequest <= std_logic'('0');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('0');
  internal_cpu_data_master_qualified_request_timer0_s1 <= internal_cpu_data_master_requests_timer0_s1 AND NOT (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write));
  --timer0_s1_writedata mux, which is an e_mux
  timer0_s1_writedata <= cpu_data_master_writedata (15 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_timer0_s1 <= internal_cpu_data_master_qualified_request_timer0_s1;
  --cpu/data_master saved-grant timer0/s1, which is an e_assign
  cpu_data_master_saved_grant_timer0_s1 <= internal_cpu_data_master_requests_timer0_s1;
  --allow new arb cycle for timer0/s1, which is an e_assign
  timer0_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  timer0_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  timer0_s1_master_qreq_vector <= std_logic'('1');
  --timer0_s1_reset_n assignment, which is an e_assign
  timer0_s1_reset_n <= reset_n;
  timer0_s1_chipselect <= internal_cpu_data_master_granted_timer0_s1;
  --timer0_s1_firsttransfer first transaction, which is an e_assign
  timer0_s1_firsttransfer <= NOT ((timer0_s1_slavearbiterlockenable AND timer0_s1_any_continuerequest));
  --timer0_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  timer0_s1_beginbursttransfer_internal <= timer0_s1_begins_xfer AND timer0_s1_firsttransfer;
  --timer0_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  timer0_s1_arbitration_holdoff_internal <= timer0_s1_begins_xfer AND timer0_s1_firsttransfer;
  --~timer0_s1_write_n assignment, which is an e_mux
  timer0_s1_write_n <= NOT ((internal_cpu_data_master_granted_timer0_s1 AND cpu_data_master_write));
  --timer0_s1_address mux, which is an e_mux
  timer0_s1_address <= A_EXT (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")), 3);
  --d1_timer0_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_timer0_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_timer0_s1_end_xfer <= timer0_s1_end_xfer;
      end if;
    end if;

  end process;

  --timer0_s1_waits_for_read in a cycle, which is an e_mux
  timer0_s1_waits_for_read <= timer0_s1_in_a_read_cycle AND timer0_s1_begins_xfer;
  --timer0_s1_in_a_read_cycle assignment, which is an e_assign
  timer0_s1_in_a_read_cycle <= internal_cpu_data_master_granted_timer0_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= timer0_s1_in_a_read_cycle;
  --timer0_s1_waits_for_write in a cycle, which is an e_mux
  timer0_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(timer0_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --timer0_s1_in_a_write_cycle assignment, which is an e_assign
  timer0_s1_in_a_write_cycle <= internal_cpu_data_master_granted_timer0_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= timer0_s1_in_a_write_cycle;
  wait_for_timer0_s1_counter <= std_logic'('0');
  --assign timer0_s1_irq_from_sa = timer0_s1_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  timer0_s1_irq_from_sa <= timer0_s1_irq;
  --vhdl renameroo for output signals
  cpu_data_master_granted_timer0_s1 <= internal_cpu_data_master_granted_timer0_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_timer0_s1 <= internal_cpu_data_master_qualified_request_timer0_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_timer0_s1 <= internal_cpu_data_master_requests_timer0_s1;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity uart_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;
                 signal uart_s1_dataavailable : IN STD_LOGIC;
                 signal uart_s1_irq : IN STD_LOGIC;
                 signal uart_s1_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal uart_s1_readyfordata : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_uart_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_uart_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_uart_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_uart_s1 : OUT STD_LOGIC;
                 signal d1_uart_s1_end_xfer : OUT STD_LOGIC;
                 signal uart_s1_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                 signal uart_s1_begintransfer : OUT STD_LOGIC;
                 signal uart_s1_chipselect : OUT STD_LOGIC;
                 signal uart_s1_dataavailable_from_sa : OUT STD_LOGIC;
                 signal uart_s1_irq_from_sa : OUT STD_LOGIC;
                 signal uart_s1_read_n : OUT STD_LOGIC;
                 signal uart_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal uart_s1_readyfordata_from_sa : OUT STD_LOGIC;
                 signal uart_s1_reset_n : OUT STD_LOGIC;
                 signal uart_s1_write_n : OUT STD_LOGIC;
                 signal uart_s1_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of uart_s1_arbitrator : entity is FALSE;
end entity uart_s1_arbitrator;


architecture europa of uart_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_uart_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_uart_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_uart_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_uart_s1 :  STD_LOGIC;
                signal uart_s1_allgrants :  STD_LOGIC;
                signal uart_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal uart_s1_any_continuerequest :  STD_LOGIC;
                signal uart_s1_arb_counter_enable :  STD_LOGIC;
                signal uart_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal uart_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal uart_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal uart_s1_arbitration_holdoff_internal :  STD_LOGIC;
                signal uart_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal uart_s1_begins_xfer :  STD_LOGIC;
                signal uart_s1_end_xfer :  STD_LOGIC;
                signal uart_s1_firsttransfer :  STD_LOGIC;
                signal uart_s1_grant_vector :  STD_LOGIC;
                signal uart_s1_in_a_read_cycle :  STD_LOGIC;
                signal uart_s1_in_a_write_cycle :  STD_LOGIC;
                signal uart_s1_master_qreq_vector :  STD_LOGIC;
                signal uart_s1_slavearbiterlockenable :  STD_LOGIC;
                signal uart_s1_waits_for_read :  STD_LOGIC;
                signal uart_s1_waits_for_write :  STD_LOGIC;
                signal wait_for_uart_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT uart_s1_end_xfer;
      end if;
    end if;

  end process;

  uart_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_uart_s1);
  --assign uart_s1_readdata_from_sa = uart_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  uart_s1_readdata_from_sa <= uart_s1_readdata;
  internal_cpu_data_master_requests_uart_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(23 DOWNTO 5) & std_logic_vector'("00000")) = std_logic_vector'("001000100000000000100000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign uart_s1_dataavailable_from_sa = uart_s1_dataavailable so that symbol knows where to group signals which may go to master only, which is an e_assign
  uart_s1_dataavailable_from_sa <= uart_s1_dataavailable;
  --assign uart_s1_readyfordata_from_sa = uart_s1_readyfordata so that symbol knows where to group signals which may go to master only, which is an e_assign
  uart_s1_readyfordata_from_sa <= uart_s1_readyfordata;
  --uart_s1_arb_share_counter set values, which is an e_mux
  uart_s1_arb_share_set_values <= std_logic_vector'("001");
  --uart_s1_arb_share_counter_next_value assignment, which is an e_assign
  uart_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(uart_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (uart_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(uart_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (uart_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --uart_s1_allgrants all slave grants, which is an e_mux
  uart_s1_allgrants <= uart_s1_grant_vector;
  --uart_s1_end_xfer assignment, which is an e_assign
  uart_s1_end_xfer <= NOT ((uart_s1_waits_for_read OR uart_s1_waits_for_write));
  --uart_s1_arb_share_counter arbitration counter enable, which is an e_assign
  uart_s1_arb_counter_enable <= uart_s1_end_xfer AND uart_s1_allgrants;
  --uart_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      uart_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(uart_s1_arb_counter_enable) = '1' then 
        uart_s1_arb_share_counter <= uart_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --uart_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      uart_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((uart_s1_master_qreq_vector AND uart_s1_end_xfer)) = '1' then 
        uart_s1_slavearbiterlockenable <= or_reduce(uart_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master uart/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= uart_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --uart_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  uart_s1_any_continuerequest <= std_logic'('0');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('0');
  internal_cpu_data_master_qualified_request_uart_s1 <= internal_cpu_data_master_requests_uart_s1;
  --uart_s1_writedata mux, which is an e_mux
  uart_s1_writedata <= cpu_data_master_writedata (15 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_uart_s1 <= internal_cpu_data_master_qualified_request_uart_s1;
  --cpu/data_master saved-grant uart/s1, which is an e_assign
  cpu_data_master_saved_grant_uart_s1 <= internal_cpu_data_master_requests_uart_s1;
  --allow new arb cycle for uart/s1, which is an e_assign
  uart_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  uart_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  uart_s1_master_qreq_vector <= std_logic'('1');
  uart_s1_begintransfer <= uart_s1_begins_xfer;
  --uart_s1_reset_n assignment, which is an e_assign
  uart_s1_reset_n <= reset_n;
  uart_s1_chipselect <= internal_cpu_data_master_granted_uart_s1;
  --uart_s1_firsttransfer first transaction, which is an e_assign
  uart_s1_firsttransfer <= NOT ((uart_s1_slavearbiterlockenable AND uart_s1_any_continuerequest));
  --uart_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  uart_s1_beginbursttransfer_internal <= uart_s1_begins_xfer AND uart_s1_firsttransfer;
  --uart_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  uart_s1_arbitration_holdoff_internal <= uart_s1_begins_xfer AND uart_s1_firsttransfer;
  --~uart_s1_read_n assignment, which is an e_mux
  uart_s1_read_n <= NOT ((internal_cpu_data_master_granted_uart_s1 AND cpu_data_master_read));
  --~uart_s1_write_n assignment, which is an e_mux
  uart_s1_write_n <= NOT ((internal_cpu_data_master_granted_uart_s1 AND cpu_data_master_write));
  --uart_s1_address mux, which is an e_mux
  uart_s1_address <= A_EXT (A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")), 3);
  --d1_uart_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_uart_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_uart_s1_end_xfer <= uart_s1_end_xfer;
      end if;
    end if;

  end process;

  --uart_s1_waits_for_read in a cycle, which is an e_mux
  uart_s1_waits_for_read <= uart_s1_in_a_read_cycle AND uart_s1_begins_xfer;
  --uart_s1_in_a_read_cycle assignment, which is an e_assign
  uart_s1_in_a_read_cycle <= internal_cpu_data_master_granted_uart_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= uart_s1_in_a_read_cycle;
  --uart_s1_waits_for_write in a cycle, which is an e_mux
  uart_s1_waits_for_write <= uart_s1_in_a_write_cycle AND uart_s1_begins_xfer;
  --uart_s1_in_a_write_cycle assignment, which is an e_assign
  uart_s1_in_a_write_cycle <= internal_cpu_data_master_granted_uart_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= uart_s1_in_a_write_cycle;
  wait_for_uart_s1_counter <= std_logic'('0');
  --assign uart_s1_irq_from_sa = uart_s1_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  uart_s1_irq_from_sa <= uart_s1_irq;
  --vhdl renameroo for output signals
  cpu_data_master_granted_uart_s1 <= internal_cpu_data_master_granted_uart_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_uart_s1 <= internal_cpu_data_master_qualified_request_uart_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_uart_s1 <= internal_cpu_data_master_requests_uart_s1;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity nios32_reset_clk_domain_synch_module is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal data_in : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal data_out : OUT STD_LOGIC
              );
end entity nios32_reset_clk_domain_synch_module;


architecture europa of nios32_reset_clk_domain_synch_module is
                signal data_in_d1 :  STD_LOGIC;
attribute ALTERA_ATTRIBUTE : string;
attribute ALTERA_ATTRIBUTE of data_in_d1 : signal is "PRESERVE_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of data_out : signal is "PRESERVE_REGISTER=ON";

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      data_in_d1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        data_in_d1 <= data_in;
      end if;
    end if;

  end process;

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      data_out <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        data_out <= data_in_d1;
      end if;
    end if;

  end process;


end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity nios32 is 
        port (
              -- 1) global signals:
                 signal clk : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- the_buttons
                 signal in_port_to_the_buttons : IN STD_LOGIC_VECTOR (3 DOWNTO 0);

              -- the_ext_bus_avalon_slave
                 signal ext_bus_address : OUT STD_LOGIC_VECTOR (19 DOWNTO 0);
                 signal ext_bus_data : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal ext_bus_readn : OUT STD_LOGIC;
                 signal select_n_to_the_flash : OUT STD_LOGIC;
                 signal write_n_to_the_flash : OUT STD_LOGIC;

              -- the_lcd
                 signal LCD_E_from_the_lcd : OUT STD_LOGIC;
                 signal LCD_RS_from_the_lcd : OUT STD_LOGIC;
                 signal LCD_RW_from_the_lcd : OUT STD_LOGIC;
                 signal LCD_data_to_and_from_the_lcd : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0);

              -- the_led_green
                 signal out_port_from_the_led_green : OUT STD_LOGIC_VECTOR (8 DOWNTO 0);

              -- the_led_red
                 signal out_port_from_the_led_red : OUT STD_LOGIC_VECTOR (17 DOWNTO 0);

              -- the_sdram
                 signal zs_addr_from_the_sdram : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal zs_ba_from_the_sdram : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal zs_cas_n_from_the_sdram : OUT STD_LOGIC;
                 signal zs_cke_from_the_sdram : OUT STD_LOGIC;
                 signal zs_cs_n_from_the_sdram : OUT STD_LOGIC;
                 signal zs_dq_to_and_from_the_sdram : INOUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal zs_dqm_from_the_sdram : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal zs_ras_n_from_the_sdram : OUT STD_LOGIC;
                 signal zs_we_n_from_the_sdram : OUT STD_LOGIC;

              -- the_seven_seg
                 signal oSEG0_from_the_seven_seg : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal oSEG1_from_the_seven_seg : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal oSEG2_from_the_seven_seg : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal oSEG3_from_the_seven_seg : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal oSEG4_from_the_seven_seg : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal oSEG5_from_the_seven_seg : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal oSEG6_from_the_seven_seg : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal oSEG7_from_the_seven_seg : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);

              -- the_sram
                 signal SRAM_ADDR_from_the_sram : OUT STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal SRAM_CE_N_from_the_sram : OUT STD_LOGIC;
                 signal SRAM_DQ_to_and_from_the_sram : INOUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal SRAM_LB_N_from_the_sram : OUT STD_LOGIC;
                 signal SRAM_OE_N_from_the_sram : OUT STD_LOGIC;
                 signal SRAM_UB_N_from_the_sram : OUT STD_LOGIC;
                 signal SRAM_WE_N_from_the_sram : OUT STD_LOGIC;

              -- the_switches
                 signal in_port_to_the_switches : IN STD_LOGIC_VECTOR (17 DOWNTO 0);

              -- the_uart
                 signal rxd_to_the_uart : IN STD_LOGIC;
                 signal txd_from_the_uart : OUT STD_LOGIC
              );
end entity nios32;


architecture europa of nios32 is
component buttons_s1_arbitrator is 
           port (
                 -- inputs:
                    signal buttons_s1_irq : IN STD_LOGIC;
                    signal buttons_s1_readdata : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal buttons_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal buttons_s1_chipselect : OUT STD_LOGIC;
                    signal buttons_s1_irq_from_sa : OUT STD_LOGIC;
                    signal buttons_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal buttons_s1_reset_n : OUT STD_LOGIC;
                    signal buttons_s1_write_n : OUT STD_LOGIC;
                    signal buttons_s1_writedata : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_granted_buttons_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_buttons_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_buttons_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_buttons_s1 : OUT STD_LOGIC;
                    signal d1_buttons_s1_end_xfer : OUT STD_LOGIC
                 );
end component buttons_s1_arbitrator;

component buttons is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal in_port : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (3 DOWNTO 0);

                 -- outputs:
                    signal irq : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC_VECTOR (3 DOWNTO 0)
                 );
end component buttons;

component cpu_jtag_debug_module_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_debugaccess : IN STD_LOGIC;
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_sdram_s1_shift_register : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal cpu_jtag_debug_module_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_jtag_debug_module_resetrequest : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_data_master_requests_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_instruction_master_granted_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_instruction_master_requests_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_address : OUT STD_LOGIC_VECTOR (8 DOWNTO 0);
                    signal cpu_jtag_debug_module_begintransfer : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_jtag_debug_module_chipselect : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_debugaccess : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_jtag_debug_module_reset : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_reset_n : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_resetrequest_from_sa : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_write : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d1_cpu_jtag_debug_module_end_xfer : OUT STD_LOGIC
                 );
end component cpu_jtag_debug_module_arbitrator;

component cpu_data_master_arbitrator is 
           port (
                 -- inputs:
                    signal buttons_s1_irq_from_sa : IN STD_LOGIC;
                    signal buttons_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_byteenable_flash_s1 : IN STD_LOGIC;
                    signal cpu_data_master_byteenable_sdram_s1 : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_byteenable_sram_avalonS : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_debugaccess : IN STD_LOGIC;
                    signal cpu_data_master_granted_buttons_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_data_master_granted_epcs_controller_epcs_control_port : IN STD_LOGIC;
                    signal cpu_data_master_granted_flash_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_jtag_avalon_jtag_slave : IN STD_LOGIC;
                    signal cpu_data_master_granted_lcd_control_slave : IN STD_LOGIC;
                    signal cpu_data_master_granted_led_green_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_led_red_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_sdram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_seven_seg_avalonS : IN STD_LOGIC;
                    signal cpu_data_master_granted_sram_avalonS : IN STD_LOGIC;
                    signal cpu_data_master_granted_switches_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_timer0_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_uart_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_buttons_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_epcs_controller_epcs_control_port : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_flash_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_jtag_avalon_jtag_slave : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_lcd_control_slave : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_led_green_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_led_red_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_sdram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_seven_seg_avalonS : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_sram_avalonS : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_switches_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_timer0_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_uart_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_buttons_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_epcs_controller_epcs_control_port : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_flash_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_jtag_avalon_jtag_slave : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_lcd_control_slave : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_led_green_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_led_red_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_sdram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_sdram_s1_shift_register : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal cpu_data_master_read_data_valid_seven_seg_avalonS : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_sram_avalonS : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_switches_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_timer0_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_uart_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_buttons_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_data_master_requests_epcs_controller_epcs_control_port : IN STD_LOGIC;
                    signal cpu_data_master_requests_flash_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_jtag_avalon_jtag_slave : IN STD_LOGIC;
                    signal cpu_data_master_requests_lcd_control_slave : IN STD_LOGIC;
                    signal cpu_data_master_requests_led_green_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_led_red_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_sdram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_seven_seg_avalonS : IN STD_LOGIC;
                    signal cpu_data_master_requests_sram_avalonS : IN STD_LOGIC;
                    signal cpu_data_master_requests_switches_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_timer0_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_uart_s1 : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_jtag_debug_module_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d1_buttons_s1_end_xfer : IN STD_LOGIC;
                    signal d1_cpu_jtag_debug_module_end_xfer : IN STD_LOGIC;
                    signal d1_epcs_controller_epcs_control_port_end_xfer : IN STD_LOGIC;
                    signal d1_ext_bus_avalon_slave_end_xfer : IN STD_LOGIC;
                    signal d1_jtag_avalon_jtag_slave_end_xfer : IN STD_LOGIC;
                    signal d1_lcd_control_slave_end_xfer : IN STD_LOGIC;
                    signal d1_led_green_s1_end_xfer : IN STD_LOGIC;
                    signal d1_led_red_s1_end_xfer : IN STD_LOGIC;
                    signal d1_sdram_s1_end_xfer : IN STD_LOGIC;
                    signal d1_seven_seg_avalonS_end_xfer : IN STD_LOGIC;
                    signal d1_sram_avalonS_end_xfer : IN STD_LOGIC;
                    signal d1_switches_s1_end_xfer : IN STD_LOGIC;
                    signal d1_timer0_s1_end_xfer : IN STD_LOGIC;
                    signal d1_uart_s1_end_xfer : IN STD_LOGIC;
                    signal epcs_controller_epcs_control_port_irq_from_sa : IN STD_LOGIC;
                    signal epcs_controller_epcs_control_port_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal flash_s1_wait_counter_eq_0 : IN STD_LOGIC;
                    signal flash_s1_wait_counter_eq_1 : IN STD_LOGIC;
                    signal incoming_ext_bus_data_with_Xs_converted_to_0 : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal jtag_avalon_jtag_slave_irq_from_sa : IN STD_LOGIC;
                    signal jtag_avalon_jtag_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtag_avalon_jtag_slave_waitrequest_from_sa : IN STD_LOGIC;
                    signal lcd_control_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal lcd_control_slave_wait_counter_eq_0 : IN STD_LOGIC;
                    signal lcd_control_slave_wait_counter_eq_1 : IN STD_LOGIC;
                    signal registered_cpu_data_master_read_data_valid_flash_s1 : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal sdram_s1_posted_fifo_readenable : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal sdram_s1_posted_fifo_writenable : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal sdram_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal sdram_s1_waitrequest_from_sa : IN STD_LOGIC;
                    signal sram_avalonS_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal sram_avalonS_wait_counter_eq_0 : IN STD_LOGIC;
                    signal switches_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal timer0_s1_irq_from_sa : IN STD_LOGIC;
                    signal timer0_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal uart_s1_irq_from_sa : IN STD_LOGIC;
                    signal uart_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal cpu_data_master_address_to_slave : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_dbs_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_dbs_write_16 : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal cpu_data_master_dbs_write_8 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal cpu_data_master_irq : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_data_master_no_byte_enables_and_last_term : OUT STD_LOGIC;
                    signal cpu_data_master_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_data_master_waitrequest : OUT STD_LOGIC
                 );
end component cpu_data_master_arbitrator;

component cpu_instruction_master_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_instruction_master_address : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_instruction_master_granted_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_instruction_master_granted_epcs_controller_epcs_control_port : IN STD_LOGIC;
                    signal cpu_instruction_master_granted_flash_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_granted_sdram_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_granted_seven_seg_avalonS : IN STD_LOGIC;
                    signal cpu_instruction_master_granted_sram_avalonS : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_epcs_controller_epcs_control_port : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_flash_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_sdram_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_seven_seg_avalonS : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_sram_avalonS : IN STD_LOGIC;
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_epcs_controller_epcs_control_port : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_flash_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_sdram_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_sdram_s1_shift_register : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal cpu_instruction_master_read_data_valid_seven_seg_avalonS : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_sram_avalonS : IN STD_LOGIC;
                    signal cpu_instruction_master_requests_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_instruction_master_requests_epcs_controller_epcs_control_port : IN STD_LOGIC;
                    signal cpu_instruction_master_requests_flash_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_requests_sdram_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_requests_seven_seg_avalonS : IN STD_LOGIC;
                    signal cpu_instruction_master_requests_sram_avalonS : IN STD_LOGIC;
                    signal cpu_jtag_debug_module_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d1_cpu_jtag_debug_module_end_xfer : IN STD_LOGIC;
                    signal d1_epcs_controller_epcs_control_port_end_xfer : IN STD_LOGIC;
                    signal d1_ext_bus_avalon_slave_end_xfer : IN STD_LOGIC;
                    signal d1_sdram_s1_end_xfer : IN STD_LOGIC;
                    signal d1_seven_seg_avalonS_end_xfer : IN STD_LOGIC;
                    signal d1_sram_avalonS_end_xfer : IN STD_LOGIC;
                    signal epcs_controller_epcs_control_port_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal flash_s1_wait_counter_eq_0 : IN STD_LOGIC;
                    signal flash_s1_wait_counter_eq_1 : IN STD_LOGIC;
                    signal incoming_ext_bus_data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal sdram_s1_posted_fifo_readenable : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal sdram_s1_posted_fifo_writenable : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal sdram_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal sdram_s1_waitrequest_from_sa : IN STD_LOGIC;
                    signal sram_avalonS_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal sram_avalonS_wait_counter_eq_0 : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_instruction_master_address_to_slave : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_instruction_master_dbs_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_latency_counter : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_instruction_master_readdatavalid : OUT STD_LOGIC;
                    signal cpu_instruction_master_waitrequest : OUT STD_LOGIC
                 );
end component cpu_instruction_master_arbitrator;

component cpu is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal d_irq : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d_waitrequest : IN STD_LOGIC;
                    signal i_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal i_readdatavalid : IN STD_LOGIC;
                    signal i_waitrequest : IN STD_LOGIC;
                    signal jtag_debug_module_address : IN STD_LOGIC_VECTOR (8 DOWNTO 0);
                    signal jtag_debug_module_begintransfer : IN STD_LOGIC;
                    signal jtag_debug_module_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal jtag_debug_module_clk : IN STD_LOGIC;
                    signal jtag_debug_module_debugaccess : IN STD_LOGIC;
                    signal jtag_debug_module_reset : IN STD_LOGIC;
                    signal jtag_debug_module_select : IN STD_LOGIC;
                    signal jtag_debug_module_write : IN STD_LOGIC;
                    signal jtag_debug_module_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal d_address : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal d_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal d_read : OUT STD_LOGIC;
                    signal d_write : OUT STD_LOGIC;
                    signal d_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal i_address : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal i_read : OUT STD_LOGIC;
                    signal jtag_debug_module_debugaccess_to_roms : OUT STD_LOGIC;
                    signal jtag_debug_module_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtag_debug_module_resetrequest : OUT STD_LOGIC
                 );
end component cpu;

component epcs_controller_epcs_control_port_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_sdram_s1_shift_register : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal epcs_controller_epcs_control_port_dataavailable : IN STD_LOGIC;
                    signal epcs_controller_epcs_control_port_endofpacket : IN STD_LOGIC;
                    signal epcs_controller_epcs_control_port_irq : IN STD_LOGIC;
                    signal epcs_controller_epcs_control_port_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal epcs_controller_epcs_control_port_readyfordata : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_epcs_controller_epcs_control_port : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_epcs_controller_epcs_control_port : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_epcs_controller_epcs_control_port : OUT STD_LOGIC;
                    signal cpu_data_master_requests_epcs_controller_epcs_control_port : OUT STD_LOGIC;
                    signal cpu_instruction_master_granted_epcs_controller_epcs_control_port : OUT STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_epcs_controller_epcs_control_port : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_epcs_controller_epcs_control_port : OUT STD_LOGIC;
                    signal cpu_instruction_master_requests_epcs_controller_epcs_control_port : OUT STD_LOGIC;
                    signal d1_epcs_controller_epcs_control_port_end_xfer : OUT STD_LOGIC;
                    signal epcs_controller_epcs_control_port_address : OUT STD_LOGIC_VECTOR (8 DOWNTO 0);
                    signal epcs_controller_epcs_control_port_chipselect : OUT STD_LOGIC;
                    signal epcs_controller_epcs_control_port_dataavailable_from_sa : OUT STD_LOGIC;
                    signal epcs_controller_epcs_control_port_endofpacket_from_sa : OUT STD_LOGIC;
                    signal epcs_controller_epcs_control_port_irq_from_sa : OUT STD_LOGIC;
                    signal epcs_controller_epcs_control_port_read_n : OUT STD_LOGIC;
                    signal epcs_controller_epcs_control_port_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal epcs_controller_epcs_control_port_readyfordata_from_sa : OUT STD_LOGIC;
                    signal epcs_controller_epcs_control_port_reset_n : OUT STD_LOGIC;
                    signal epcs_controller_epcs_control_port_write_n : OUT STD_LOGIC;
                    signal epcs_controller_epcs_control_port_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component epcs_controller_epcs_control_port_arbitrator;

component epcs_controller is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (8 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal read_n : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal dataavailable : OUT STD_LOGIC;
                    signal endofpacket : OUT STD_LOGIC;
                    signal irq : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal readyfordata : OUT STD_LOGIC
                 );
end component epcs_controller;

component ext_bus_avalon_slave_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_dbs_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_dbs_write_8 : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal cpu_data_master_no_byte_enables_and_last_term : IN STD_LOGIC;
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_instruction_master_dbs_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_sdram_s1_shift_register : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_byteenable_flash_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_granted_flash_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_flash_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_flash_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_flash_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_granted_flash_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_flash_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_flash_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_requests_flash_s1 : OUT STD_LOGIC;
                    signal d1_ext_bus_avalon_slave_end_xfer : OUT STD_LOGIC;
                    signal ext_bus_address : OUT STD_LOGIC_VECTOR (19 DOWNTO 0);
                    signal ext_bus_data : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal ext_bus_readn : OUT STD_LOGIC;
                    signal flash_s1_wait_counter_eq_0 : OUT STD_LOGIC;
                    signal flash_s1_wait_counter_eq_1 : OUT STD_LOGIC;
                    signal incoming_ext_bus_data : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal incoming_ext_bus_data_with_Xs_converted_to_0 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal registered_cpu_data_master_read_data_valid_flash_s1 : OUT STD_LOGIC;
                    signal select_n_to_the_flash : OUT STD_LOGIC;
                    signal write_n_to_the_flash : OUT STD_LOGIC
                 );
end component ext_bus_avalon_slave_arbitrator;

component ext_bus is 
end component ext_bus;

component ext_bus_bridge_arbitrator is 
end component ext_bus_bridge_arbitrator;

component jtag_avalon_jtag_slave_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtag_avalon_jtag_slave_dataavailable : IN STD_LOGIC;
                    signal jtag_avalon_jtag_slave_irq : IN STD_LOGIC;
                    signal jtag_avalon_jtag_slave_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtag_avalon_jtag_slave_readyfordata : IN STD_LOGIC;
                    signal jtag_avalon_jtag_slave_waitrequest : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_jtag_avalon_jtag_slave : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_jtag_avalon_jtag_slave : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_jtag_avalon_jtag_slave : OUT STD_LOGIC;
                    signal cpu_data_master_requests_jtag_avalon_jtag_slave : OUT STD_LOGIC;
                    signal d1_jtag_avalon_jtag_slave_end_xfer : OUT STD_LOGIC;
                    signal jtag_avalon_jtag_slave_address : OUT STD_LOGIC;
                    signal jtag_avalon_jtag_slave_chipselect : OUT STD_LOGIC;
                    signal jtag_avalon_jtag_slave_dataavailable_from_sa : OUT STD_LOGIC;
                    signal jtag_avalon_jtag_slave_irq_from_sa : OUT STD_LOGIC;
                    signal jtag_avalon_jtag_slave_read_n : OUT STD_LOGIC;
                    signal jtag_avalon_jtag_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtag_avalon_jtag_slave_readyfordata_from_sa : OUT STD_LOGIC;
                    signal jtag_avalon_jtag_slave_reset_n : OUT STD_LOGIC;
                    signal jtag_avalon_jtag_slave_waitrequest_from_sa : OUT STD_LOGIC;
                    signal jtag_avalon_jtag_slave_write_n : OUT STD_LOGIC;
                    signal jtag_avalon_jtag_slave_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component jtag_avalon_jtag_slave_arbitrator;

component jtag is 
           port (
                 -- inputs:
                    signal av_address : IN STD_LOGIC;
                    signal av_chipselect : IN STD_LOGIC;
                    signal av_read_n : IN STD_LOGIC;
                    signal av_write_n : IN STD_LOGIC;
                    signal av_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal rst_n : IN STD_LOGIC;

                 -- outputs:
                    signal av_irq : OUT STD_LOGIC;
                    signal av_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal av_waitrequest : OUT STD_LOGIC;
                    signal dataavailable : OUT STD_LOGIC;
                    signal readyfordata : OUT STD_LOGIC
                 );
end component jtag;

component lcd_control_slave_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal lcd_control_slave_readdata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_lcd_control_slave : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_lcd_control_slave : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_lcd_control_slave : OUT STD_LOGIC;
                    signal cpu_data_master_requests_lcd_control_slave : OUT STD_LOGIC;
                    signal d1_lcd_control_slave_end_xfer : OUT STD_LOGIC;
                    signal lcd_control_slave_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal lcd_control_slave_begintransfer : OUT STD_LOGIC;
                    signal lcd_control_slave_read : OUT STD_LOGIC;
                    signal lcd_control_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal lcd_control_slave_wait_counter_eq_0 : OUT STD_LOGIC;
                    signal lcd_control_slave_wait_counter_eq_1 : OUT STD_LOGIC;
                    signal lcd_control_slave_write : OUT STD_LOGIC;
                    signal lcd_control_slave_writedata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component lcd_control_slave_arbitrator;

component lcd is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal begintransfer : IN STD_LOGIC;
                    signal read : IN STD_LOGIC;
                    signal write : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);

                 -- outputs:
                    signal LCD_E : OUT STD_LOGIC;
                    signal LCD_RS : OUT STD_LOGIC;
                    signal LCD_RW : OUT STD_LOGIC;
                    signal LCD_data : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal irq : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component lcd;

component led_green_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_led_green_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_led_green_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_led_green_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_led_green_s1 : OUT STD_LOGIC;
                    signal d1_led_green_s1_end_xfer : OUT STD_LOGIC;
                    signal led_green_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal led_green_s1_chipselect : OUT STD_LOGIC;
                    signal led_green_s1_reset_n : OUT STD_LOGIC;
                    signal led_green_s1_write_n : OUT STD_LOGIC;
                    signal led_green_s1_writedata : OUT STD_LOGIC_VECTOR (8 DOWNTO 0)
                 );
end component led_green_s1_arbitrator;

component led_green is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (8 DOWNTO 0);

                 -- outputs:
                    signal out_port : OUT STD_LOGIC_VECTOR (8 DOWNTO 0)
                 );
end component led_green;

component led_red_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_led_red_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_led_red_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_led_red_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_led_red_s1 : OUT STD_LOGIC;
                    signal d1_led_red_s1_end_xfer : OUT STD_LOGIC;
                    signal led_red_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal led_red_s1_chipselect : OUT STD_LOGIC;
                    signal led_red_s1_reset_n : OUT STD_LOGIC;
                    signal led_red_s1_write_n : OUT STD_LOGIC;
                    signal led_red_s1_writedata : OUT STD_LOGIC_VECTOR (17 DOWNTO 0)
                 );
end component led_red_s1_arbitrator;

component led_red is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (17 DOWNTO 0);

                 -- outputs:
                    signal out_port : OUT STD_LOGIC_VECTOR (17 DOWNTO 0)
                 );
end component led_red;

component sdram_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_dbs_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_dbs_write_16 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal cpu_data_master_no_byte_enables_and_last_term : IN STD_LOGIC;
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_instruction_master_dbs_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal sdram_s1_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal sdram_s1_readdatavalid : IN STD_LOGIC;
                    signal sdram_s1_waitrequest : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_byteenable_sdram_s1 : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_granted_sdram_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_sdram_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_sdram_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_sdram_s1_shift_register : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal cpu_data_master_requests_sdram_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_granted_sdram_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_sdram_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_sdram_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_sdram_s1_shift_register : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal cpu_instruction_master_requests_sdram_s1 : OUT STD_LOGIC;
                    signal d1_sdram_s1_end_xfer : OUT STD_LOGIC;
                    signal sdram_s1_address : OUT STD_LOGIC_VECTOR (21 DOWNTO 0);
                    signal sdram_s1_byteenable_n : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal sdram_s1_chipselect : OUT STD_LOGIC;
                    signal sdram_s1_posted_fifo_readenable : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal sdram_s1_posted_fifo_writenable : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal sdram_s1_read_n : OUT STD_LOGIC;
                    signal sdram_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal sdram_s1_reset_n : OUT STD_LOGIC;
                    signal sdram_s1_waitrequest_from_sa : OUT STD_LOGIC;
                    signal sdram_s1_write_n : OUT STD_LOGIC;
                    signal sdram_s1_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component sdram_s1_arbitrator;

component sdram is 
           port (
                 -- inputs:
                    signal az_addr : IN STD_LOGIC_VECTOR (21 DOWNTO 0);
                    signal az_be_n : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal az_cs : IN STD_LOGIC;
                    signal az_data : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal az_rd_n : IN STD_LOGIC;
                    signal az_wr_n : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal za_data : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal za_valid : OUT STD_LOGIC;
                    signal za_waitrequest : OUT STD_LOGIC;
                    signal zs_addr : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal zs_ba : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal zs_cas_n : OUT STD_LOGIC;
                    signal zs_cke : OUT STD_LOGIC;
                    signal zs_cs_n : OUT STD_LOGIC;
                    signal zs_dq : INOUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal zs_dqm : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal zs_ras_n : OUT STD_LOGIC;
                    signal zs_we_n : OUT STD_LOGIC
                 );
end component sdram;

component seven_seg_avalonS_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_seven_seg_avalonS : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_seven_seg_avalonS : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_seven_seg_avalonS : OUT STD_LOGIC;
                    signal cpu_data_master_requests_seven_seg_avalonS : OUT STD_LOGIC;
                    signal cpu_instruction_master_granted_seven_seg_avalonS : OUT STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_seven_seg_avalonS : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_seven_seg_avalonS : OUT STD_LOGIC;
                    signal cpu_instruction_master_requests_seven_seg_avalonS : OUT STD_LOGIC;
                    signal d1_seven_seg_avalonS_end_xfer : OUT STD_LOGIC;
                    signal seven_seg_avalonS_reset_n : OUT STD_LOGIC;
                    signal seven_seg_avalonS_write : OUT STD_LOGIC;
                    signal seven_seg_avalonS_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component seven_seg_avalonS_arbitrator;

component seven_seg is 
           port (
                 -- inputs:
                    signal iCLK : IN STD_LOGIC;
                    signal iDIG : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal iRST_N : IN STD_LOGIC;
                    signal iWR : IN STD_LOGIC;

                 -- outputs:
                    signal oSEG0 : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal oSEG1 : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal oSEG2 : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal oSEG3 : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal oSEG4 : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal oSEG5 : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal oSEG6 : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal oSEG7 : OUT STD_LOGIC_VECTOR (6 DOWNTO 0)
                 );
end component seven_seg;

component sram_avalonS_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_dbs_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_dbs_write_16 : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal cpu_data_master_no_byte_enables_and_last_term : IN STD_LOGIC;
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_instruction_master_dbs_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_sdram_s1_shift_register : IN STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal sram_avalonS_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal cpu_data_master_byteenable_sram_avalonS : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_granted_sram_avalonS : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_sram_avalonS : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_sram_avalonS : OUT STD_LOGIC;
                    signal cpu_data_master_requests_sram_avalonS : OUT STD_LOGIC;
                    signal cpu_instruction_master_granted_sram_avalonS : OUT STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_sram_avalonS : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_sram_avalonS : OUT STD_LOGIC;
                    signal cpu_instruction_master_requests_sram_avalonS : OUT STD_LOGIC;
                    signal d1_sram_avalonS_end_xfer : OUT STD_LOGIC;
                    signal sram_avalonS_address : OUT STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal sram_avalonS_byteenable_n : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal sram_avalonS_chipselect_n : OUT STD_LOGIC;
                    signal sram_avalonS_outputenable_n : OUT STD_LOGIC;
                    signal sram_avalonS_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal sram_avalonS_reset_n : OUT STD_LOGIC;
                    signal sram_avalonS_wait_counter_eq_0 : OUT STD_LOGIC;
                    signal sram_avalonS_write_n : OUT STD_LOGIC;
                    signal sram_avalonS_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component sram_avalonS_arbitrator;

component sram is 
           port (
                 -- inputs:
                    signal iADDR : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal iCE_N : IN STD_LOGIC;
                    signal iDATA : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal iLB_N : IN STD_LOGIC;
                    signal iOE_N : IN STD_LOGIC;
                    signal iRST_N : IN STD_LOGIC;
                    signal iUB_N : IN STD_LOGIC;
                    signal iWE_N : IN STD_LOGIC;

                 -- outputs:
                    signal SRAM_ADDR : OUT STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal SRAM_CE_N : OUT STD_LOGIC;
                    signal SRAM_DQ : INOUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal SRAM_LB_N : OUT STD_LOGIC;
                    signal SRAM_OE_N : OUT STD_LOGIC;
                    signal SRAM_UB_N : OUT STD_LOGIC;
                    signal SRAM_WE_N : OUT STD_LOGIC;
                    signal oDATA : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component sram;

component switches_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal switches_s1_readdata : IN STD_LOGIC_VECTOR (17 DOWNTO 0);

                 -- outputs:
                    signal cpu_data_master_granted_switches_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_switches_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_switches_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_switches_s1 : OUT STD_LOGIC;
                    signal d1_switches_s1_end_xfer : OUT STD_LOGIC;
                    signal switches_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal switches_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal switches_s1_reset_n : OUT STD_LOGIC
                 );
end component switches_s1_arbitrator;

component switches is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal in_port : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal readdata : OUT STD_LOGIC_VECTOR (17 DOWNTO 0)
                 );
end component switches;

component timer0_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal timer0_s1_irq : IN STD_LOGIC;
                    signal timer0_s1_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal cpu_data_master_granted_timer0_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_timer0_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_timer0_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_timer0_s1 : OUT STD_LOGIC;
                    signal d1_timer0_s1_end_xfer : OUT STD_LOGIC;
                    signal timer0_s1_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal timer0_s1_chipselect : OUT STD_LOGIC;
                    signal timer0_s1_irq_from_sa : OUT STD_LOGIC;
                    signal timer0_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal timer0_s1_reset_n : OUT STD_LOGIC;
                    signal timer0_s1_write_n : OUT STD_LOGIC;
                    signal timer0_s1_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component timer0_s1_arbitrator;

component timer0 is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal irq : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component timer0;

component uart_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal uart_s1_dataavailable : IN STD_LOGIC;
                    signal uart_s1_irq : IN STD_LOGIC;
                    signal uart_s1_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal uart_s1_readyfordata : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_uart_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_uart_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_uart_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_uart_s1 : OUT STD_LOGIC;
                    signal d1_uart_s1_end_xfer : OUT STD_LOGIC;
                    signal uart_s1_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal uart_s1_begintransfer : OUT STD_LOGIC;
                    signal uart_s1_chipselect : OUT STD_LOGIC;
                    signal uart_s1_dataavailable_from_sa : OUT STD_LOGIC;
                    signal uart_s1_irq_from_sa : OUT STD_LOGIC;
                    signal uart_s1_read_n : OUT STD_LOGIC;
                    signal uart_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal uart_s1_readyfordata_from_sa : OUT STD_LOGIC;
                    signal uart_s1_reset_n : OUT STD_LOGIC;
                    signal uart_s1_write_n : OUT STD_LOGIC;
                    signal uart_s1_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component uart_s1_arbitrator;

component uart is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal begintransfer : IN STD_LOGIC;
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal read_n : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal rxd : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal dataavailable : OUT STD_LOGIC;
                    signal irq : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal readyfordata : OUT STD_LOGIC;
                    signal txd : OUT STD_LOGIC
                 );
end component uart;

component nios32_reset_clk_domain_synch_module is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal data_in : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal data_out : OUT STD_LOGIC
                 );
end component nios32_reset_clk_domain_synch_module;

                signal buttons_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal buttons_s1_chipselect :  STD_LOGIC;
                signal buttons_s1_irq :  STD_LOGIC;
                signal buttons_s1_irq_from_sa :  STD_LOGIC;
                signal buttons_s1_readdata :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal buttons_s1_readdata_from_sa :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal buttons_s1_reset_n :  STD_LOGIC;
                signal buttons_s1_write_n :  STD_LOGIC;
                signal buttons_s1_writedata :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal clk_reset_n :  STD_LOGIC;
                signal cpu_data_master_address :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal cpu_data_master_address_to_slave :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal cpu_data_master_byteenable :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal cpu_data_master_byteenable_flash_s1 :  STD_LOGIC;
                signal cpu_data_master_byteenable_sdram_s1 :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_byteenable_sram_avalonS :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_dbs_write_16 :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal cpu_data_master_dbs_write_8 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal cpu_data_master_debugaccess :  STD_LOGIC;
                signal cpu_data_master_granted_buttons_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_data_master_granted_epcs_controller_epcs_control_port :  STD_LOGIC;
                signal cpu_data_master_granted_flash_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_jtag_avalon_jtag_slave :  STD_LOGIC;
                signal cpu_data_master_granted_lcd_control_slave :  STD_LOGIC;
                signal cpu_data_master_granted_led_green_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_led_red_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_sdram_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_seven_seg_avalonS :  STD_LOGIC;
                signal cpu_data_master_granted_sram_avalonS :  STD_LOGIC;
                signal cpu_data_master_granted_switches_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_timer0_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_uart_s1 :  STD_LOGIC;
                signal cpu_data_master_irq :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_data_master_no_byte_enables_and_last_term :  STD_LOGIC;
                signal cpu_data_master_qualified_request_buttons_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_data_master_qualified_request_epcs_controller_epcs_control_port :  STD_LOGIC;
                signal cpu_data_master_qualified_request_flash_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_jtag_avalon_jtag_slave :  STD_LOGIC;
                signal cpu_data_master_qualified_request_lcd_control_slave :  STD_LOGIC;
                signal cpu_data_master_qualified_request_led_green_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_led_red_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_sdram_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_seven_seg_avalonS :  STD_LOGIC;
                signal cpu_data_master_qualified_request_sram_avalonS :  STD_LOGIC;
                signal cpu_data_master_qualified_request_switches_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_timer0_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_uart_s1 :  STD_LOGIC;
                signal cpu_data_master_read :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_buttons_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_epcs_controller_epcs_control_port :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_flash_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_jtag_avalon_jtag_slave :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_lcd_control_slave :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_led_green_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_led_red_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_sdram_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_sdram_s1_shift_register :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal cpu_data_master_read_data_valid_seven_seg_avalonS :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_sram_avalonS :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_switches_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_timer0_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_uart_s1 :  STD_LOGIC;
                signal cpu_data_master_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_data_master_requests_buttons_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_data_master_requests_epcs_controller_epcs_control_port :  STD_LOGIC;
                signal cpu_data_master_requests_flash_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_jtag_avalon_jtag_slave :  STD_LOGIC;
                signal cpu_data_master_requests_lcd_control_slave :  STD_LOGIC;
                signal cpu_data_master_requests_led_green_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_led_red_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_sdram_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_seven_seg_avalonS :  STD_LOGIC;
                signal cpu_data_master_requests_sram_avalonS :  STD_LOGIC;
                signal cpu_data_master_requests_switches_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_timer0_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_uart_s1 :  STD_LOGIC;
                signal cpu_data_master_waitrequest :  STD_LOGIC;
                signal cpu_data_master_write :  STD_LOGIC;
                signal cpu_data_master_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_instruction_master_address :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal cpu_instruction_master_address_to_slave :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal cpu_instruction_master_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_instruction_master_granted_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_instruction_master_granted_epcs_controller_epcs_control_port :  STD_LOGIC;
                signal cpu_instruction_master_granted_flash_s1 :  STD_LOGIC;
                signal cpu_instruction_master_granted_sdram_s1 :  STD_LOGIC;
                signal cpu_instruction_master_granted_seven_seg_avalonS :  STD_LOGIC;
                signal cpu_instruction_master_granted_sram_avalonS :  STD_LOGIC;
                signal cpu_instruction_master_latency_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_instruction_master_qualified_request_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_instruction_master_qualified_request_epcs_controller_epcs_control_port :  STD_LOGIC;
                signal cpu_instruction_master_qualified_request_flash_s1 :  STD_LOGIC;
                signal cpu_instruction_master_qualified_request_sdram_s1 :  STD_LOGIC;
                signal cpu_instruction_master_qualified_request_seven_seg_avalonS :  STD_LOGIC;
                signal cpu_instruction_master_qualified_request_sram_avalonS :  STD_LOGIC;
                signal cpu_instruction_master_read :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_epcs_controller_epcs_control_port :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_flash_s1 :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_sdram_s1 :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_sdram_s1_shift_register :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal cpu_instruction_master_read_data_valid_seven_seg_avalonS :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_sram_avalonS :  STD_LOGIC;
                signal cpu_instruction_master_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_instruction_master_readdatavalid :  STD_LOGIC;
                signal cpu_instruction_master_requests_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_instruction_master_requests_epcs_controller_epcs_control_port :  STD_LOGIC;
                signal cpu_instruction_master_requests_flash_s1 :  STD_LOGIC;
                signal cpu_instruction_master_requests_sdram_s1 :  STD_LOGIC;
                signal cpu_instruction_master_requests_seven_seg_avalonS :  STD_LOGIC;
                signal cpu_instruction_master_requests_sram_avalonS :  STD_LOGIC;
                signal cpu_instruction_master_waitrequest :  STD_LOGIC;
                signal cpu_jtag_debug_module_address :  STD_LOGIC_VECTOR (8 DOWNTO 0);
                signal cpu_jtag_debug_module_begintransfer :  STD_LOGIC;
                signal cpu_jtag_debug_module_byteenable :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal cpu_jtag_debug_module_chipselect :  STD_LOGIC;
                signal cpu_jtag_debug_module_debugaccess :  STD_LOGIC;
                signal cpu_jtag_debug_module_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_jtag_debug_module_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_jtag_debug_module_reset :  STD_LOGIC;
                signal cpu_jtag_debug_module_reset_n :  STD_LOGIC;
                signal cpu_jtag_debug_module_resetrequest :  STD_LOGIC;
                signal cpu_jtag_debug_module_resetrequest_from_sa :  STD_LOGIC;
                signal cpu_jtag_debug_module_write :  STD_LOGIC;
                signal cpu_jtag_debug_module_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal d1_buttons_s1_end_xfer :  STD_LOGIC;
                signal d1_cpu_jtag_debug_module_end_xfer :  STD_LOGIC;
                signal d1_epcs_controller_epcs_control_port_end_xfer :  STD_LOGIC;
                signal d1_ext_bus_avalon_slave_end_xfer :  STD_LOGIC;
                signal d1_jtag_avalon_jtag_slave_end_xfer :  STD_LOGIC;
                signal d1_lcd_control_slave_end_xfer :  STD_LOGIC;
                signal d1_led_green_s1_end_xfer :  STD_LOGIC;
                signal d1_led_red_s1_end_xfer :  STD_LOGIC;
                signal d1_sdram_s1_end_xfer :  STD_LOGIC;
                signal d1_seven_seg_avalonS_end_xfer :  STD_LOGIC;
                signal d1_sram_avalonS_end_xfer :  STD_LOGIC;
                signal d1_switches_s1_end_xfer :  STD_LOGIC;
                signal d1_timer0_s1_end_xfer :  STD_LOGIC;
                signal d1_uart_s1_end_xfer :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_address :  STD_LOGIC_VECTOR (8 DOWNTO 0);
                signal epcs_controller_epcs_control_port_chipselect :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_dataavailable :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_dataavailable_from_sa :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_endofpacket :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_endofpacket_from_sa :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_irq :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_irq_from_sa :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_read_n :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal epcs_controller_epcs_control_port_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal epcs_controller_epcs_control_port_readyfordata :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_readyfordata_from_sa :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_reset_n :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_write_n :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal flash_s1_wait_counter_eq_0 :  STD_LOGIC;
                signal flash_s1_wait_counter_eq_1 :  STD_LOGIC;
                signal incoming_ext_bus_data :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal incoming_ext_bus_data_with_Xs_converted_to_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal internal_LCD_E_from_the_lcd :  STD_LOGIC;
                signal internal_LCD_RS_from_the_lcd :  STD_LOGIC;
                signal internal_LCD_RW_from_the_lcd :  STD_LOGIC;
                signal internal_SRAM_ADDR_from_the_sram :  STD_LOGIC_VECTOR (17 DOWNTO 0);
                signal internal_SRAM_CE_N_from_the_sram :  STD_LOGIC;
                signal internal_SRAM_LB_N_from_the_sram :  STD_LOGIC;
                signal internal_SRAM_OE_N_from_the_sram :  STD_LOGIC;
                signal internal_SRAM_UB_N_from_the_sram :  STD_LOGIC;
                signal internal_SRAM_WE_N_from_the_sram :  STD_LOGIC;
                signal internal_ext_bus_address :  STD_LOGIC_VECTOR (19 DOWNTO 0);
                signal internal_ext_bus_readn :  STD_LOGIC;
                signal internal_oSEG0_from_the_seven_seg :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal internal_oSEG1_from_the_seven_seg :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal internal_oSEG2_from_the_seven_seg :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal internal_oSEG3_from_the_seven_seg :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal internal_oSEG4_from_the_seven_seg :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal internal_oSEG5_from_the_seven_seg :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal internal_oSEG6_from_the_seven_seg :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal internal_oSEG7_from_the_seven_seg :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal internal_out_port_from_the_led_green :  STD_LOGIC_VECTOR (8 DOWNTO 0);
                signal internal_out_port_from_the_led_red :  STD_LOGIC_VECTOR (17 DOWNTO 0);
                signal internal_select_n_to_the_flash :  STD_LOGIC;
                signal internal_txd_from_the_uart :  STD_LOGIC;
                signal internal_write_n_to_the_flash :  STD_LOGIC;
                signal internal_zs_addr_from_the_sdram :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal internal_zs_ba_from_the_sdram :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal internal_zs_cas_n_from_the_sdram :  STD_LOGIC;
                signal internal_zs_cke_from_the_sdram :  STD_LOGIC;
                signal internal_zs_cs_n_from_the_sdram :  STD_LOGIC;
                signal internal_zs_dqm_from_the_sdram :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal internal_zs_ras_n_from_the_sdram :  STD_LOGIC;
                signal internal_zs_we_n_from_the_sdram :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_address :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_chipselect :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_dataavailable :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_dataavailable_from_sa :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_irq :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_irq_from_sa :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_read_n :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal jtag_avalon_jtag_slave_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal jtag_avalon_jtag_slave_readyfordata :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_readyfordata_from_sa :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_reset_n :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_waitrequest :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_waitrequest_from_sa :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_write_n :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal lcd_control_slave_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal lcd_control_slave_begintransfer :  STD_LOGIC;
                signal lcd_control_slave_irq :  STD_LOGIC;
                signal lcd_control_slave_read :  STD_LOGIC;
                signal lcd_control_slave_readdata :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal lcd_control_slave_readdata_from_sa :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal lcd_control_slave_wait_counter_eq_0 :  STD_LOGIC;
                signal lcd_control_slave_wait_counter_eq_1 :  STD_LOGIC;
                signal lcd_control_slave_write :  STD_LOGIC;
                signal lcd_control_slave_writedata :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal led_green_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal led_green_s1_chipselect :  STD_LOGIC;
                signal led_green_s1_reset_n :  STD_LOGIC;
                signal led_green_s1_write_n :  STD_LOGIC;
                signal led_green_s1_writedata :  STD_LOGIC_VECTOR (8 DOWNTO 0);
                signal led_red_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal led_red_s1_chipselect :  STD_LOGIC;
                signal led_red_s1_reset_n :  STD_LOGIC;
                signal led_red_s1_write_n :  STD_LOGIC;
                signal led_red_s1_writedata :  STD_LOGIC_VECTOR (17 DOWNTO 0);
                signal module_input :  STD_LOGIC;
                signal registered_cpu_data_master_read_data_valid_flash_s1 :  STD_LOGIC;
                signal reset_n_sources :  STD_LOGIC;
                signal sdram_s1_address :  STD_LOGIC_VECTOR (21 DOWNTO 0);
                signal sdram_s1_byteenable_n :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal sdram_s1_chipselect :  STD_LOGIC;
                signal sdram_s1_posted_fifo_readenable :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal sdram_s1_posted_fifo_writenable :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal sdram_s1_read_n :  STD_LOGIC;
                signal sdram_s1_readdata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal sdram_s1_readdata_from_sa :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal sdram_s1_readdatavalid :  STD_LOGIC;
                signal sdram_s1_reset_n :  STD_LOGIC;
                signal sdram_s1_waitrequest :  STD_LOGIC;
                signal sdram_s1_waitrequest_from_sa :  STD_LOGIC;
                signal sdram_s1_write_n :  STD_LOGIC;
                signal sdram_s1_writedata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal seven_seg_avalonS_reset_n :  STD_LOGIC;
                signal seven_seg_avalonS_write :  STD_LOGIC;
                signal seven_seg_avalonS_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal sram_avalonS_address :  STD_LOGIC_VECTOR (17 DOWNTO 0);
                signal sram_avalonS_byteenable_n :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal sram_avalonS_chipselect_n :  STD_LOGIC;
                signal sram_avalonS_outputenable_n :  STD_LOGIC;
                signal sram_avalonS_readdata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal sram_avalonS_readdata_from_sa :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal sram_avalonS_reset_n :  STD_LOGIC;
                signal sram_avalonS_wait_counter_eq_0 :  STD_LOGIC;
                signal sram_avalonS_write_n :  STD_LOGIC;
                signal sram_avalonS_writedata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal switches_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal switches_s1_readdata :  STD_LOGIC_VECTOR (17 DOWNTO 0);
                signal switches_s1_readdata_from_sa :  STD_LOGIC_VECTOR (17 DOWNTO 0);
                signal switches_s1_reset_n :  STD_LOGIC;
                signal timer0_s1_address :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal timer0_s1_chipselect :  STD_LOGIC;
                signal timer0_s1_irq :  STD_LOGIC;
                signal timer0_s1_irq_from_sa :  STD_LOGIC;
                signal timer0_s1_readdata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal timer0_s1_readdata_from_sa :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal timer0_s1_reset_n :  STD_LOGIC;
                signal timer0_s1_write_n :  STD_LOGIC;
                signal timer0_s1_writedata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal uart_s1_address :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal uart_s1_begintransfer :  STD_LOGIC;
                signal uart_s1_chipselect :  STD_LOGIC;
                signal uart_s1_dataavailable :  STD_LOGIC;
                signal uart_s1_dataavailable_from_sa :  STD_LOGIC;
                signal uart_s1_irq :  STD_LOGIC;
                signal uart_s1_irq_from_sa :  STD_LOGIC;
                signal uart_s1_read_n :  STD_LOGIC;
                signal uart_s1_readdata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal uart_s1_readdata_from_sa :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal uart_s1_readyfordata :  STD_LOGIC;
                signal uart_s1_readyfordata_from_sa :  STD_LOGIC;
                signal uart_s1_reset_n :  STD_LOGIC;
                signal uart_s1_write_n :  STD_LOGIC;
                signal uart_s1_writedata :  STD_LOGIC_VECTOR (15 DOWNTO 0);

begin

  --the_buttons_s1, which is an e_instance
  the_buttons_s1 : buttons_s1_arbitrator
    port map(
      buttons_s1_address => buttons_s1_address,
      buttons_s1_chipselect => buttons_s1_chipselect,
      buttons_s1_irq_from_sa => buttons_s1_irq_from_sa,
      buttons_s1_readdata_from_sa => buttons_s1_readdata_from_sa,
      buttons_s1_reset_n => buttons_s1_reset_n,
      buttons_s1_write_n => buttons_s1_write_n,
      buttons_s1_writedata => buttons_s1_writedata,
      cpu_data_master_granted_buttons_s1 => cpu_data_master_granted_buttons_s1,
      cpu_data_master_qualified_request_buttons_s1 => cpu_data_master_qualified_request_buttons_s1,
      cpu_data_master_read_data_valid_buttons_s1 => cpu_data_master_read_data_valid_buttons_s1,
      cpu_data_master_requests_buttons_s1 => cpu_data_master_requests_buttons_s1,
      d1_buttons_s1_end_xfer => d1_buttons_s1_end_xfer,
      buttons_s1_irq => buttons_s1_irq,
      buttons_s1_readdata => buttons_s1_readdata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_buttons, which is an e_ptf_instance
  the_buttons : buttons
    port map(
      irq => buttons_s1_irq,
      readdata => buttons_s1_readdata,
      address => buttons_s1_address,
      chipselect => buttons_s1_chipselect,
      clk => clk,
      in_port => in_port_to_the_buttons,
      reset_n => buttons_s1_reset_n,
      write_n => buttons_s1_write_n,
      writedata => buttons_s1_writedata
    );


  --the_cpu_jtag_debug_module, which is an e_instance
  the_cpu_jtag_debug_module : cpu_jtag_debug_module_arbitrator
    port map(
      cpu_data_master_granted_cpu_jtag_debug_module => cpu_data_master_granted_cpu_jtag_debug_module,
      cpu_data_master_qualified_request_cpu_jtag_debug_module => cpu_data_master_qualified_request_cpu_jtag_debug_module,
      cpu_data_master_read_data_valid_cpu_jtag_debug_module => cpu_data_master_read_data_valid_cpu_jtag_debug_module,
      cpu_data_master_requests_cpu_jtag_debug_module => cpu_data_master_requests_cpu_jtag_debug_module,
      cpu_instruction_master_granted_cpu_jtag_debug_module => cpu_instruction_master_granted_cpu_jtag_debug_module,
      cpu_instruction_master_qualified_request_cpu_jtag_debug_module => cpu_instruction_master_qualified_request_cpu_jtag_debug_module,
      cpu_instruction_master_read_data_valid_cpu_jtag_debug_module => cpu_instruction_master_read_data_valid_cpu_jtag_debug_module,
      cpu_instruction_master_requests_cpu_jtag_debug_module => cpu_instruction_master_requests_cpu_jtag_debug_module,
      cpu_jtag_debug_module_address => cpu_jtag_debug_module_address,
      cpu_jtag_debug_module_begintransfer => cpu_jtag_debug_module_begintransfer,
      cpu_jtag_debug_module_byteenable => cpu_jtag_debug_module_byteenable,
      cpu_jtag_debug_module_chipselect => cpu_jtag_debug_module_chipselect,
      cpu_jtag_debug_module_debugaccess => cpu_jtag_debug_module_debugaccess,
      cpu_jtag_debug_module_readdata_from_sa => cpu_jtag_debug_module_readdata_from_sa,
      cpu_jtag_debug_module_reset => cpu_jtag_debug_module_reset,
      cpu_jtag_debug_module_reset_n => cpu_jtag_debug_module_reset_n,
      cpu_jtag_debug_module_resetrequest_from_sa => cpu_jtag_debug_module_resetrequest_from_sa,
      cpu_jtag_debug_module_write => cpu_jtag_debug_module_write,
      cpu_jtag_debug_module_writedata => cpu_jtag_debug_module_writedata,
      d1_cpu_jtag_debug_module_end_xfer => d1_cpu_jtag_debug_module_end_xfer,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_debugaccess => cpu_data_master_debugaccess,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      cpu_instruction_master_address_to_slave => cpu_instruction_master_address_to_slave,
      cpu_instruction_master_latency_counter => cpu_instruction_master_latency_counter,
      cpu_instruction_master_read => cpu_instruction_master_read,
      cpu_instruction_master_read_data_valid_sdram_s1_shift_register => cpu_instruction_master_read_data_valid_sdram_s1_shift_register,
      cpu_jtag_debug_module_readdata => cpu_jtag_debug_module_readdata,
      cpu_jtag_debug_module_resetrequest => cpu_jtag_debug_module_resetrequest,
      reset_n => clk_reset_n
    );


  --the_cpu_data_master, which is an e_instance
  the_cpu_data_master : cpu_data_master_arbitrator
    port map(
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_dbs_address => cpu_data_master_dbs_address,
      cpu_data_master_dbs_write_16 => cpu_data_master_dbs_write_16,
      cpu_data_master_dbs_write_8 => cpu_data_master_dbs_write_8,
      cpu_data_master_irq => cpu_data_master_irq,
      cpu_data_master_no_byte_enables_and_last_term => cpu_data_master_no_byte_enables_and_last_term,
      cpu_data_master_readdata => cpu_data_master_readdata,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      buttons_s1_irq_from_sa => buttons_s1_irq_from_sa,
      buttons_s1_readdata_from_sa => buttons_s1_readdata_from_sa,
      clk => clk,
      cpu_data_master_address => cpu_data_master_address,
      cpu_data_master_byteenable_flash_s1 => cpu_data_master_byteenable_flash_s1,
      cpu_data_master_byteenable_sdram_s1 => cpu_data_master_byteenable_sdram_s1,
      cpu_data_master_byteenable_sram_avalonS => cpu_data_master_byteenable_sram_avalonS,
      cpu_data_master_debugaccess => cpu_data_master_debugaccess,
      cpu_data_master_granted_buttons_s1 => cpu_data_master_granted_buttons_s1,
      cpu_data_master_granted_cpu_jtag_debug_module => cpu_data_master_granted_cpu_jtag_debug_module,
      cpu_data_master_granted_epcs_controller_epcs_control_port => cpu_data_master_granted_epcs_controller_epcs_control_port,
      cpu_data_master_granted_flash_s1 => cpu_data_master_granted_flash_s1,
      cpu_data_master_granted_jtag_avalon_jtag_slave => cpu_data_master_granted_jtag_avalon_jtag_slave,
      cpu_data_master_granted_lcd_control_slave => cpu_data_master_granted_lcd_control_slave,
      cpu_data_master_granted_led_green_s1 => cpu_data_master_granted_led_green_s1,
      cpu_data_master_granted_led_red_s1 => cpu_data_master_granted_led_red_s1,
      cpu_data_master_granted_sdram_s1 => cpu_data_master_granted_sdram_s1,
      cpu_data_master_granted_seven_seg_avalonS => cpu_data_master_granted_seven_seg_avalonS,
      cpu_data_master_granted_sram_avalonS => cpu_data_master_granted_sram_avalonS,
      cpu_data_master_granted_switches_s1 => cpu_data_master_granted_switches_s1,
      cpu_data_master_granted_timer0_s1 => cpu_data_master_granted_timer0_s1,
      cpu_data_master_granted_uart_s1 => cpu_data_master_granted_uart_s1,
      cpu_data_master_qualified_request_buttons_s1 => cpu_data_master_qualified_request_buttons_s1,
      cpu_data_master_qualified_request_cpu_jtag_debug_module => cpu_data_master_qualified_request_cpu_jtag_debug_module,
      cpu_data_master_qualified_request_epcs_controller_epcs_control_port => cpu_data_master_qualified_request_epcs_controller_epcs_control_port,
      cpu_data_master_qualified_request_flash_s1 => cpu_data_master_qualified_request_flash_s1,
      cpu_data_master_qualified_request_jtag_avalon_jtag_slave => cpu_data_master_qualified_request_jtag_avalon_jtag_slave,
      cpu_data_master_qualified_request_lcd_control_slave => cpu_data_master_qualified_request_lcd_control_slave,
      cpu_data_master_qualified_request_led_green_s1 => cpu_data_master_qualified_request_led_green_s1,
      cpu_data_master_qualified_request_led_red_s1 => cpu_data_master_qualified_request_led_red_s1,
      cpu_data_master_qualified_request_sdram_s1 => cpu_data_master_qualified_request_sdram_s1,
      cpu_data_master_qualified_request_seven_seg_avalonS => cpu_data_master_qualified_request_seven_seg_avalonS,
      cpu_data_master_qualified_request_sram_avalonS => cpu_data_master_qualified_request_sram_avalonS,
      cpu_data_master_qualified_request_switches_s1 => cpu_data_master_qualified_request_switches_s1,
      cpu_data_master_qualified_request_timer0_s1 => cpu_data_master_qualified_request_timer0_s1,
      cpu_data_master_qualified_request_uart_s1 => cpu_data_master_qualified_request_uart_s1,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_read_data_valid_buttons_s1 => cpu_data_master_read_data_valid_buttons_s1,
      cpu_data_master_read_data_valid_cpu_jtag_debug_module => cpu_data_master_read_data_valid_cpu_jtag_debug_module,
      cpu_data_master_read_data_valid_epcs_controller_epcs_control_port => cpu_data_master_read_data_valid_epcs_controller_epcs_control_port,
      cpu_data_master_read_data_valid_flash_s1 => cpu_data_master_read_data_valid_flash_s1,
      cpu_data_master_read_data_valid_jtag_avalon_jtag_slave => cpu_data_master_read_data_valid_jtag_avalon_jtag_slave,
      cpu_data_master_read_data_valid_lcd_control_slave => cpu_data_master_read_data_valid_lcd_control_slave,
      cpu_data_master_read_data_valid_led_green_s1 => cpu_data_master_read_data_valid_led_green_s1,
      cpu_data_master_read_data_valid_led_red_s1 => cpu_data_master_read_data_valid_led_red_s1,
      cpu_data_master_read_data_valid_sdram_s1 => cpu_data_master_read_data_valid_sdram_s1,
      cpu_data_master_read_data_valid_sdram_s1_shift_register => cpu_data_master_read_data_valid_sdram_s1_shift_register,
      cpu_data_master_read_data_valid_seven_seg_avalonS => cpu_data_master_read_data_valid_seven_seg_avalonS,
      cpu_data_master_read_data_valid_sram_avalonS => cpu_data_master_read_data_valid_sram_avalonS,
      cpu_data_master_read_data_valid_switches_s1 => cpu_data_master_read_data_valid_switches_s1,
      cpu_data_master_read_data_valid_timer0_s1 => cpu_data_master_read_data_valid_timer0_s1,
      cpu_data_master_read_data_valid_uart_s1 => cpu_data_master_read_data_valid_uart_s1,
      cpu_data_master_requests_buttons_s1 => cpu_data_master_requests_buttons_s1,
      cpu_data_master_requests_cpu_jtag_debug_module => cpu_data_master_requests_cpu_jtag_debug_module,
      cpu_data_master_requests_epcs_controller_epcs_control_port => cpu_data_master_requests_epcs_controller_epcs_control_port,
      cpu_data_master_requests_flash_s1 => cpu_data_master_requests_flash_s1,
      cpu_data_master_requests_jtag_avalon_jtag_slave => cpu_data_master_requests_jtag_avalon_jtag_slave,
      cpu_data_master_requests_lcd_control_slave => cpu_data_master_requests_lcd_control_slave,
      cpu_data_master_requests_led_green_s1 => cpu_data_master_requests_led_green_s1,
      cpu_data_master_requests_led_red_s1 => cpu_data_master_requests_led_red_s1,
      cpu_data_master_requests_sdram_s1 => cpu_data_master_requests_sdram_s1,
      cpu_data_master_requests_seven_seg_avalonS => cpu_data_master_requests_seven_seg_avalonS,
      cpu_data_master_requests_sram_avalonS => cpu_data_master_requests_sram_avalonS,
      cpu_data_master_requests_switches_s1 => cpu_data_master_requests_switches_s1,
      cpu_data_master_requests_timer0_s1 => cpu_data_master_requests_timer0_s1,
      cpu_data_master_requests_uart_s1 => cpu_data_master_requests_uart_s1,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      cpu_jtag_debug_module_readdata_from_sa => cpu_jtag_debug_module_readdata_from_sa,
      d1_buttons_s1_end_xfer => d1_buttons_s1_end_xfer,
      d1_cpu_jtag_debug_module_end_xfer => d1_cpu_jtag_debug_module_end_xfer,
      d1_epcs_controller_epcs_control_port_end_xfer => d1_epcs_controller_epcs_control_port_end_xfer,
      d1_ext_bus_avalon_slave_end_xfer => d1_ext_bus_avalon_slave_end_xfer,
      d1_jtag_avalon_jtag_slave_end_xfer => d1_jtag_avalon_jtag_slave_end_xfer,
      d1_lcd_control_slave_end_xfer => d1_lcd_control_slave_end_xfer,
      d1_led_green_s1_end_xfer => d1_led_green_s1_end_xfer,
      d1_led_red_s1_end_xfer => d1_led_red_s1_end_xfer,
      d1_sdram_s1_end_xfer => d1_sdram_s1_end_xfer,
      d1_seven_seg_avalonS_end_xfer => d1_seven_seg_avalonS_end_xfer,
      d1_sram_avalonS_end_xfer => d1_sram_avalonS_end_xfer,
      d1_switches_s1_end_xfer => d1_switches_s1_end_xfer,
      d1_timer0_s1_end_xfer => d1_timer0_s1_end_xfer,
      d1_uart_s1_end_xfer => d1_uart_s1_end_xfer,
      epcs_controller_epcs_control_port_irq_from_sa => epcs_controller_epcs_control_port_irq_from_sa,
      epcs_controller_epcs_control_port_readdata_from_sa => epcs_controller_epcs_control_port_readdata_from_sa,
      flash_s1_wait_counter_eq_0 => flash_s1_wait_counter_eq_0,
      flash_s1_wait_counter_eq_1 => flash_s1_wait_counter_eq_1,
      incoming_ext_bus_data_with_Xs_converted_to_0 => incoming_ext_bus_data_with_Xs_converted_to_0,
      jtag_avalon_jtag_slave_irq_from_sa => jtag_avalon_jtag_slave_irq_from_sa,
      jtag_avalon_jtag_slave_readdata_from_sa => jtag_avalon_jtag_slave_readdata_from_sa,
      jtag_avalon_jtag_slave_waitrequest_from_sa => jtag_avalon_jtag_slave_waitrequest_from_sa,
      lcd_control_slave_readdata_from_sa => lcd_control_slave_readdata_from_sa,
      lcd_control_slave_wait_counter_eq_0 => lcd_control_slave_wait_counter_eq_0,
      lcd_control_slave_wait_counter_eq_1 => lcd_control_slave_wait_counter_eq_1,
      registered_cpu_data_master_read_data_valid_flash_s1 => registered_cpu_data_master_read_data_valid_flash_s1,
      reset_n => clk_reset_n,
      sdram_s1_posted_fifo_readenable => sdram_s1_posted_fifo_readenable,
      sdram_s1_posted_fifo_writenable => sdram_s1_posted_fifo_writenable,
      sdram_s1_readdata_from_sa => sdram_s1_readdata_from_sa,
      sdram_s1_waitrequest_from_sa => sdram_s1_waitrequest_from_sa,
      sram_avalonS_readdata_from_sa => sram_avalonS_readdata_from_sa,
      sram_avalonS_wait_counter_eq_0 => sram_avalonS_wait_counter_eq_0,
      switches_s1_readdata_from_sa => switches_s1_readdata_from_sa,
      timer0_s1_irq_from_sa => timer0_s1_irq_from_sa,
      timer0_s1_readdata_from_sa => timer0_s1_readdata_from_sa,
      uart_s1_irq_from_sa => uart_s1_irq_from_sa,
      uart_s1_readdata_from_sa => uart_s1_readdata_from_sa
    );


  --the_cpu_instruction_master, which is an e_instance
  the_cpu_instruction_master : cpu_instruction_master_arbitrator
    port map(
      cpu_instruction_master_address_to_slave => cpu_instruction_master_address_to_slave,
      cpu_instruction_master_dbs_address => cpu_instruction_master_dbs_address,
      cpu_instruction_master_latency_counter => cpu_instruction_master_latency_counter,
      cpu_instruction_master_readdata => cpu_instruction_master_readdata,
      cpu_instruction_master_readdatavalid => cpu_instruction_master_readdatavalid,
      cpu_instruction_master_waitrequest => cpu_instruction_master_waitrequest,
      clk => clk,
      cpu_instruction_master_address => cpu_instruction_master_address,
      cpu_instruction_master_granted_cpu_jtag_debug_module => cpu_instruction_master_granted_cpu_jtag_debug_module,
      cpu_instruction_master_granted_epcs_controller_epcs_control_port => cpu_instruction_master_granted_epcs_controller_epcs_control_port,
      cpu_instruction_master_granted_flash_s1 => cpu_instruction_master_granted_flash_s1,
      cpu_instruction_master_granted_sdram_s1 => cpu_instruction_master_granted_sdram_s1,
      cpu_instruction_master_granted_seven_seg_avalonS => cpu_instruction_master_granted_seven_seg_avalonS,
      cpu_instruction_master_granted_sram_avalonS => cpu_instruction_master_granted_sram_avalonS,
      cpu_instruction_master_qualified_request_cpu_jtag_debug_module => cpu_instruction_master_qualified_request_cpu_jtag_debug_module,
      cpu_instruction_master_qualified_request_epcs_controller_epcs_control_port => cpu_instruction_master_qualified_request_epcs_controller_epcs_control_port,
      cpu_instruction_master_qualified_request_flash_s1 => cpu_instruction_master_qualified_request_flash_s1,
      cpu_instruction_master_qualified_request_sdram_s1 => cpu_instruction_master_qualified_request_sdram_s1,
      cpu_instruction_master_qualified_request_seven_seg_avalonS => cpu_instruction_master_qualified_request_seven_seg_avalonS,
      cpu_instruction_master_qualified_request_sram_avalonS => cpu_instruction_master_qualified_request_sram_avalonS,
      cpu_instruction_master_read => cpu_instruction_master_read,
      cpu_instruction_master_read_data_valid_cpu_jtag_debug_module => cpu_instruction_master_read_data_valid_cpu_jtag_debug_module,
      cpu_instruction_master_read_data_valid_epcs_controller_epcs_control_port => cpu_instruction_master_read_data_valid_epcs_controller_epcs_control_port,
      cpu_instruction_master_read_data_valid_flash_s1 => cpu_instruction_master_read_data_valid_flash_s1,
      cpu_instruction_master_read_data_valid_sdram_s1 => cpu_instruction_master_read_data_valid_sdram_s1,
      cpu_instruction_master_read_data_valid_sdram_s1_shift_register => cpu_instruction_master_read_data_valid_sdram_s1_shift_register,
      cpu_instruction_master_read_data_valid_seven_seg_avalonS => cpu_instruction_master_read_data_valid_seven_seg_avalonS,
      cpu_instruction_master_read_data_valid_sram_avalonS => cpu_instruction_master_read_data_valid_sram_avalonS,
      cpu_instruction_master_requests_cpu_jtag_debug_module => cpu_instruction_master_requests_cpu_jtag_debug_module,
      cpu_instruction_master_requests_epcs_controller_epcs_control_port => cpu_instruction_master_requests_epcs_controller_epcs_control_port,
      cpu_instruction_master_requests_flash_s1 => cpu_instruction_master_requests_flash_s1,
      cpu_instruction_master_requests_sdram_s1 => cpu_instruction_master_requests_sdram_s1,
      cpu_instruction_master_requests_seven_seg_avalonS => cpu_instruction_master_requests_seven_seg_avalonS,
      cpu_instruction_master_requests_sram_avalonS => cpu_instruction_master_requests_sram_avalonS,
      cpu_jtag_debug_module_readdata_from_sa => cpu_jtag_debug_module_readdata_from_sa,
      d1_cpu_jtag_debug_module_end_xfer => d1_cpu_jtag_debug_module_end_xfer,
      d1_epcs_controller_epcs_control_port_end_xfer => d1_epcs_controller_epcs_control_port_end_xfer,
      d1_ext_bus_avalon_slave_end_xfer => d1_ext_bus_avalon_slave_end_xfer,
      d1_sdram_s1_end_xfer => d1_sdram_s1_end_xfer,
      d1_seven_seg_avalonS_end_xfer => d1_seven_seg_avalonS_end_xfer,
      d1_sram_avalonS_end_xfer => d1_sram_avalonS_end_xfer,
      epcs_controller_epcs_control_port_readdata_from_sa => epcs_controller_epcs_control_port_readdata_from_sa,
      flash_s1_wait_counter_eq_0 => flash_s1_wait_counter_eq_0,
      flash_s1_wait_counter_eq_1 => flash_s1_wait_counter_eq_1,
      incoming_ext_bus_data => incoming_ext_bus_data,
      reset_n => clk_reset_n,
      sdram_s1_posted_fifo_readenable => sdram_s1_posted_fifo_readenable,
      sdram_s1_posted_fifo_writenable => sdram_s1_posted_fifo_writenable,
      sdram_s1_readdata_from_sa => sdram_s1_readdata_from_sa,
      sdram_s1_waitrequest_from_sa => sdram_s1_waitrequest_from_sa,
      sram_avalonS_readdata_from_sa => sram_avalonS_readdata_from_sa,
      sram_avalonS_wait_counter_eq_0 => sram_avalonS_wait_counter_eq_0
    );


  --the_cpu, which is an e_ptf_instance
  the_cpu : cpu
    port map(
      d_address => cpu_data_master_address,
      d_byteenable => cpu_data_master_byteenable,
      d_read => cpu_data_master_read,
      d_write => cpu_data_master_write,
      d_writedata => cpu_data_master_writedata,
      i_address => cpu_instruction_master_address,
      i_read => cpu_instruction_master_read,
      jtag_debug_module_debugaccess_to_roms => cpu_data_master_debugaccess,
      jtag_debug_module_readdata => cpu_jtag_debug_module_readdata,
      jtag_debug_module_resetrequest => cpu_jtag_debug_module_resetrequest,
      clk => clk,
      d_irq => cpu_data_master_irq,
      d_readdata => cpu_data_master_readdata,
      d_waitrequest => cpu_data_master_waitrequest,
      i_readdata => cpu_instruction_master_readdata,
      i_readdatavalid => cpu_instruction_master_readdatavalid,
      i_waitrequest => cpu_instruction_master_waitrequest,
      jtag_debug_module_address => cpu_jtag_debug_module_address,
      jtag_debug_module_begintransfer => cpu_jtag_debug_module_begintransfer,
      jtag_debug_module_byteenable => cpu_jtag_debug_module_byteenable,
      jtag_debug_module_clk => clk,
      jtag_debug_module_debugaccess => cpu_jtag_debug_module_debugaccess,
      jtag_debug_module_reset => cpu_jtag_debug_module_reset,
      jtag_debug_module_select => cpu_jtag_debug_module_chipselect,
      jtag_debug_module_write => cpu_jtag_debug_module_write,
      jtag_debug_module_writedata => cpu_jtag_debug_module_writedata,
      reset_n => cpu_jtag_debug_module_reset_n
    );


  --the_epcs_controller_epcs_control_port, which is an e_instance
  the_epcs_controller_epcs_control_port : epcs_controller_epcs_control_port_arbitrator
    port map(
      cpu_data_master_granted_epcs_controller_epcs_control_port => cpu_data_master_granted_epcs_controller_epcs_control_port,
      cpu_data_master_qualified_request_epcs_controller_epcs_control_port => cpu_data_master_qualified_request_epcs_controller_epcs_control_port,
      cpu_data_master_read_data_valid_epcs_controller_epcs_control_port => cpu_data_master_read_data_valid_epcs_controller_epcs_control_port,
      cpu_data_master_requests_epcs_controller_epcs_control_port => cpu_data_master_requests_epcs_controller_epcs_control_port,
      cpu_instruction_master_granted_epcs_controller_epcs_control_port => cpu_instruction_master_granted_epcs_controller_epcs_control_port,
      cpu_instruction_master_qualified_request_epcs_controller_epcs_control_port => cpu_instruction_master_qualified_request_epcs_controller_epcs_control_port,
      cpu_instruction_master_read_data_valid_epcs_controller_epcs_control_port => cpu_instruction_master_read_data_valid_epcs_controller_epcs_control_port,
      cpu_instruction_master_requests_epcs_controller_epcs_control_port => cpu_instruction_master_requests_epcs_controller_epcs_control_port,
      d1_epcs_controller_epcs_control_port_end_xfer => d1_epcs_controller_epcs_control_port_end_xfer,
      epcs_controller_epcs_control_port_address => epcs_controller_epcs_control_port_address,
      epcs_controller_epcs_control_port_chipselect => epcs_controller_epcs_control_port_chipselect,
      epcs_controller_epcs_control_port_dataavailable_from_sa => epcs_controller_epcs_control_port_dataavailable_from_sa,
      epcs_controller_epcs_control_port_endofpacket_from_sa => epcs_controller_epcs_control_port_endofpacket_from_sa,
      epcs_controller_epcs_control_port_irq_from_sa => epcs_controller_epcs_control_port_irq_from_sa,
      epcs_controller_epcs_control_port_read_n => epcs_controller_epcs_control_port_read_n,
      epcs_controller_epcs_control_port_readdata_from_sa => epcs_controller_epcs_control_port_readdata_from_sa,
      epcs_controller_epcs_control_port_readyfordata_from_sa => epcs_controller_epcs_control_port_readyfordata_from_sa,
      epcs_controller_epcs_control_port_reset_n => epcs_controller_epcs_control_port_reset_n,
      epcs_controller_epcs_control_port_write_n => epcs_controller_epcs_control_port_write_n,
      epcs_controller_epcs_control_port_writedata => epcs_controller_epcs_control_port_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      cpu_instruction_master_address_to_slave => cpu_instruction_master_address_to_slave,
      cpu_instruction_master_latency_counter => cpu_instruction_master_latency_counter,
      cpu_instruction_master_read => cpu_instruction_master_read,
      cpu_instruction_master_read_data_valid_sdram_s1_shift_register => cpu_instruction_master_read_data_valid_sdram_s1_shift_register,
      epcs_controller_epcs_control_port_dataavailable => epcs_controller_epcs_control_port_dataavailable,
      epcs_controller_epcs_control_port_endofpacket => epcs_controller_epcs_control_port_endofpacket,
      epcs_controller_epcs_control_port_irq => epcs_controller_epcs_control_port_irq,
      epcs_controller_epcs_control_port_readdata => epcs_controller_epcs_control_port_readdata,
      epcs_controller_epcs_control_port_readyfordata => epcs_controller_epcs_control_port_readyfordata,
      reset_n => clk_reset_n
    );


  --the_epcs_controller, which is an e_ptf_instance
  the_epcs_controller : epcs_controller
    port map(
      dataavailable => epcs_controller_epcs_control_port_dataavailable,
      endofpacket => epcs_controller_epcs_control_port_endofpacket,
      irq => epcs_controller_epcs_control_port_irq,
      readdata => epcs_controller_epcs_control_port_readdata,
      readyfordata => epcs_controller_epcs_control_port_readyfordata,
      address => epcs_controller_epcs_control_port_address,
      chipselect => epcs_controller_epcs_control_port_chipselect,
      clk => clk,
      read_n => epcs_controller_epcs_control_port_read_n,
      reset_n => epcs_controller_epcs_control_port_reset_n,
      write_n => epcs_controller_epcs_control_port_write_n,
      writedata => epcs_controller_epcs_control_port_writedata
    );


  --the_ext_bus_avalon_slave, which is an e_instance
  the_ext_bus_avalon_slave : ext_bus_avalon_slave_arbitrator
    port map(
      cpu_data_master_byteenable_flash_s1 => cpu_data_master_byteenable_flash_s1,
      cpu_data_master_granted_flash_s1 => cpu_data_master_granted_flash_s1,
      cpu_data_master_qualified_request_flash_s1 => cpu_data_master_qualified_request_flash_s1,
      cpu_data_master_read_data_valid_flash_s1 => cpu_data_master_read_data_valid_flash_s1,
      cpu_data_master_requests_flash_s1 => cpu_data_master_requests_flash_s1,
      cpu_instruction_master_granted_flash_s1 => cpu_instruction_master_granted_flash_s1,
      cpu_instruction_master_qualified_request_flash_s1 => cpu_instruction_master_qualified_request_flash_s1,
      cpu_instruction_master_read_data_valid_flash_s1 => cpu_instruction_master_read_data_valid_flash_s1,
      cpu_instruction_master_requests_flash_s1 => cpu_instruction_master_requests_flash_s1,
      d1_ext_bus_avalon_slave_end_xfer => d1_ext_bus_avalon_slave_end_xfer,
      ext_bus_address => internal_ext_bus_address,
      ext_bus_data => ext_bus_data,
      ext_bus_readn => internal_ext_bus_readn,
      flash_s1_wait_counter_eq_0 => flash_s1_wait_counter_eq_0,
      flash_s1_wait_counter_eq_1 => flash_s1_wait_counter_eq_1,
      incoming_ext_bus_data => incoming_ext_bus_data,
      incoming_ext_bus_data_with_Xs_converted_to_0 => incoming_ext_bus_data_with_Xs_converted_to_0,
      registered_cpu_data_master_read_data_valid_flash_s1 => registered_cpu_data_master_read_data_valid_flash_s1,
      select_n_to_the_flash => internal_select_n_to_the_flash,
      write_n_to_the_flash => internal_write_n_to_the_flash,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_dbs_address => cpu_data_master_dbs_address,
      cpu_data_master_dbs_write_8 => cpu_data_master_dbs_write_8,
      cpu_data_master_no_byte_enables_and_last_term => cpu_data_master_no_byte_enables_and_last_term,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_instruction_master_address_to_slave => cpu_instruction_master_address_to_slave,
      cpu_instruction_master_dbs_address => cpu_instruction_master_dbs_address,
      cpu_instruction_master_latency_counter => cpu_instruction_master_latency_counter,
      cpu_instruction_master_read => cpu_instruction_master_read,
      cpu_instruction_master_read_data_valid_sdram_s1_shift_register => cpu_instruction_master_read_data_valid_sdram_s1_shift_register,
      reset_n => clk_reset_n
    );


  --the_jtag_avalon_jtag_slave, which is an e_instance
  the_jtag_avalon_jtag_slave : jtag_avalon_jtag_slave_arbitrator
    port map(
      cpu_data_master_granted_jtag_avalon_jtag_slave => cpu_data_master_granted_jtag_avalon_jtag_slave,
      cpu_data_master_qualified_request_jtag_avalon_jtag_slave => cpu_data_master_qualified_request_jtag_avalon_jtag_slave,
      cpu_data_master_read_data_valid_jtag_avalon_jtag_slave => cpu_data_master_read_data_valid_jtag_avalon_jtag_slave,
      cpu_data_master_requests_jtag_avalon_jtag_slave => cpu_data_master_requests_jtag_avalon_jtag_slave,
      d1_jtag_avalon_jtag_slave_end_xfer => d1_jtag_avalon_jtag_slave_end_xfer,
      jtag_avalon_jtag_slave_address => jtag_avalon_jtag_slave_address,
      jtag_avalon_jtag_slave_chipselect => jtag_avalon_jtag_slave_chipselect,
      jtag_avalon_jtag_slave_dataavailable_from_sa => jtag_avalon_jtag_slave_dataavailable_from_sa,
      jtag_avalon_jtag_slave_irq_from_sa => jtag_avalon_jtag_slave_irq_from_sa,
      jtag_avalon_jtag_slave_read_n => jtag_avalon_jtag_slave_read_n,
      jtag_avalon_jtag_slave_readdata_from_sa => jtag_avalon_jtag_slave_readdata_from_sa,
      jtag_avalon_jtag_slave_readyfordata_from_sa => jtag_avalon_jtag_slave_readyfordata_from_sa,
      jtag_avalon_jtag_slave_reset_n => jtag_avalon_jtag_slave_reset_n,
      jtag_avalon_jtag_slave_waitrequest_from_sa => jtag_avalon_jtag_slave_waitrequest_from_sa,
      jtag_avalon_jtag_slave_write_n => jtag_avalon_jtag_slave_write_n,
      jtag_avalon_jtag_slave_writedata => jtag_avalon_jtag_slave_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      jtag_avalon_jtag_slave_dataavailable => jtag_avalon_jtag_slave_dataavailable,
      jtag_avalon_jtag_slave_irq => jtag_avalon_jtag_slave_irq,
      jtag_avalon_jtag_slave_readdata => jtag_avalon_jtag_slave_readdata,
      jtag_avalon_jtag_slave_readyfordata => jtag_avalon_jtag_slave_readyfordata,
      jtag_avalon_jtag_slave_waitrequest => jtag_avalon_jtag_slave_waitrequest,
      reset_n => clk_reset_n
    );


  --the_jtag, which is an e_ptf_instance
  the_jtag : jtag
    port map(
      av_irq => jtag_avalon_jtag_slave_irq,
      av_readdata => jtag_avalon_jtag_slave_readdata,
      av_waitrequest => jtag_avalon_jtag_slave_waitrequest,
      dataavailable => jtag_avalon_jtag_slave_dataavailable,
      readyfordata => jtag_avalon_jtag_slave_readyfordata,
      av_address => jtag_avalon_jtag_slave_address,
      av_chipselect => jtag_avalon_jtag_slave_chipselect,
      av_read_n => jtag_avalon_jtag_slave_read_n,
      av_write_n => jtag_avalon_jtag_slave_write_n,
      av_writedata => jtag_avalon_jtag_slave_writedata,
      clk => clk,
      rst_n => jtag_avalon_jtag_slave_reset_n
    );


  --the_lcd_control_slave, which is an e_instance
  the_lcd_control_slave : lcd_control_slave_arbitrator
    port map(
      cpu_data_master_granted_lcd_control_slave => cpu_data_master_granted_lcd_control_slave,
      cpu_data_master_qualified_request_lcd_control_slave => cpu_data_master_qualified_request_lcd_control_slave,
      cpu_data_master_read_data_valid_lcd_control_slave => cpu_data_master_read_data_valid_lcd_control_slave,
      cpu_data_master_requests_lcd_control_slave => cpu_data_master_requests_lcd_control_slave,
      d1_lcd_control_slave_end_xfer => d1_lcd_control_slave_end_xfer,
      lcd_control_slave_address => lcd_control_slave_address,
      lcd_control_slave_begintransfer => lcd_control_slave_begintransfer,
      lcd_control_slave_read => lcd_control_slave_read,
      lcd_control_slave_readdata_from_sa => lcd_control_slave_readdata_from_sa,
      lcd_control_slave_wait_counter_eq_0 => lcd_control_slave_wait_counter_eq_0,
      lcd_control_slave_wait_counter_eq_1 => lcd_control_slave_wait_counter_eq_1,
      lcd_control_slave_write => lcd_control_slave_write,
      lcd_control_slave_writedata => lcd_control_slave_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      lcd_control_slave_readdata => lcd_control_slave_readdata,
      reset_n => clk_reset_n
    );


  --the_lcd, which is an e_ptf_instance
  the_lcd : lcd
    port map(
      LCD_E => internal_LCD_E_from_the_lcd,
      LCD_RS => internal_LCD_RS_from_the_lcd,
      LCD_RW => internal_LCD_RW_from_the_lcd,
      LCD_data => LCD_data_to_and_from_the_lcd,
      irq => lcd_control_slave_irq,
      readdata => lcd_control_slave_readdata,
      address => lcd_control_slave_address,
      begintransfer => lcd_control_slave_begintransfer,
      read => lcd_control_slave_read,
      write => lcd_control_slave_write,
      writedata => lcd_control_slave_writedata
    );


  --the_led_green_s1, which is an e_instance
  the_led_green_s1 : led_green_s1_arbitrator
    port map(
      cpu_data_master_granted_led_green_s1 => cpu_data_master_granted_led_green_s1,
      cpu_data_master_qualified_request_led_green_s1 => cpu_data_master_qualified_request_led_green_s1,
      cpu_data_master_read_data_valid_led_green_s1 => cpu_data_master_read_data_valid_led_green_s1,
      cpu_data_master_requests_led_green_s1 => cpu_data_master_requests_led_green_s1,
      d1_led_green_s1_end_xfer => d1_led_green_s1_end_xfer,
      led_green_s1_address => led_green_s1_address,
      led_green_s1_chipselect => led_green_s1_chipselect,
      led_green_s1_reset_n => led_green_s1_reset_n,
      led_green_s1_write_n => led_green_s1_write_n,
      led_green_s1_writedata => led_green_s1_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_led_green, which is an e_ptf_instance
  the_led_green : led_green
    port map(
      out_port => internal_out_port_from_the_led_green,
      address => led_green_s1_address,
      chipselect => led_green_s1_chipselect,
      clk => clk,
      reset_n => led_green_s1_reset_n,
      write_n => led_green_s1_write_n,
      writedata => led_green_s1_writedata
    );


  --the_led_red_s1, which is an e_instance
  the_led_red_s1 : led_red_s1_arbitrator
    port map(
      cpu_data_master_granted_led_red_s1 => cpu_data_master_granted_led_red_s1,
      cpu_data_master_qualified_request_led_red_s1 => cpu_data_master_qualified_request_led_red_s1,
      cpu_data_master_read_data_valid_led_red_s1 => cpu_data_master_read_data_valid_led_red_s1,
      cpu_data_master_requests_led_red_s1 => cpu_data_master_requests_led_red_s1,
      d1_led_red_s1_end_xfer => d1_led_red_s1_end_xfer,
      led_red_s1_address => led_red_s1_address,
      led_red_s1_chipselect => led_red_s1_chipselect,
      led_red_s1_reset_n => led_red_s1_reset_n,
      led_red_s1_write_n => led_red_s1_write_n,
      led_red_s1_writedata => led_red_s1_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_led_red, which is an e_ptf_instance
  the_led_red : led_red
    port map(
      out_port => internal_out_port_from_the_led_red,
      address => led_red_s1_address,
      chipselect => led_red_s1_chipselect,
      clk => clk,
      reset_n => led_red_s1_reset_n,
      write_n => led_red_s1_write_n,
      writedata => led_red_s1_writedata
    );


  --the_sdram_s1, which is an e_instance
  the_sdram_s1 : sdram_s1_arbitrator
    port map(
      cpu_data_master_byteenable_sdram_s1 => cpu_data_master_byteenable_sdram_s1,
      cpu_data_master_granted_sdram_s1 => cpu_data_master_granted_sdram_s1,
      cpu_data_master_qualified_request_sdram_s1 => cpu_data_master_qualified_request_sdram_s1,
      cpu_data_master_read_data_valid_sdram_s1 => cpu_data_master_read_data_valid_sdram_s1,
      cpu_data_master_read_data_valid_sdram_s1_shift_register => cpu_data_master_read_data_valid_sdram_s1_shift_register,
      cpu_data_master_requests_sdram_s1 => cpu_data_master_requests_sdram_s1,
      cpu_instruction_master_granted_sdram_s1 => cpu_instruction_master_granted_sdram_s1,
      cpu_instruction_master_qualified_request_sdram_s1 => cpu_instruction_master_qualified_request_sdram_s1,
      cpu_instruction_master_read_data_valid_sdram_s1 => cpu_instruction_master_read_data_valid_sdram_s1,
      cpu_instruction_master_read_data_valid_sdram_s1_shift_register => cpu_instruction_master_read_data_valid_sdram_s1_shift_register,
      cpu_instruction_master_requests_sdram_s1 => cpu_instruction_master_requests_sdram_s1,
      d1_sdram_s1_end_xfer => d1_sdram_s1_end_xfer,
      sdram_s1_address => sdram_s1_address,
      sdram_s1_byteenable_n => sdram_s1_byteenable_n,
      sdram_s1_chipselect => sdram_s1_chipselect,
      sdram_s1_posted_fifo_readenable => sdram_s1_posted_fifo_readenable,
      sdram_s1_posted_fifo_writenable => sdram_s1_posted_fifo_writenable,
      sdram_s1_read_n => sdram_s1_read_n,
      sdram_s1_readdata_from_sa => sdram_s1_readdata_from_sa,
      sdram_s1_reset_n => sdram_s1_reset_n,
      sdram_s1_waitrequest_from_sa => sdram_s1_waitrequest_from_sa,
      sdram_s1_write_n => sdram_s1_write_n,
      sdram_s1_writedata => sdram_s1_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_dbs_address => cpu_data_master_dbs_address,
      cpu_data_master_dbs_write_16 => cpu_data_master_dbs_write_16,
      cpu_data_master_no_byte_enables_and_last_term => cpu_data_master_no_byte_enables_and_last_term,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_instruction_master_address_to_slave => cpu_instruction_master_address_to_slave,
      cpu_instruction_master_dbs_address => cpu_instruction_master_dbs_address,
      cpu_instruction_master_latency_counter => cpu_instruction_master_latency_counter,
      cpu_instruction_master_read => cpu_instruction_master_read,
      reset_n => clk_reset_n,
      sdram_s1_readdata => sdram_s1_readdata,
      sdram_s1_readdatavalid => sdram_s1_readdatavalid,
      sdram_s1_waitrequest => sdram_s1_waitrequest
    );


  --the_sdram, which is an e_ptf_instance
  the_sdram : sdram
    port map(
      za_data => sdram_s1_readdata,
      za_valid => sdram_s1_readdatavalid,
      za_waitrequest => sdram_s1_waitrequest,
      zs_addr => internal_zs_addr_from_the_sdram,
      zs_ba => internal_zs_ba_from_the_sdram,
      zs_cas_n => internal_zs_cas_n_from_the_sdram,
      zs_cke => internal_zs_cke_from_the_sdram,
      zs_cs_n => internal_zs_cs_n_from_the_sdram,
      zs_dq => zs_dq_to_and_from_the_sdram,
      zs_dqm => internal_zs_dqm_from_the_sdram,
      zs_ras_n => internal_zs_ras_n_from_the_sdram,
      zs_we_n => internal_zs_we_n_from_the_sdram,
      az_addr => sdram_s1_address,
      az_be_n => sdram_s1_byteenable_n,
      az_cs => sdram_s1_chipselect,
      az_data => sdram_s1_writedata,
      az_rd_n => sdram_s1_read_n,
      az_wr_n => sdram_s1_write_n,
      clk => clk,
      reset_n => sdram_s1_reset_n
    );


  --the_seven_seg_avalonS, which is an e_instance
  the_seven_seg_avalonS : seven_seg_avalonS_arbitrator
    port map(
      cpu_data_master_granted_seven_seg_avalonS => cpu_data_master_granted_seven_seg_avalonS,
      cpu_data_master_qualified_request_seven_seg_avalonS => cpu_data_master_qualified_request_seven_seg_avalonS,
      cpu_data_master_read_data_valid_seven_seg_avalonS => cpu_data_master_read_data_valid_seven_seg_avalonS,
      cpu_data_master_requests_seven_seg_avalonS => cpu_data_master_requests_seven_seg_avalonS,
      cpu_instruction_master_granted_seven_seg_avalonS => cpu_instruction_master_granted_seven_seg_avalonS,
      cpu_instruction_master_qualified_request_seven_seg_avalonS => cpu_instruction_master_qualified_request_seven_seg_avalonS,
      cpu_instruction_master_read_data_valid_seven_seg_avalonS => cpu_instruction_master_read_data_valid_seven_seg_avalonS,
      cpu_instruction_master_requests_seven_seg_avalonS => cpu_instruction_master_requests_seven_seg_avalonS,
      d1_seven_seg_avalonS_end_xfer => d1_seven_seg_avalonS_end_xfer,
      seven_seg_avalonS_reset_n => seven_seg_avalonS_reset_n,
      seven_seg_avalonS_write => seven_seg_avalonS_write,
      seven_seg_avalonS_writedata => seven_seg_avalonS_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      cpu_instruction_master_address_to_slave => cpu_instruction_master_address_to_slave,
      cpu_instruction_master_latency_counter => cpu_instruction_master_latency_counter,
      cpu_instruction_master_read => cpu_instruction_master_read,
      reset_n => clk_reset_n
    );


  --the_seven_seg, which is an e_ptf_instance
  the_seven_seg : seven_seg
    port map(
      oSEG0 => internal_oSEG0_from_the_seven_seg,
      oSEG1 => internal_oSEG1_from_the_seven_seg,
      oSEG2 => internal_oSEG2_from_the_seven_seg,
      oSEG3 => internal_oSEG3_from_the_seven_seg,
      oSEG4 => internal_oSEG4_from_the_seven_seg,
      oSEG5 => internal_oSEG5_from_the_seven_seg,
      oSEG6 => internal_oSEG6_from_the_seven_seg,
      oSEG7 => internal_oSEG7_from_the_seven_seg,
      iCLK => clk,
      iDIG => seven_seg_avalonS_writedata,
      iRST_N => seven_seg_avalonS_reset_n,
      iWR => seven_seg_avalonS_write
    );


  --the_sram_avalonS, which is an e_instance
  the_sram_avalonS : sram_avalonS_arbitrator
    port map(
      cpu_data_master_byteenable_sram_avalonS => cpu_data_master_byteenable_sram_avalonS,
      cpu_data_master_granted_sram_avalonS => cpu_data_master_granted_sram_avalonS,
      cpu_data_master_qualified_request_sram_avalonS => cpu_data_master_qualified_request_sram_avalonS,
      cpu_data_master_read_data_valid_sram_avalonS => cpu_data_master_read_data_valid_sram_avalonS,
      cpu_data_master_requests_sram_avalonS => cpu_data_master_requests_sram_avalonS,
      cpu_instruction_master_granted_sram_avalonS => cpu_instruction_master_granted_sram_avalonS,
      cpu_instruction_master_qualified_request_sram_avalonS => cpu_instruction_master_qualified_request_sram_avalonS,
      cpu_instruction_master_read_data_valid_sram_avalonS => cpu_instruction_master_read_data_valid_sram_avalonS,
      cpu_instruction_master_requests_sram_avalonS => cpu_instruction_master_requests_sram_avalonS,
      d1_sram_avalonS_end_xfer => d1_sram_avalonS_end_xfer,
      sram_avalonS_address => sram_avalonS_address,
      sram_avalonS_byteenable_n => sram_avalonS_byteenable_n,
      sram_avalonS_chipselect_n => sram_avalonS_chipselect_n,
      sram_avalonS_outputenable_n => sram_avalonS_outputenable_n,
      sram_avalonS_readdata_from_sa => sram_avalonS_readdata_from_sa,
      sram_avalonS_reset_n => sram_avalonS_reset_n,
      sram_avalonS_wait_counter_eq_0 => sram_avalonS_wait_counter_eq_0,
      sram_avalonS_write_n => sram_avalonS_write_n,
      sram_avalonS_writedata => sram_avalonS_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_dbs_address => cpu_data_master_dbs_address,
      cpu_data_master_dbs_write_16 => cpu_data_master_dbs_write_16,
      cpu_data_master_no_byte_enables_and_last_term => cpu_data_master_no_byte_enables_and_last_term,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_instruction_master_address_to_slave => cpu_instruction_master_address_to_slave,
      cpu_instruction_master_dbs_address => cpu_instruction_master_dbs_address,
      cpu_instruction_master_latency_counter => cpu_instruction_master_latency_counter,
      cpu_instruction_master_read => cpu_instruction_master_read,
      cpu_instruction_master_read_data_valid_sdram_s1_shift_register => cpu_instruction_master_read_data_valid_sdram_s1_shift_register,
      reset_n => clk_reset_n,
      sram_avalonS_readdata => sram_avalonS_readdata
    );


  --the_sram, which is an e_ptf_instance
  the_sram : sram
    port map(
      SRAM_ADDR => internal_SRAM_ADDR_from_the_sram,
      SRAM_CE_N => internal_SRAM_CE_N_from_the_sram,
      SRAM_DQ => SRAM_DQ_to_and_from_the_sram,
      SRAM_LB_N => internal_SRAM_LB_N_from_the_sram,
      SRAM_OE_N => internal_SRAM_OE_N_from_the_sram,
      SRAM_UB_N => internal_SRAM_UB_N_from_the_sram,
      SRAM_WE_N => internal_SRAM_WE_N_from_the_sram,
      oDATA => sram_avalonS_readdata,
      iADDR => sram_avalonS_address,
      iCE_N => sram_avalonS_chipselect_n,
      iDATA => sram_avalonS_writedata,
      iLB_N => sram_avalonS_byteenable_n(0),
      iOE_N => sram_avalonS_outputenable_n,
      iRST_N => sram_avalonS_reset_n,
      iUB_N => sram_avalonS_byteenable_n(0),
      iWE_N => sram_avalonS_write_n
    );


  --the_switches_s1, which is an e_instance
  the_switches_s1 : switches_s1_arbitrator
    port map(
      cpu_data_master_granted_switches_s1 => cpu_data_master_granted_switches_s1,
      cpu_data_master_qualified_request_switches_s1 => cpu_data_master_qualified_request_switches_s1,
      cpu_data_master_read_data_valid_switches_s1 => cpu_data_master_read_data_valid_switches_s1,
      cpu_data_master_requests_switches_s1 => cpu_data_master_requests_switches_s1,
      d1_switches_s1_end_xfer => d1_switches_s1_end_xfer,
      switches_s1_address => switches_s1_address,
      switches_s1_readdata_from_sa => switches_s1_readdata_from_sa,
      switches_s1_reset_n => switches_s1_reset_n,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      reset_n => clk_reset_n,
      switches_s1_readdata => switches_s1_readdata
    );


  --the_switches, which is an e_ptf_instance
  the_switches : switches
    port map(
      readdata => switches_s1_readdata,
      address => switches_s1_address,
      clk => clk,
      in_port => in_port_to_the_switches,
      reset_n => switches_s1_reset_n
    );


  --the_timer0_s1, which is an e_instance
  the_timer0_s1 : timer0_s1_arbitrator
    port map(
      cpu_data_master_granted_timer0_s1 => cpu_data_master_granted_timer0_s1,
      cpu_data_master_qualified_request_timer0_s1 => cpu_data_master_qualified_request_timer0_s1,
      cpu_data_master_read_data_valid_timer0_s1 => cpu_data_master_read_data_valid_timer0_s1,
      cpu_data_master_requests_timer0_s1 => cpu_data_master_requests_timer0_s1,
      d1_timer0_s1_end_xfer => d1_timer0_s1_end_xfer,
      timer0_s1_address => timer0_s1_address,
      timer0_s1_chipselect => timer0_s1_chipselect,
      timer0_s1_irq_from_sa => timer0_s1_irq_from_sa,
      timer0_s1_readdata_from_sa => timer0_s1_readdata_from_sa,
      timer0_s1_reset_n => timer0_s1_reset_n,
      timer0_s1_write_n => timer0_s1_write_n,
      timer0_s1_writedata => timer0_s1_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n,
      timer0_s1_irq => timer0_s1_irq,
      timer0_s1_readdata => timer0_s1_readdata
    );


  --the_timer0, which is an e_ptf_instance
  the_timer0 : timer0
    port map(
      irq => timer0_s1_irq,
      readdata => timer0_s1_readdata,
      address => timer0_s1_address,
      chipselect => timer0_s1_chipselect,
      clk => clk,
      reset_n => timer0_s1_reset_n,
      write_n => timer0_s1_write_n,
      writedata => timer0_s1_writedata
    );


  --the_uart_s1, which is an e_instance
  the_uart_s1 : uart_s1_arbitrator
    port map(
      cpu_data_master_granted_uart_s1 => cpu_data_master_granted_uart_s1,
      cpu_data_master_qualified_request_uart_s1 => cpu_data_master_qualified_request_uart_s1,
      cpu_data_master_read_data_valid_uart_s1 => cpu_data_master_read_data_valid_uart_s1,
      cpu_data_master_requests_uart_s1 => cpu_data_master_requests_uart_s1,
      d1_uart_s1_end_xfer => d1_uart_s1_end_xfer,
      uart_s1_address => uart_s1_address,
      uart_s1_begintransfer => uart_s1_begintransfer,
      uart_s1_chipselect => uart_s1_chipselect,
      uart_s1_dataavailable_from_sa => uart_s1_dataavailable_from_sa,
      uart_s1_irq_from_sa => uart_s1_irq_from_sa,
      uart_s1_read_n => uart_s1_read_n,
      uart_s1_readdata_from_sa => uart_s1_readdata_from_sa,
      uart_s1_readyfordata_from_sa => uart_s1_readyfordata_from_sa,
      uart_s1_reset_n => uart_s1_reset_n,
      uart_s1_write_n => uart_s1_write_n,
      uart_s1_writedata => uart_s1_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n,
      uart_s1_dataavailable => uart_s1_dataavailable,
      uart_s1_irq => uart_s1_irq,
      uart_s1_readdata => uart_s1_readdata,
      uart_s1_readyfordata => uart_s1_readyfordata
    );


  --the_uart, which is an e_ptf_instance
  the_uart : uart
    port map(
      dataavailable => uart_s1_dataavailable,
      irq => uart_s1_irq,
      readdata => uart_s1_readdata,
      readyfordata => uart_s1_readyfordata,
      txd => internal_txd_from_the_uart,
      address => uart_s1_address,
      begintransfer => uart_s1_begintransfer,
      chipselect => uart_s1_chipselect,
      clk => clk,
      read_n => uart_s1_read_n,
      reset_n => uart_s1_reset_n,
      rxd => rxd_to_the_uart,
      write_n => uart_s1_write_n,
      writedata => uart_s1_writedata
    );


  --reset is asserted asynchronously and deasserted synchronously
  nios32_reset_clk_domain_synch : nios32_reset_clk_domain_synch_module
    port map(
      data_out => clk_reset_n,
      clk => clk,
      data_in => module_input,
      reset_n => reset_n_sources
    );

  module_input <= std_logic'('1');

  --reset sources mux, which is an e_mux
  reset_n_sources <= Vector_To_Std_Logic(NOT (((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT reset_n))) OR std_logic_vector'("00000000000000000000000000000000")) OR (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_jtag_debug_module_resetrequest_from_sa)))) OR (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_jtag_debug_module_resetrequest_from_sa))))));
  --vhdl renameroo for output signals
  LCD_E_from_the_lcd <= internal_LCD_E_from_the_lcd;
  --vhdl renameroo for output signals
  LCD_RS_from_the_lcd <= internal_LCD_RS_from_the_lcd;
  --vhdl renameroo for output signals
  LCD_RW_from_the_lcd <= internal_LCD_RW_from_the_lcd;
  --vhdl renameroo for output signals
  SRAM_ADDR_from_the_sram <= internal_SRAM_ADDR_from_the_sram;
  --vhdl renameroo for output signals
  SRAM_CE_N_from_the_sram <= internal_SRAM_CE_N_from_the_sram;
  --vhdl renameroo for output signals
  SRAM_LB_N_from_the_sram <= internal_SRAM_LB_N_from_the_sram;
  --vhdl renameroo for output signals
  SRAM_OE_N_from_the_sram <= internal_SRAM_OE_N_from_the_sram;
  --vhdl renameroo for output signals
  SRAM_UB_N_from_the_sram <= internal_SRAM_UB_N_from_the_sram;
  --vhdl renameroo for output signals
  SRAM_WE_N_from_the_sram <= internal_SRAM_WE_N_from_the_sram;
  --vhdl renameroo for output signals
  ext_bus_address <= internal_ext_bus_address;
  --vhdl renameroo for output signals
  ext_bus_readn <= internal_ext_bus_readn;
  --vhdl renameroo for output signals
  oSEG0_from_the_seven_seg <= internal_oSEG0_from_the_seven_seg;
  --vhdl renameroo for output signals
  oSEG1_from_the_seven_seg <= internal_oSEG1_from_the_seven_seg;
  --vhdl renameroo for output signals
  oSEG2_from_the_seven_seg <= internal_oSEG2_from_the_seven_seg;
  --vhdl renameroo for output signals
  oSEG3_from_the_seven_seg <= internal_oSEG3_from_the_seven_seg;
  --vhdl renameroo for output signals
  oSEG4_from_the_seven_seg <= internal_oSEG4_from_the_seven_seg;
  --vhdl renameroo for output signals
  oSEG5_from_the_seven_seg <= internal_oSEG5_from_the_seven_seg;
  --vhdl renameroo for output signals
  oSEG6_from_the_seven_seg <= internal_oSEG6_from_the_seven_seg;
  --vhdl renameroo for output signals
  oSEG7_from_the_seven_seg <= internal_oSEG7_from_the_seven_seg;
  --vhdl renameroo for output signals
  out_port_from_the_led_green <= internal_out_port_from_the_led_green;
  --vhdl renameroo for output signals
  out_port_from_the_led_red <= internal_out_port_from_the_led_red;
  --vhdl renameroo for output signals
  select_n_to_the_flash <= internal_select_n_to_the_flash;
  --vhdl renameroo for output signals
  txd_from_the_uart <= internal_txd_from_the_uart;
  --vhdl renameroo for output signals
  write_n_to_the_flash <= internal_write_n_to_the_flash;
  --vhdl renameroo for output signals
  zs_addr_from_the_sdram <= internal_zs_addr_from_the_sdram;
  --vhdl renameroo for output signals
  zs_ba_from_the_sdram <= internal_zs_ba_from_the_sdram;
  --vhdl renameroo for output signals
  zs_cas_n_from_the_sdram <= internal_zs_cas_n_from_the_sdram;
  --vhdl renameroo for output signals
  zs_cke_from_the_sdram <= internal_zs_cke_from_the_sdram;
  --vhdl renameroo for output signals
  zs_cs_n_from_the_sdram <= internal_zs_cs_n_from_the_sdram;
  --vhdl renameroo for output signals
  zs_dqm_from_the_sdram <= internal_zs_dqm_from_the_sdram;
  --vhdl renameroo for output signals
  zs_ras_n_from_the_sdram <= internal_zs_ras_n_from_the_sdram;
  --vhdl renameroo for output signals
  zs_we_n_from_the_sdram <= internal_zs_we_n_from_the_sdram;

end europa;


--synthesis translate_off

library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity flash_lane0_module is 
        port (
              -- inputs:
                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal rdaddress : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                 signal rdclken : IN STD_LOGIC;
                 signal wraddress : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                 signal wrclock : IN STD_LOGIC;
                 signal wren : IN STD_LOGIC;

              -- outputs:
                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
              );
end entity flash_lane0_module;


architecture europa of flash_lane0_module is
              signal internal_q :  STD_LOGIC_VECTOR (7 DOWNTO 0);
              TYPE mem_array is ARRAY( 1048575 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
              signal memory_has_been_read :  STD_LOGIC;
              signal read_address :  STD_LOGIC_VECTOR (19 DOWNTO 0);

      
FUNCTION convert_string_to_number(string_to_convert : STRING;
      final_char_index : NATURAL := 0)
RETURN NATURAL IS
   VARIABLE result: NATURAL := 0;
   VARIABLE current_index : NATURAL := 1;
   VARIABLE the_char : CHARACTER;

   BEGIN
      IF final_char_index = 0 THEN
         result := 0;
	 ELSE
         WHILE current_index <= final_char_index LOOP
            the_char := string_to_convert(current_index);
            IF    '0' <= the_char AND the_char <= '9' THEN
               result := result * 16 + character'pos(the_char) - character'pos('0');
            ELSIF 'A' <= the_char AND the_char <= 'F' THEN
               result := result * 16 + character'pos(the_char) - character'pos('A') + 10;
            ELSIF 'a' <= the_char AND the_char <= 'f' THEN
               result := result * 16 + character'pos(the_char) - character'pos('a') + 10;
            ELSE
               report "Ack, a formatting error!";
            END IF;
            current_index := current_index + 1;
         END LOOP;
      END IF; 
   RETURN result;
END convert_string_to_number;

 FUNCTION convert_string_to_std_logic(value : STRING; num_chars : INTEGER; mem_width_bits : INTEGER)
 RETURN STD_LOGIC_VECTOR is			   
     VARIABLE conv_string: std_logic_vector((mem_width_bits + 4)-1 downto 0);
     VARIABLE result : std_logic_vector((mem_width_bits -1) downto 0);
     VARIABLE curr_char : integer;
              
     BEGIN
     result := (others => '0');
     conv_string := (others => '0');
     
          FOR I IN 1 TO num_chars LOOP
	     curr_char := num_chars - (I-1);

             CASE value(I) IS
               WHEN '0' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0000";
               WHEN '1' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0001";
               WHEN '2' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0010";
               WHEN '3' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0011";
               WHEN '4' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0100";
               WHEN '5' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0101";
               WHEN '6' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0110";
               WHEN '7' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0111";
               WHEN '8' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1000";
               WHEN '9' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1001";
               WHEN 'A' | 'a' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1010";
               WHEN 'B' | 'b' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1011";
               WHEN 'C' | 'c' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1100";
               WHEN 'D' | 'd' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1101";
               WHEN 'E' | 'e' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1110";
               WHEN 'F' | 'f' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1111";
               WHEN 'X' | 'x' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "XXXX";
               WHEN ' ' => EXIT;
               WHEN HT  => exit;
               WHEN others =>
                  ASSERT False
                  REPORT "function From_Hex: string """ & value & """ contains non-hex character"
                       severity Error;
                  EXIT;
               END case;
            END loop;

          -- convert back to normal bit size
          result(mem_width_bits - 1 downto 0) := conv_string(mem_width_bits - 1 downto 0);

          RETURN result;
        END convert_string_to_std_logic;



begin
   process (wrclock, rdaddress) -- MG
    VARIABLE data_line : LINE;
    VARIABLE the_character_from_data_line : CHARACTER;
    VARIABLE b_munging_address : BOOLEAN := FALSE;
    VARIABLE converted_number : NATURAL := 0;
    VARIABLE found_string_array : STRING(1 TO 128);
    VARIABLE string_index : NATURAL := 0;
    VARIABLE line_length : NATURAL := 0;
    VARIABLE b_convert : BOOLEAN := FALSE;
    VARIABLE b_found_new_val : BOOLEAN := FALSE;
    VARIABLE load_address : NATURAL := 0;
    VARIABLE mem_index : NATURAL := 0;
    VARIABLE mem_init : BOOLEAN := FALSE;

    VARIABLE wr_address_internal : STD_LOGIC_VECTOR (19 DOWNTO 0) := (others => '0');
    FILE memory_contents_file : TEXT OPEN read_mode IS "flash.dat";  
    variable Marc_Gaucherons_Memory_Variable : mem_array; -- MG
    
    begin
   -- need an initialization process
   -- this process initializes the whole memory array from a named file by copying the
   -- contents of the *.dat file to the memory array.

   -- find the @<address> thingy to load the memory from this point 
IF(NOT mem_init) THEN
   WHILE NOT(endfile(memory_contents_file)) LOOP

      readline(memory_contents_file, data_line);
      line_length := data_line'LENGTH;


      WHILE line_length > 0 LOOP
         read(data_line, the_character_from_data_line);

	       -- check for the @ character indicating a new address wad
 	       -- if not found, we're either still reading the new address _or_loading data
         IF '@' = the_character_from_data_line AND NOT b_munging_address THEN
  	    b_munging_address := TRUE;
            b_found_new_val := TRUE; 
	    -- get the rest of characters before white space and then convert them
	    -- to a number
	 ELSE 

            IF (' ' = the_character_from_data_line AND b_found_new_val) 
		OR (line_length = 1) THEN
               b_convert := TRUE;
	    END IF;

            IF NOT(' ' = the_character_from_data_line) THEN
               string_index := string_index + 1;
               found_string_array(string_index) := the_character_from_data_line;
--               IF NOT(b_munging_address) THEN
--                 dat_string_array(string_index) := the_character_from_data_line;
--               END IF;
	       b_found_new_val := TRUE;
            END IF;
	 END IF;

     IF b_convert THEN

       IF b_munging_address THEN
          converted_number := convert_string_to_number(found_string_array, string_index);    
          load_address := converted_number;
          mem_index := load_address;
--          mem_index := load_address / 1;
          b_munging_address := FALSE;
       ELSE
	  IF (mem_index < 1048576) THEN
	    Marc_Gaucherons_Memory_Variable(mem_index) := convert_string_to_std_logic(found_string_array, string_index, 8);
            mem_index := mem_index + 1;
          END IF;
       END IF; 
       b_convert := FALSE;
       b_found_new_val := FALSE;
       string_index := 0;
    END IF;
    line_length := line_length - 1; 
    END LOOP;

END LOOP;
-- get the first _real_ block of data, sized to our memory width
-- and keep on loading.
  mem_init := TRUE;
END IF;
-- END OF READMEM



      -- Write data
      if wrclock'event and wrclock = '1' then
        wr_address_internal := wraddress;
        if wren = '1' then 
          Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(wr_address_internal))) := data;
        end if;
      end if;

      -- read data
      q <= Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(rdaddress)));
      


    end process;
end europa;

--synthesis translate_on


--synthesis read_comments_as_HDL on
--library altera_vhdl_support;
--use altera_vhdl_support.altera_vhdl_support_lib.all;
--
--library ieee;
--use ieee.std_logic_1164.all;
--use ieee.std_logic_arith.all;
--use ieee.std_logic_unsigned.all;
--
--library std;
--use std.textio.all;
--
--entity flash_lane0_module is 
--        port (
--              
--                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--                 signal rdaddress : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
--                 signal rdclken : IN STD_LOGIC;
--                 signal wraddress : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
--                 signal wrclock : IN STD_LOGIC;
--                 signal wren : IN STD_LOGIC;
--
--              
--                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
--              );
--end entity flash_lane0_module;
--
--
--architecture europa of flash_lane0_module is
--  component lpm_ram_dp is
--GENERIC (
--      lpm_file : STRING;
--        lpm_hint : STRING;
--        lpm_indata : STRING;
--        lpm_outdata : STRING;
--        lpm_rdaddress_control : STRING;
--        lpm_width : NATURAL;
--        lpm_widthad : NATURAL;
--        lpm_wraddress_control : STRING;
--        suppress_memory_conversion_warnings : STRING
--      );
--    PORT (
--    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal wraddress : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
--        signal wrclock : IN STD_LOGIC;
--        signal rdaddress : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
--        signal rdclken : IN STD_LOGIC;
--        signal wren : IN STD_LOGIC
--      );
--  end component lpm_ram_dp;
--                signal internal_q :  STD_LOGIC_VECTOR (7 DOWNTO 0);
--                TYPE mem_array is ARRAY( 1048575 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
--                signal memory_has_been_read :  STD_LOGIC;
--                signal read_address :  STD_LOGIC_VECTOR (19 DOWNTO 0);
--
--begin
--
--  process (rdaddress)
--  begin
--      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
--        read_address <= rdaddress;
--      end if;
--
--  end process;
--
--  lpm_ram_dp_component : lpm_ram_dp
--    generic map(
--      lpm_file => "flash.mif",
--      lpm_hint => "USE_EAB=ON",
--      lpm_indata => "REGISTERED",
--      lpm_outdata => "UNREGISTERED",
--      lpm_rdaddress_control => "UNREGISTERED",
--      lpm_width => 8,
--      lpm_widthad => 20,
--      lpm_wraddress_control => "REGISTERED",
--      suppress_memory_conversion_warnings => "ON"
--    )
--    port map(
--            data => data,
--            q => internal_q,
--            rdaddress => read_address,
--            rdclken => rdclken,
--            wraddress => wraddress,
--            wrclock => wrclock,
--            wren => wren
--    );
--
--  
--  q <= internal_q;
--end europa;
--
--synthesis read_comments_as_HDL off

library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity flash is 
        port (
              -- inputs:
                 signal address : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                 signal read_n : IN STD_LOGIC;
                 signal select_n : IN STD_LOGIC;
                 signal write_n : IN STD_LOGIC;

              -- outputs:
                 signal data : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0)
              );
end entity flash;


architecture europa of flash is
--synthesis translate_off
component flash_lane0_module is 
           port (
                 -- inputs:
                    signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal rdaddress : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                    signal rdclken : IN STD_LOGIC;
                    signal wraddress : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                    signal wrclock : IN STD_LOGIC;
                    signal wren : IN STD_LOGIC;

                 -- outputs:
                    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component flash_lane0_module;

--synthesis translate_on
                signal data_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal logic_vector_gasket :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal module_input1 :  STD_LOGIC;
                signal module_input2 :  STD_LOGIC;
                signal q_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);

begin

  --s1, which is an e_ptf_slave
--synthesis translate_off
    logic_vector_gasket <= data;
    data_0 <= logic_vector_gasket(7 DOWNTO 0);
    --flash_lane0, which is an e_ram
    flash_lane0 : flash_lane0_module
      port map(
        q => q_0,
        data => data_0,
        rdaddress => address,
        rdclken => module_input1,
        wraddress => address,
        wrclock => write_n,
        wren => module_input2
      );

    module_input1 <= std_logic'('1');
    module_input2 <= NOT select_n;

    data <= A_WE_StdLogicVector((std_logic'(((NOT select_n AND NOT read_n))) = '1'), q_0, A_REP(std_logic'('Z'), 8));
--synthesis translate_on

end europa;


--synthesis translate_off

library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;



-- <ALTERA_NOTE> CODE INSERTED BETWEEN HERE
--add your libraries here
-- AND HERE WILL BE PRESERVED </ALTERA_NOTE>

entity test_bench is 
end entity test_bench;


architecture europa of test_bench is
component nios32 is 
           port (
                 -- 1) global signals:
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- the_buttons
                    signal in_port_to_the_buttons : IN STD_LOGIC_VECTOR (3 DOWNTO 0);

                 -- the_ext_bus_avalon_slave
                    signal ext_bus_address : OUT STD_LOGIC_VECTOR (19 DOWNTO 0);
                    signal ext_bus_data : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal ext_bus_readn : OUT STD_LOGIC;
                    signal select_n_to_the_flash : OUT STD_LOGIC;
                    signal write_n_to_the_flash : OUT STD_LOGIC;

                 -- the_lcd
                    signal LCD_E_from_the_lcd : OUT STD_LOGIC;
                    signal LCD_RS_from_the_lcd : OUT STD_LOGIC;
                    signal LCD_RW_from_the_lcd : OUT STD_LOGIC;
                    signal LCD_data_to_and_from_the_lcd : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0);

                 -- the_led_green
                    signal out_port_from_the_led_green : OUT STD_LOGIC_VECTOR (8 DOWNTO 0);

                 -- the_led_red
                    signal out_port_from_the_led_red : OUT STD_LOGIC_VECTOR (17 DOWNTO 0);

                 -- the_sdram
                    signal zs_addr_from_the_sdram : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal zs_ba_from_the_sdram : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal zs_cas_n_from_the_sdram : OUT STD_LOGIC;
                    signal zs_cke_from_the_sdram : OUT STD_LOGIC;
                    signal zs_cs_n_from_the_sdram : OUT STD_LOGIC;
                    signal zs_dq_to_and_from_the_sdram : INOUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal zs_dqm_from_the_sdram : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal zs_ras_n_from_the_sdram : OUT STD_LOGIC;
                    signal zs_we_n_from_the_sdram : OUT STD_LOGIC;

                 -- the_seven_seg
                    signal oSEG0_from_the_seven_seg : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal oSEG1_from_the_seven_seg : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal oSEG2_from_the_seven_seg : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal oSEG3_from_the_seven_seg : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal oSEG4_from_the_seven_seg : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal oSEG5_from_the_seven_seg : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal oSEG6_from_the_seven_seg : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal oSEG7_from_the_seven_seg : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);

                 -- the_sram
                    signal SRAM_ADDR_from_the_sram : OUT STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal SRAM_CE_N_from_the_sram : OUT STD_LOGIC;
                    signal SRAM_DQ_to_and_from_the_sram : INOUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal SRAM_LB_N_from_the_sram : OUT STD_LOGIC;
                    signal SRAM_OE_N_from_the_sram : OUT STD_LOGIC;
                    signal SRAM_UB_N_from_the_sram : OUT STD_LOGIC;
                    signal SRAM_WE_N_from_the_sram : OUT STD_LOGIC;

                 -- the_switches
                    signal in_port_to_the_switches : IN STD_LOGIC_VECTOR (17 DOWNTO 0);

                 -- the_uart
                    signal rxd_to_the_uart : IN STD_LOGIC;
                    signal txd_from_the_uart : OUT STD_LOGIC
                 );
end component nios32;

component flash is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                    signal read_n : IN STD_LOGIC;
                    signal select_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;

                 -- outputs:
                    signal data : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component flash;

                signal LCD_E_from_the_lcd :  STD_LOGIC;
                signal LCD_RS_from_the_lcd :  STD_LOGIC;
                signal LCD_RW_from_the_lcd :  STD_LOGIC;
                signal LCD_data_to_and_from_the_lcd :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal SRAM_ADDR_from_the_sram :  STD_LOGIC_VECTOR (17 DOWNTO 0);
                signal SRAM_CE_N_from_the_sram :  STD_LOGIC;
                signal SRAM_DQ_to_and_from_the_sram :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal SRAM_LB_N_from_the_sram :  STD_LOGIC;
                signal SRAM_OE_N_from_the_sram :  STD_LOGIC;
                signal SRAM_UB_N_from_the_sram :  STD_LOGIC;
                signal SRAM_WE_N_from_the_sram :  STD_LOGIC;
                signal clk :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_dataavailable_from_sa :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_endofpacket_from_sa :  STD_LOGIC;
                signal epcs_controller_epcs_control_port_readyfordata_from_sa :  STD_LOGIC;
                signal ext_bus_address :  STD_LOGIC_VECTOR (19 DOWNTO 0);
                signal ext_bus_data :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal ext_bus_readn :  STD_LOGIC;
                signal in_port_to_the_buttons :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal in_port_to_the_switches :  STD_LOGIC_VECTOR (17 DOWNTO 0);
                signal jtag_avalon_jtag_slave_dataavailable_from_sa :  STD_LOGIC;
                signal jtag_avalon_jtag_slave_readyfordata_from_sa :  STD_LOGIC;
                signal lcd_control_slave_irq :  STD_LOGIC;
                signal oSEG0_from_the_seven_seg :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal oSEG1_from_the_seven_seg :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal oSEG2_from_the_seven_seg :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal oSEG3_from_the_seven_seg :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal oSEG4_from_the_seven_seg :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal oSEG5_from_the_seven_seg :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal oSEG6_from_the_seven_seg :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal oSEG7_from_the_seven_seg :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal out_port_from_the_led_green :  STD_LOGIC_VECTOR (8 DOWNTO 0);
                signal out_port_from_the_led_red :  STD_LOGIC_VECTOR (17 DOWNTO 0);
                signal reset_n :  STD_LOGIC;
                signal rxd_to_the_uart :  STD_LOGIC;
                signal select_n_to_the_flash :  STD_LOGIC;
                signal txd_from_the_uart :  STD_LOGIC;
                signal uart_s1_dataavailable_from_sa :  STD_LOGIC;
                signal uart_s1_readyfordata_from_sa :  STD_LOGIC;
                signal write_n_to_the_flash :  STD_LOGIC;
                signal zs_addr_from_the_sdram :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal zs_ba_from_the_sdram :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal zs_cas_n_from_the_sdram :  STD_LOGIC;
                signal zs_cke_from_the_sdram :  STD_LOGIC;
                signal zs_cs_n_from_the_sdram :  STD_LOGIC;
                signal zs_dq_to_and_from_the_sdram :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal zs_dqm_from_the_sdram :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal zs_ras_n_from_the_sdram :  STD_LOGIC;
                signal zs_we_n_from_the_sdram :  STD_LOGIC;


-- <ALTERA_NOTE> CODE INSERTED BETWEEN HERE
--add your component and signal declaration here
-- AND HERE WILL BE PRESERVED </ALTERA_NOTE>


begin

  --Set us up the Dut
  DUT : nios32
    port map(
      LCD_E_from_the_lcd => LCD_E_from_the_lcd,
      LCD_RS_from_the_lcd => LCD_RS_from_the_lcd,
      LCD_RW_from_the_lcd => LCD_RW_from_the_lcd,
      LCD_data_to_and_from_the_lcd => LCD_data_to_and_from_the_lcd,
      SRAM_ADDR_from_the_sram => SRAM_ADDR_from_the_sram,
      SRAM_CE_N_from_the_sram => SRAM_CE_N_from_the_sram,
      SRAM_DQ_to_and_from_the_sram => SRAM_DQ_to_and_from_the_sram,
      SRAM_LB_N_from_the_sram => SRAM_LB_N_from_the_sram,
      SRAM_OE_N_from_the_sram => SRAM_OE_N_from_the_sram,
      SRAM_UB_N_from_the_sram => SRAM_UB_N_from_the_sram,
      SRAM_WE_N_from_the_sram => SRAM_WE_N_from_the_sram,
      ext_bus_address => ext_bus_address,
      ext_bus_data => ext_bus_data,
      ext_bus_readn => ext_bus_readn,
      oSEG0_from_the_seven_seg => oSEG0_from_the_seven_seg,
      oSEG1_from_the_seven_seg => oSEG1_from_the_seven_seg,
      oSEG2_from_the_seven_seg => oSEG2_from_the_seven_seg,
      oSEG3_from_the_seven_seg => oSEG3_from_the_seven_seg,
      oSEG4_from_the_seven_seg => oSEG4_from_the_seven_seg,
      oSEG5_from_the_seven_seg => oSEG5_from_the_seven_seg,
      oSEG6_from_the_seven_seg => oSEG6_from_the_seven_seg,
      oSEG7_from_the_seven_seg => oSEG7_from_the_seven_seg,
      out_port_from_the_led_green => out_port_from_the_led_green,
      out_port_from_the_led_red => out_port_from_the_led_red,
      select_n_to_the_flash => select_n_to_the_flash,
      txd_from_the_uart => txd_from_the_uart,
      write_n_to_the_flash => write_n_to_the_flash,
      zs_addr_from_the_sdram => zs_addr_from_the_sdram,
      zs_ba_from_the_sdram => zs_ba_from_the_sdram,
      zs_cas_n_from_the_sdram => zs_cas_n_from_the_sdram,
      zs_cke_from_the_sdram => zs_cke_from_the_sdram,
      zs_cs_n_from_the_sdram => zs_cs_n_from_the_sdram,
      zs_dq_to_and_from_the_sdram => zs_dq_to_and_from_the_sdram,
      zs_dqm_from_the_sdram => zs_dqm_from_the_sdram,
      zs_ras_n_from_the_sdram => zs_ras_n_from_the_sdram,
      zs_we_n_from_the_sdram => zs_we_n_from_the_sdram,
      clk => clk,
      in_port_to_the_buttons => in_port_to_the_buttons,
      in_port_to_the_switches => in_port_to_the_switches,
      reset_n => reset_n,
      rxd_to_the_uart => rxd_to_the_uart
    );


  --the_flash, which is an e_ptf_instance
  the_flash : flash
    port map(
      data => ext_bus_data,
      address => ext_bus_address,
      read_n => ext_bus_readn,
      select_n => select_n_to_the_flash,
      write_n => write_n_to_the_flash
    );


  process
  begin
    clk <= '0';
    loop
       wait for 10 ns;
       clk <= not clk;
    end loop;
  end process;
  PROCESS
    BEGIN
       reset_n <= '0';
       wait for 200 ns;
       reset_n <= '1'; 
    WAIT;
  END PROCESS;


-- <ALTERA_NOTE> CODE INSERTED BETWEEN HERE
--add additional architecture here
-- AND HERE WILL BE PRESERVED </ALTERA_NOTE>


end europa;



--synthesis translate_on
